#include <PalmOS.h>
#include "events.h"
#include "tape.h"

void Handle_KeyEvent(unsigned long what)
{
/*	int key_status = (event->type==EVENT_KEYPRESS ? KEY_PRESSED : KEY_RELEASED);
	boolean with_modifiers = (game_status == GAME_MODE_PLAYING ? FALSE : TRUE);
	Key key = GetEventKey(event, with_modifiers);
	Key keymod = (with_modifiers ? GetEventKey(event, FALSE) : key);

	HandleKeyModState(keymod, key_status);*/
	Handle_Key(what);
	//was HandleKey(key, key_status);
}

static unsigned long old_what=0;

void Handle_Key(unsigned long what)
{
	/*
	int joy = 0;
	boolean anyTextGadgetActiveOrJustFinished = anyTextGadgetActive();
	static struct SetupKeyboardInfo custom_key;*/
	static struct
	{
//		Key *key_custom;
//		Key key_default;
		unsigned long mask;//for palm only
		byte action;
	} key_info[] =
	{
		{ /*&custom_key.left,  DEFAULT_KEY_LEFT,*/  keyBitHard1,	MV_LEFT      },
		{ /*&custom_key.right, DEFAULT_KEY_RIGHT,*/ keyBitHard2,	MV_RIGHT     },
		{ /*&custom_key.up,    DEFAULT_KEY_UP,*/	keyBitPageUp,	MV_UP        },
		{ /*&custom_key.down,  DEFAULT_KEY_DOWN,*/  keyBitPageDown,	MV_DOWN      },
		{ /*&custom_key.snap,  DEFAULT_KEY_SNAP,*/  keyBitHard3,	KEY_BUTTON_1 },
		{ /*&custom_key.drop,  DEFAULT_KEY_DROP,*/  keyBitHard4,	KEY_BUTTON_2 }
	};

	if (game_status == GAME_MODE_PLAYING)
	{
		// only needed for single-step tape recording mode
/*		static boolean clear_button_2[MAX_PLAYERS] = { FALSE,FALSE,FALSE,FALSE };
		static boolean element_dropped[MAX_PLAYERS] = { FALSE,FALSE,FALSE,FALSE };
		int pnr;

		for (pnr = 0; pnr < MAX_PLAYERS; pnr++)
*/		{
			int i;
			byte key_action = 0;
			byte end_key_action = 0;
			
/*			if (setup.input[pnr].use_joystick)
				continue;

			custom_key = setup.input[pnr].key;
*/
			for (i = 0; i < 6; i++)
				if (what & key_info[i].mask)
					key_action |= key_info[i].action;
				else if (old_what & key_info[i].mask)
					end_key_action |= key_info[i].action;
					
			stored_player_.action |= key_action;
			
			stored_player_.action &= ~end_key_action;
			
/*
			if (tape.single_step && clear_button_2[pnr])
			{
				stored_player[pnr].action &= ~KEY_BUTTON_2;
				clear_button_2[pnr] = FALSE;
			}

			if (tape.single_step && tape.recording && tape.pausing)
			{
				if (key_status == KEY_PRESSED &&
								(key_action & (KEY_MOTION | KEY_BUTTON_1)))
				{
					TapeTogglePause(TAPE_TOGGLE_AUTOMATIC);

					if (key_action & KEY_MOTION)
					{
						if (stored_player[pnr].action & KEY_BUTTON_2)
							element_dropped[pnr] = TRUE;
					}
				}
				else if (key_status == KEY_RELEASED &&
								(key_action & KEY_BUTTON_2))
				{
					if (!element_dropped[pnr])
					{
						TapeTogglePause(TAPE_TOGGLE_AUTOMATIC);

						stored_player[pnr].action |= KEY_BUTTON_2;
						clear_button_2[pnr] = TRUE;
					}

					element_dropped[pnr] = FALSE;
				}
			}
			else */if (tape.recording && tape.pausing && (key_action & KEY_ACTION))
				TapeTogglePause(TAPE_TOGGLE_MANUAL);
		}
	}
/*  else
  {
    int i;

    for (i = 0; i < 6; i++)
      if (key == key_info[i].key_default)
	joy |= key_info[i].action;
  }

  if (joy)
  {
    if (key_status == KEY_PRESSED)
      key_joystick_mapping |= joy;
    else
      key_joystick_mapping &= ~joy;

    HandleJoystick();
  }

  if (game_status != GAME_MODE_PLAYING)
    key_joystick_mapping = 0;

  if (key_status == KEY_RELEASED)
    return;

  if (game_status == GAME_MODE_PLAYING && AllPlayersGone &&
      (key == KSYM_Return || key == setup.shortcut.toggle_pause))
  {
    CloseDoor(DOOR_CLOSE_1);
    game_status = GAME_MODE_MAIN;
    DrawMainMenu();

    return;
  }

  if (game_status == GAME_MODE_MAIN && key == setup.shortcut.toggle_pause)
  {
    if (setup.autorecord)
      TapeStartRecording();

    {
      game_status = GAME_MODE_PLAYING;
      StopAnimation();
      InitGame();
    }

    return;
  }

  if (game_status == GAME_MODE_MAIN || game_status == GAME_MODE_PLAYING)
  {
    if (key == setup.shortcut.save_game)
      TapeQuickSave();
    else if (key == setup.shortcut.load_game)
      TapeQuickLoad();
    else if (key == setup.shortcut.toggle_pause)
      TapeTogglePause(TAPE_TOGGLE_MANUAL);
  }

  HandleKeysSpecial(key);

  if (HandleGadgetsKeyInput(key))
  {
    if (key != KSYM_Escape)	// always allow ESC key to be handled
      key = KSYM_UNDEFINED;
  }

  switch(game_status)
  {
    case GAME_MODE_PSEUDO_TYPENAME:
      HandleTypeName(0, key);
      break;

    case GAME_MODE_MAIN:
    case GAME_MODE_LEVELS:
    case GAME_MODE_SETUP:
    case GAME_MODE_INFO:
      switch(key)
      {
	case KSYM_space:
	case KSYM_Return:
	  if (game_status == GAME_MODE_MAIN)
	    HandleMainMenu(0,0, 0,0, MB_MENU_CHOICE);
          else if (game_status == GAME_MODE_LEVELS)
            HandleChooseLevel(0,0, 0,0, MB_MENU_CHOICE);
	  else if (game_status == GAME_MODE_SETUP)
	    HandleSetupScreen(0,0, 0,0, MB_MENU_CHOICE);
	  else if (game_status == GAME_MODE_INFO)
	    HandleInfoScreen(0,0, 0,0, MB_MENU_CHOICE);
	  break;

	case KSYM_Escape:
          if (game_status == GAME_MODE_LEVELS)
            HandleChooseLevel(0,0, 0,0, MB_MENU_LEAVE);
	  else if (game_status == GAME_MODE_SETUP)
	    HandleSetupScreen(0,0, 0,0, MB_MENU_LEAVE);
	  else if (game_status == GAME_MODE_INFO)
	    HandleInfoScreen(0,0, 0,0, MB_MENU_LEAVE);
	  break;

        case KSYM_Page_Up:
          if (game_status == GAME_MODE_LEVELS)
            HandleChooseLevel(0,0, 0, -1 * SCROLL_PAGE, MB_MENU_MARK);
	  else if (game_status == GAME_MODE_SETUP)
	    HandleSetupScreen(0,0, 0, -1 * SCROLL_PAGE, MB_MENU_MARK);
	  else if (game_status == GAME_MODE_INFO)
	    HandleInfoScreen(0,0, 0, -1 * SCROLL_PAGE, MB_MENU_MARK);
	  break;

        case KSYM_Page_Down:
          if (game_status == GAME_MODE_LEVELS)
            HandleChooseLevel(0,0, 0, +1 * SCROLL_PAGE, MB_MENU_MARK);
	  else if (game_status == GAME_MODE_SETUP)
	    HandleSetupScreen(0,0, 0, +1 * SCROLL_PAGE, MB_MENU_MARK);
	  else if (game_status == GAME_MODE_INFO)
	    HandleInfoScreen(0,0, 0, +1 * SCROLL_PAGE, MB_MENU_MARK);
	  break;

	default:
	  break;
      }
      break;

    case GAME_MODE_SCORES:
      switch(key)
      {
	case KSYM_space:
	case KSYM_Return:
	case KSYM_Escape:
	  game_status = GAME_MODE_MAIN;
	  DrawMainMenu();
	  break;

        case KSYM_Page_Up:
	  HandleHallOfFame(0,0, 0, -1 * SCROLL_PAGE, MB_MENU_MARK);
	  break;

        case KSYM_Page_Down:
	  HandleHallOfFame(0,0, 0, +1 * SCROLL_PAGE, MB_MENU_MARK);
	  break;

	default:
	  break;
      }
      break;

    case GAME_MODE_EDITOR:
      if (!anyTextGadgetActiveOrJustFinished || key == KSYM_Escape)
	HandleLevelEditorKeyInput(key);
      break;

    case GAME_MODE_PLAYING:
    {
      switch(key)
      {
        case KSYM_Escape:
	  RequestQuitGame(setup.ask_on_escape);
	  break;

#ifdef DEBUG
	case KSYM_0:
	case KSYM_1:
	case KSYM_2:
	case KSYM_3:
	case KSYM_4:
	case KSYM_5:
	case KSYM_6:
	case KSYM_7:
	case KSYM_8:
	case KSYM_9:
	  if (key == KSYM_0)
	  {
	    if (GameFrameDelay == 500)
	      GameFrameDelay = GAME_FRAME_DELAY;
	    else
	      GameFrameDelay = 500;
	  }
	  else
	    GameFrameDelay = (key - KSYM_0) * 10;
	  printf("Game speed == %d%% (%d ms delay between two frames)\n",
		 GAME_FRAME_DELAY * 100 / GameFrameDelay, GameFrameDelay);
	  break;

	case KSYM_d:
	  if (options.debug)
	  {
	    options.debug = FALSE;
	    printf("debug mode disabled\n");
	  }
	  else
	  {
	    options.debug = TRUE;
	    printf("debug mode enabled\n");
	  }
	  break;

	case KSYM_S:
	  if (!global.fps_slowdown)
	  {
	    global.fps_slowdown = TRUE;
	    global.fps_slowdown_factor = 2;
	    printf("fps slowdown enabled -- display only every 2nd frame\n");
	  }
	  else if (global.fps_slowdown_factor == 2)
	  {
	    global.fps_slowdown_factor = 4;
	    printf("fps slowdown enabled -- display only every 4th frame\n");
	  }
	  else
	  {
	    global.fps_slowdown = FALSE;
	    global.fps_slowdown_factor = 1;
	    printf("fps slowdown disabled\n");
	  }
	  break;

#if 0
	case KSYM_a:
	  if (ScrollStepSize == TILEX/8)
	    ScrollStepSize = TILEX/4;
	  else
	    ScrollStepSize = TILEX/8;
	  printf("ScrollStepSize == %d\n", ScrollStepSize);
	  break;
#endif

#if 0
	case KSYM_m:
	  if (MoveSpeed == 8)
	  {
	    MoveSpeed = 4;
	    ScrollStepSize = TILEX/4;
	  }
	  else
	  {
	    MoveSpeed = 8;
	    ScrollStepSize = TILEX/8;
	  }
	  printf("MoveSpeed == %d\n", MoveSpeed);
	  break;
#endif

	case KSYM_f:
	  ScrollStepSize = TILEX/8;
	  printf("ScrollStepSize == %d (1/8)\n", ScrollStepSize);
	  break;

	case KSYM_g:
	  ScrollStepSize = TILEX/4;
	  printf("ScrollStepSize == %d (1/4)\n", ScrollStepSize);
	  break;

	case KSYM_h:
	  ScrollStepSize = TILEX/2;
	  printf("ScrollStepSize == %d (1/2)\n", ScrollStepSize);
	  break;

	case KSYM_l:
	  ScrollStepSize = TILEX;
	  printf("ScrollStepSize == %d (1/1)\n", ScrollStepSize);
	  break;

#if 0

	case KSYM_z:
	  {
	    int i;

	    for (i = 0; i < MAX_PLAYERS; i++)
	    {
	      printf("Player %d:\n", i);
	      printf("  jx == %d, jy == %d\n",
		     stored_player[i].jx, stored_player[i].jy);
	      printf("  last_jx == %d, last_jy == %d\n",
		     stored_player[i].last_jx, stored_player[i].last_jy);
	    }
	    printf("\n");
	  }

	  break;
#endif
#endif

	default:
	  break;
      }
      break;
    }

    default:
      if (key == KSYM_Escape)
      {
	game_status = GAME_MODE_MAIN;
	DrawMainMenu();

	return;
      }
  }*/
	old_what=what;
}