#include "p_gfxinit.h"

#include "RoNDi.h"
#include "video.h"

#include "libgamelibgame.h"
#include "init.h"
#include "main_.h"
#include "events.h"
#include "screens.h"

long for_bugd=0;

unsigned char frames50=0;
unsigned long oldf50,newf50,time50;
unsigned long countStartMoving=0,last50StartMoving;
unsigned long countBigStartMoving=0,last50BigStartMoving;
unsigned long total50tiles=0,last50tiles;

int waiter=0;

boolean DS_Cheating=FALSE;
boolean DS_MDL_Other=FALSE;
int DS_TestRender=0;
int DS_TestMainLoop=0;

int		game_status = -1;

char			redraw_x1 = 0, redraw_y1 = 0;//was int

short			Feld[MAX_LEV_FIELDX*MAX_LEV_FIELDY];
unsigned char	FeldYStart[MAX_LEV_FIELDY];
unsigned char	FeldYEnd[MAX_LEV_FIELDY];

char			MovPos[MAX_LEV_FIELDX*MAX_LEV_FIELDY];//was short
unsigned char	MovDir[MAX_LEV_FIELDX*MAX_LEV_FIELDY];//was short
unsigned short 	* MovDelay = NULL;
short		 	* Store = NULL;
short		 	* Back = NULL;
short		 	* Store2 = NULL;

unsigned char 	FFlags[MAX_LEV_FIELDX*MAX_LEV_FIELDY];
unsigned char	RedrawYCnt[MAX_BUF_YSIZE+2];
//unsigned char	RedrawXCnt[MAX_BUF_XSIZE+2];
unsigned char	StopYBegin[MAX_LEV_FIELDY];
unsigned char	StopYEnd[MAX_LEV_FIELDY];
unsigned char	WasJustYBegin[MAX_LEV_FIELDY];
unsigned char	WasJustYEnd[MAX_LEV_FIELDY];

unsigned char 	* AmoebaNr = NULL;
short			AmoebaCnt[MAX_NUM_AMOEBA];
short			AmoebaCnt2[MAX_NUM_AMOEBA];

unsigned char 	* ExplodeFlags = NULL;
unsigned char	FeldYExplosion[MAX_LEV_FIELDY];
unsigned char	ExplodeFieldY[MAX_LEV_FIELDY];

unsigned char	PropertiesF[NUM_EP_BITFIELDS][MAX_NUM_ELEMENTS];

short int	*GfxElement = NULL;
//changed for palm was long and now char
char			GfxAction[MAX_LEV_FIELDX*MAX_LEV_FIELDY];
//changed for palm was int and now char
//short int		* Gfx = NULL;
unsigned short int		* GfxSFrame = NULL;
unsigned char			*GfxRandom = NULL;

short int 		StorePlayerXY;

int			lev_fieldx, lev_fieldy;
int			scroll_x, scroll_y;

int			FX = SX, FY = SY;
int			ScrollStepSize;
int			ScreenMovDir = MV_NO_MOVING, ScreenMovPos = 0;
int			ScreenGfxPos = 0;
int			BorderElement = EL_STEELWALL;
int			GameFrameDelay = GAME_FRAME_DELAY;
int			FfwdFrameDelay = FFWD_FRAME_DELAY;
int			BX1 = 0, BY1 = 0;
int			BX2 = SCR_FIELDX - 1, BY2 = SCR_FIELDY - 1;
int			SBX_Left, SBX_Right;
int			SBY_Upper, SBY_Lower;
int			ZX, ZY;
int			ExitX, ExitY;
int			AllPlayersGone;

int			TimeFrames, TimePlayed, TimeLeft, TapeTime;

struct LevelInfo	level;
struct PlayerInfo	stored_player_, *local_player = NULL;//was stored_player[MAX]
struct TapeInfo		tape;
struct GameInfo		game;
struct GlobalInfo	global;

struct DoorInfo		door_1, door_2;
struct GraphicInfo     *graphic_infoF = NULL;
struct AnimationInfo	*anim_infoF = NULL;

long gfx_anim_random_frame = 0;

struct ElementInfo		*element_infoF = NULL;
struct ElementGraphicInfo	*element_graphic_infoF = NULL;

unsigned char MainDoLoop[MAX_NUM_ELEMENTS + 1];
/*
short int SAGetValue(struct SmallArray *pntr, short int x, short int y)
{
	short int i;
	for(i=0;i<pntr->size;i++)
		if(pntr->x[i+1]==x&&pntr->y[i+1]==y)
			return pntr->value[i+1];
	return 0;
}

void SASetValue(struct SmallArray *pntr,short int x, short int y, short int val)
{
	short int i;
	for(i=0;i<pntr->size;i++)
		if(pntr->x[i+1]==x&&pntr->y[i+1]==y)
		{
			pntr->value[i+1]=val;
			if(val==0)
			{
				short int j;
				for(j=i+1;j<pntr->size;j++)
				{
					pntr->x[j]=pntr->x[j+1];
					pntr->y[j]=pntr->y[j+1];
					pntr->value[j]=pntr->value[j+1];	
				}
				pntr->size--;
			}
			return;
		}
	if(val==0)
		return;
	if(pntr->size>MAXSA)
	{
		bugd("SASetValue overflow!!!",x*256*256+y);
		return;
	}
	pntr->size++;
	pntr->x[pntr->size]=x;
	pntr->y[pntr->size]=y;
	pntr->value[pntr->size]=val;
};
*/
int PlayWindowNotActive=0;

UInt32	oldKeyMask, curKeyPressed;

void bugd(char* sotro,long value)
{
	char TmpStr[50];
	StrIToH(TmpStr,value);
	FrmCustomAlert(alt_String1,sotro,TmpStr,NULL);
}

void TellGameWon(void)
{
	char ScoreStr[10];
	int ls=LevelSets->cur_levset;

	if(ls>=0)
	{
		if(level_nr==LevelSets->last_won_level[ls]+1)
			LevelSets->last_won_level[ls]++;
	}

	StrIToA(ScoreStr,local_player->score);
	if(FrmCustomAlert(alt_GameWon,ScoreStr,NULL,NULL)==0)
	{
		if(ls>=0)
		{
			level_nr++;
			LevelSets->cur_level[ls]=level_nr;
		}
	}
	DrawMainMenu();
};

//char olko[500];
//short int Fe[32*64];

INIT_SECTION static int StartApplication(void)
{
	UInt32 ROMVersion=0;
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &ROMVersion);
	if (ROMVersion<sysMakeROMVersion(3,5,0,sysROMStageRelease,0))
	{
		FrmAlert(alt_OS35Needed);
		return 10;
	} 
	switch(PrepareResources())
	{
		case 2:
			FrmAlert(alt_NEM);
			ReleaseResources();
			return 2;
		case 1:
			FrmAlert(alt_ResError);
			return 1;
		case 0:
		default:
			break;
	}
	if(WinXSetGreyscale()==1)
	{
		FrmAlert(alt_NEM);
		ReleaseResources();
		WinXSetMono();
		return 3;
	}
	EvtEnableGraffiti(FALSE);
	oldKeyMask = KeySetMask(keyBitPower|keyBitCradle|keyBitAntenna|
					keyBitContrast);//Specify which keys generate keyDownEvents
	LoadLevelSetsInfo();
	FindAllLevelDBs();
/*	{
		int counter=50;
		int y;
		int register x;
		char TmpStr[10];
		int o_tick;
		olko[0]=0;olko[1]=1;olko[2]=0;
		for(y=0;y<32;y++)
			Feld[12][y]=Feld[31][y]=Feld[24][y]=Feld[45][y]=1;
		lev_fieldx=64;
		lev_fieldy=32;
		o_tick=TimGetTicks();
		do{counter--;
		for (y = 0; y < lev_fieldy; y++)
		{	short int register xy=A2TO1(0,y);
			for (x = 0; x < lev_fieldx; x++,xy+=A2TO1(1,0))
			{
				switch(olko[Fe[xy]])
				{
					case 0:
						break;
					case 1:
					default:
						if(xy>20000)
							bugd("EPRST",0);
				}
			}
		}
		}while(counter>=0);
		o_tick=TimGetTicks()-o_tick;
		StrIToA(TmpStr,o_tick);
		FrmCustomAlert(alt_String1,
				"Loop Test 50 frames in .01 sec: ",TmpStr,NULL);

	}*/
/*	{
		UInt16 initDelay,period,doubleTapDelay;
		Boolean queueAhead;
		KeyRates (0, &initDelay, &period, &doubleTapDelay, &queueAhead);
		bugd("initDelay",initDelay);
		bugd("period",period);
		bugd("doubleTapDelay",doubleTapDelay);
		bugd("queueAhead",queueAhead);
	}*/
	SetDefaultGraphic();
	OpenAll();
	IdealTick = SysTicksPerSecond()/50;  /* 20ms/frame */
	ideal_ticks=0;
	FrmGotoForm(frmMain);
	return 0;
}



static Boolean ApplicationHandleEvent(EventPtr event)
{
	UInt16 formID;
	FormPtr form;
	Boolean handled = false;
	
	// Application event loop
	switch (event->eType)
	{
		case menuEvent:
			// Set event handler for application
			handled = ApplicationHandleMenu(event->data.menu.itemID);
			break;
		case frmLoadEvent:
			// Handle form load events
			formID = event->data.frmLoad.formID;
			form = FrmInitForm(formID);
			FrmSetActiveForm(form);		

			switch (formID)
			{
				case frmMain:
					// Set event handler for frmMain
					FrmSetEventHandler(form, (FormEventHandlerPtr) frmMain_HandleEvent);
					break;
				default:
					break;
			}
			handled = true;
			break;
		default:
			break;
	}

	return handled;
};

#define NUM_IGNORE_SYSTEM	10

static void GamePlaying(void)
{
	byte Gcnt=0;
	do{
			curKeyPressed = KeyCurrentState();

			Handle_KeyEvent(curKeyPressed);

			if (game_status == GAME_MODE_PLAYING)
				HandleGameActions(); 

			if(DS_TestRender)
			{
				char TmpStr[10];
				int o_tick=TimGetTicks();
				for(DS_TestRender=50;DS_TestRender>0;DS_TestRender--)
					HandleGameActions();
				o_tick=TimGetTicks()-o_tick;
				StrIToA(TmpStr,o_tick);
				FrmCustomAlert(alt_String1,
						"HandleGameActions Test 50 frames in .01 sec: ",TmpStr,NULL);
				DS_TestRender=1;//Test will end in PlayGame();
				DS_TestMainLoop=50;
				o_tick=TimGetTicks();
				HandleGameActions();
				o_tick=TimGetTicks()-o_tick;
				StrIToA(TmpStr,o_tick);
				FrmCustomAlert(alt_String1,
						"Main Loop Test 50 frames in .01 sec: ",TmpStr,NULL);
				DS_TestMainLoop=0;
			}
			
			PlayGame();
			
			if(DS_MDL_Other)
				DS_MDL_Other=0;
			
			frames50++;
			if(frames50==50)
			{
				last50StartMoving=countStartMoving;
				countStartMoving=0;
				last50BigStartMoving=countBigStartMoving;
				countBigStartMoving=0;
				frames50=0;
				newf50=TimGetTicks();
				time50=newf50-oldf50;
				oldf50=newf50;
				waiter=0;
				last50tiles=total50tiles;
				total50tiles=0;
			}

			cur_tick = TimGetTicks();
			
			ideal_ticks+=IdealTick;

			if(cur_tick-old_tick>=ideal_ticks)ticks_wait=0;
				else ticks_wait=ideal_ticks-cur_tick+old_tick;
		
			if(frames50==0)
				ResetTicks();
			
			if(ticks_wait>0&&ticks_wait<=IdealTick)
			{
				if (!(tape.playing && tape.warp_forward && !tape.pausing))
					{
//					bugd("TaskDelay",ticks_wait);
					waiter++;
					SysTaskDelay(ticks_wait);
				}
			}
	
	Gcnt++;	
	}while(Gcnt<=NUM_IGNORE_SYSTEM);
}

static void EventLoop(void)
{
	Err error;
	EventType event;

	old_tick = TimGetTicks();
	oldf50 = TimGetTicks();
	// Main event loop
	do
	{
		// Get next event
		EvtGetEvent(&event, 0);
		if (event.data.keyDown.chr==vchrMenu
/*					||event.data.keyDown.chr==vchrCommand*/)
			PlayWindowNotActive=1;
		if (event.eType == winExitEvent) { 
			if (event.data.winExit.exitWindow ==  
				(WinHandle) FrmGetFormPtr(frmMain))
					PlayWindowNotActive=1;
			}
		if (event.eType == winEnterEvent) { 
			if (event.data.winEnter.enterWindow ==  
				(WinHandle) FrmGetFormPtr(frmMain) && 
				event.data.winEnter.enterWindow ==  
				(WinHandle) FrmGetFirstForm ())
				{
					PlayWindowNotActive=0;
					ResetTicks();
				}
			} 

		// Handle event
		if (!SysHandleEvent(&event))
		{
			if (!MenuHandleEvent(0, &event, &error))
			{
				if (!ApplicationHandleEvent(&event))
					FrmDispatchEvent(&event);	
			}
		}

		if(!PlayWindowNotActive)
		{
			GamePlaying();
		}
		else
		{
			oldf50 = TimGetTicks();
			frames50=0;
			SysTaskDelay(2);
		}
		
	}
	while (event.eType != appStopEvent);
}

static void StopApplication(void)
{
	CloseAll();
	FrmCloseAllForms();
	WinXSetMono();
	SaveLevelSetsInfo();
	ReleaseResources();
	KeySetMask(oldKeyMask);
	EvtEnableGraffiti(TRUE);
}


UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 launchFlags)
{
	Err error;
	
	switch (cmd) 
 	{
		case sysAppLaunchCmdNormalLaunch:
			// Application start code
			error = StartApplication();
			if (error)
				return error;
		
			// Maintain event loop
			EventLoop();

			// Stop application 
			StopApplication();		
			break;
		default:
			break;
	}
	return 0;
}