#include "screens.h"
#include "game.h"
#include "tools.h"
#include "files.h" 
#include "tape.h"

void DrawMainMenu()
{
/*	static LevelDirTree *leveldir_last_valid = NULL;
	char *name_text = (!options.network && setup.team_mode ? "Team:" : "Name:");
	int name_width, level_width;
	int i;

	UnmapAllGadgets();

	KeyboardAutoRepeatOn();

	SetDrawDeactivationMask(REDRAW_NONE);
	SetDrawBackgroundMask(REDRAW_FIELD);

	// leveldir_current may be invalid (level group, parent link)
	if (!validLevelSeries(leveldir_current))
		leveldir_current = getFirstValidTreeInfoEntry(leveldir_last_valid);

	// store valid level series information
	leveldir_last_valid = leveldir_current;

	// needed if last screen (level choice) changed graphics, sounds or music
	ReloadCustomArtwork(0);*/
/*
#ifdef TARGET_SDL
	SetDrawtoField(DRAW_BACKBUFFER);
#endif
*/
/*	// map gadgets for main menu screen
	MapTapeButtons();

	// level_nr may have been set to value over handicap with level editor
	if (setup.handicap && level_nr > leveldir_current->handicap_level)
		level_nr = leveldir_current->handicap_level;

	GetPlayerConfig();*/
	LoadLevel(level_nr);
/*
	SetMainBackgroundImage(IMG_BACKGROUND_MAIN);
	ClearWindow();

	DrawHeadline();

  DrawText(mSX + 32, mSY + 2*32, name_text, FONT_MENU_1);
  DrawText(mSX + 32, mSY + 3*32, "Level:", FONT_MENU_1);
  DrawText(mSX + 32, mSY + 4*32, "Hall Of Fame", FONT_MENU_1);
  DrawText(mSX + 32, mSY + 5*32, "Level Creator", FONT_MENU_1);
  DrawText(mSX + 32, mSY + 6*32, "Info Screen", FONT_MENU_1);
  DrawText(mSX + 32, mSY + 7*32, "Start Game", FONT_MENU_1);
  DrawText(mSX + 32, mSY + 8*32, "Setup", FONT_MENU_1);
  DrawText(mSX + 32, mSY + 9*32, "Quit", FONT_MENU_1);

  // calculated after (possible) reload of custom artwork
  name_width = getTextWidth(name_text, FONT_MENU_1);
  level_width = getTextWidth("Level:", FONT_MENU_1);

  DrawText(mSX + 32 + name_width, mSY + 2*32, setup.player_name, FONT_INPUT_1);
  DrawText(mSX + level_width + 5 * 32, mSY + 3*32, int2str(level_nr,3),
	   FONT_VALUE_1);

  DrawMicroLevel(MICROLEV_XPOS, MICROLEV_YPOS, TRUE);

  DrawTextF(mSX + 32 + level_width - 2, mSY + 3*32 + 1, FONT_TEXT_3, "%d-%d",
	    leveldir_current->first_level, leveldir_current->last_level);

	if (leveldir_current->readonly)
	{
		DrawTextS(mSX + level_width + 9 * 32 - 2,
								mSY + 3 * 32 + 1 - 7, FONT_TEXT_3, "READ");
		DrawTextS(mSX + level_width + 9 * 32 - 2,
								mSY + 3 * 32 + 1 + 7, FONT_TEXT_3, "ONLY");
	}

	for (i = 0; i < 8; i++)
		initCursor(i, (i == 1 || i == 4 || i == 6 ? IMG_MENU_BUTTON_RIGHT :
														 IMG_MENU_BUTTON));

	drawCursorXY(level_width/32 + 4, 1, IMG_MENU_BUTTON_LEFT);
	drawCursorXY(level_width/32 + 8, 1, IMG_MENU_BUTTON_RIGHT);

	DrawTextSCentered(326, FONT_TITLE_2, "A Game by Artsoft Entertainment");

	FadeToFront();
	InitAnimation();

	HandleMainMenu(0, 0, 0, 0, MB_MENU_INITIALIZE);

	TapeStop();
	if (TAPE_IS_EMPTY(tape))
		LoadTape(level_nr);
	DrawCompleteVideoDisplay();

	OpenDoor(DOOR_CLOSE_1 | DOOR_OPEN_2);*/
//--------------------------- start ---------------------------
	TapeStartRecording();

	game_status = GAME_MODE_PLAYING;
//	StopAnimation();
	InitGame();
//-----------------------------end---------------------------
}

void HandleGameActions()
{
	if (game_status != GAME_MODE_PLAYING)
		return;

	if (local_player->LevelSolved)
		GameWon();

	if (AllPlayersGone && !TAPE_IS_STOPPED(tape))
		TapeStop();
	GameActions();
	BackToFront();
} 