#ifndef TAPE_H_INCLUDED
#define TAPE_H_INCLUDED

#include "main_.h"

/* values for TapeTogglePause() */
#define	TAPE_TOGGLE_MANUAL	TRUE
#define	TAPE_TOGGLE_AUTOMATIC	FALSE 

/* forward declaration for internal use */
void TapeAppendRecording(void)INIT_SECTION;

void TapeStartRecording(void)INIT_SECTION;
void TapeHaltRecording(void)INIT_SECTION;
void TapeStopRecording(void)INIT_SECTION;
void TapeRecordAction(byte);
void TapeTogglePause(boolean)INIT_SECTION;

byte TapePlayAction(void);

void TapeStop(void)INIT_SECTION;
void TapeErase(void)INIT_SECTION;

void TapeQuickSave(void);
void TapeQuickLoad(void);

#endif
