#include "tools.h"
#include "game.h"

#include "video.h"

//static int el_act2crm(int, int);
static int get_act2crm(short int element,char action)
{
	if(element==EL_SAND)
		return IMG_SAND_CRUMBLED;
	else
		return IMG_SAND_CRUMBLED;
}

void SetDrawtoField(int mode)
{/*
	if (mode == DRAW_BUFFERED && setup.soft_scrolling)
	{
		FX = TILEX;
		FY = TILEY;
		BX1 = -1;
		BY1 = -1;
		BX2 = SCR_FIELDX;
		BY2 = SCR_FIELDY;
		redraw_x1 = 1;
		redraw_y1 = 1;

		drawto_field = fieldbuffer;
	}
	else	// DRAW_DIRECT, DRAW_BACKBUFFER
*/	{
		FX = SX;
		FY = SY;
		BX1 = 0;
		BY1 = 0;
		BX2 = SCR_FIELDX - 1;
		BY2 = SCR_FIELDY - 1;
		redraw_x1 = 0;
		redraw_y1 = 0;

//		drawto_field = (mode == DRAW_DIRECT ? window :  backbuffer);
	}
}

#define PalmYporog		2
#define PalmXporog		3

void BackToFront()
{
//	int Ymode,Xmode;
	int x,y;
/*  DrawBuffer *buffer = (drawto_field == window ? backbuffer : drawto_field);

  if (setup.direct_draw && game_status == GAME_MODE_PLAYING)
    redraw_mask &= ~REDRAW_MAIN;
*/
/*	if (redraw_mask & REDRAW_TILES && redraw_tiles > REDRAWTILES_THRESHOLD)
		redraw_mask |= REDRAW_FIELD;*/
	//for palm REDRAWTILES_THRESHOLD is not good enough - using RedrawYCnt

	if (redraw_mask & REDRAW_FIELD)
		redraw_mask &= ~REDRAW_TILES;

	if (redraw_mask == REDRAW_NONE)
		return;

	if (global.fps_slowdown && game_status == GAME_MODE_PLAYING)
	{
		static boolean last_frame_skipped = FALSE;
		boolean skip_even_when_not_scrolling = TRUE;
		boolean just_scrolling = (ScreenMovDir != 0);

		if (global.fps_slowdown_factor > 1 &&
						(FrameCounter % global.fps_slowdown_factor) &&
						(just_scrolling || skip_even_when_not_scrolling))
		{
			redraw_mask &= ~REDRAW_MAIN;

			last_frame_skipped = TRUE;

		}
		else
		{
			if (last_frame_skipped)
				redraw_mask |= REDRAW_FIELD;

			last_frame_skipped = FALSE;

		}
	}
/*
  // synchronize X11 graphics at this point; if we would synchronize the
  //   display immediately after the buffer switching (after the XFlush),
  //   this could mean that we have to wait for the graphics to complete,
  //   although we could go on doing calculations for the next frame

  SyncDisplay();
*/
	if (redraw_mask & REDRAW_ALL)
	{
//		BlitBitmap(backbuffer, window, 0, 0, WIN_XSIZE, WIN_YSIZE, 0, 0);
		PalmAllBackToMain();
		redraw_mask = 0;
	}

	if (redraw_mask & REDRAW_FIELD)
	{
		if (game_status != GAME_MODE_PLAYING ||
						redraw_mask & REDRAW_FROM_BACKBUFFER)
		{
			PalmAllBackToMain();
/*			BlitBitmap(backbuffer, window,
					REAL_SX, REAL_SY, FULL_SXSIZE, FULL_SYSIZE, REAL_SX, REAL_SY);
*/		}
		else
		{
			int fx = FX, fy = FY;

			if (setup.soft_scrolling)
			{
				fx += (ScreenMovDir & (MV_LEFT | MV_RIGHT) ? ScreenGfxPos : 0);
				fy += (ScreenMovDir & (MV_UP | MV_DOWN)    ? ScreenGfxPos : 0);
			}

			if (setup.soft_scrolling ||
					ABS(ScreenMovPos) + ScrollStepSize == TILEX ||
					ABS(ScreenMovPos) == ScrollStepSize ||
					redraw_tiles > REDRAWTILES_THRESHOLD)
			{
//				BlitBitmap(buffer, window, fx, fy, SXSIZE, SYSIZE, SX, SY);
				PalmAllBackToMain();
			}
		}

		redraw_mask &= ~REDRAW_MAIN;
	}
/*
	if (redraw_mask & REDRAW_DOORS)
	{
		if (redraw_mask & REDRAW_DOOR_1)
			BlitBitmap(backbuffer, window, DX, DY, DXSIZE, DYSIZE, DX, DY);
		if (redraw_mask & REDRAW_DOOR_2)
			BlitBitmap(backbuffer, window, VX, VY, VXSIZE, VYSIZE, VX, VY);
		if (redraw_mask & REDRAW_DOOR_3)
			BlitBitmap(backbuffer, window, EX, EY, EXSIZE, EYSIZE, EX, EY);

		redraw_mask &= ~REDRAW_DOORS;
	}

  if (redraw_mask & REDRAW_MICROLEVEL)
  {
    BlitBitmap(backbuffer, window, SX, SY + 10 * TILEY, SXSIZE, 7 * TILEY,
	       SX, SY + 10 * TILEY);

    redraw_mask &= ~REDRAW_MICROLEVEL;
  }
*/
	if (redraw_mask & REDRAW_TILES)
	{
/*		Ymode=Xmode=0;
		
		for (y =0 ; y < SCR_FIELDY; y++)
			if(RedrawYCnt[y]<=PalmYporog)
				Ymode+=PalmYporog;
			else
				Ymode+=RedrawYCnt[y];

		for (x =0 ; x < SCR_FIELDX; x++)
			if(RedrawXCnt[x]<=PalmXporog)
				Xmode+=PalmXporog;
			else
				Xmode+=RedrawXCnt[x]*2;//seems to be good:)
		
		if(Ymode<Xmode)
*/			for (y =0 ; y < SCR_FIELDY; y++)
			{
				short int xy=A2TO1(redraw_x1 ,redraw_y1 + y);
				if(RedrawYCnt[y]<=PalmYporog)
				{
					for (x = 0; x < SCR_FIELDX; x++,xy+=A2TO1(1,0))
						if (getRedraw(xy))//redraw[redraw_x1 + x][redraw_y1 + y]
/*					BlitBitmap(buffer, window,
								FX + x * TILEX, FY + y * TILEY, TILEX, TILEY,
								SX + x * TILEX, SY + y * TILEY)*/
							PalmTileBackToMain(x,y,1,1);
				}
				else
					PalmTileBackToMain(0,y,10,1);
			}
/*		else
		{bugd("Xmode",0);
			for (x =0 ; x < SCR_FIELDX; x++)
			{
				short int xy=A2TO1(redraw_x1 + x,redraw_y1);
				if(RedrawXCnt[x]<=PalmXporog)
				{
					for (y = 0; y < SCR_FIELDY; y++,xy+=A2TO1(0,1))
						if (getRedraw(xy))
							PalmTileBackToMain(x,y,1,1);
				}
				else
					PalmTileBackToMain(x,0,1,10);
			}
		}*/
	}
/*
  if (redraw_mask & REDRAW_FPS)		// display frames per second
  {
    char text[100];
    char info1[100];

    sprintf(info1, " (only every %d. frame)", global.fps_slowdown_factor);
    if (!global.fps_slowdown)
      info1[0] = '\0';

    sprintf(text, "%.1f fps%s", global.frames_per_second, info1);
    DrawTextExt(window, SX, SY, text, FONT_TEXT_2, BLIT_OPAQUE);
  }
*/
	FlushDisplay();

	for (x = 0; x < MAX_BUF_XSIZE; x++)
//		if(RedrawXCnt[x])
		{
			short int xy=A2TO1(x,0);
			for (y = 0; y < MAX_BUF_YSIZE; y++,xy+=A2TO1(0,1))
				setRedrawFALSE(xy);// redraw[x][y] = 0;
		}

	for (y = 0; y < MAX_BUF_YSIZE; y++)
		RedrawYCnt[y]=0;
/*
	for (x = 0; y < MAX_BUF_XSIZE; x++)
		RedrawXCnt[x]=0;
*/
	redraw_tiles = 0;
	redraw_mask = REDRAW_NONE;
}

void FadeToFront()
{
	BackToFront();
}

void ClearWindow()
{
/*  DrawBackground(REAL_SX, REAL_SY, FULL_SXSIZE, FULL_SYSIZE);

  if (setup.soft_scrolling && game_status == GAME_MODE_PLAYING)
  {
    ClearRectangle(fieldbuffer, 0, 0, FXSIZE, FYSIZE);
    SetDrawtoField(DRAW_BUFFERED);
  }
  else
    SetDrawtoField(DRAW_BACKBUFFER);

  if (setup.direct_draw && game_status == GAME_MODE_PLAYING)
  {
    ClearRectangle(window, REAL_SX, REAL_SY, FULL_SXSIZE, FULL_SYSIZE);
    SetDrawtoField(DRAW_DIRECT);
  }*/
}

void MarkTileDirty(int x, int y)
{
	int xx = redraw_x1 + x;
	int yy = redraw_y1 + y;
	short int xxyy=A2TO1(xx,yy);
/*
	if(xx<0||yy<0)
	{
		bugd("MarkTileDirty with -1 at y,x",xx+256*yy);
		return;
	}
*/
	if (!getRedraw(xxyy))//!redraw[xx][yy]
	{
		redraw_tiles++;
		RedrawYCnt[yy]++;
//		RedrawXCnt[xx]++;
	}
	setRedrawTRUE(xxyy);	//	redraw[xx][yy] = TRUE;

	redraw_mask |= REDRAW_TILES;
}

void SetBorderElement()
{
	int x, y;

	BorderElement = EL_EMPTY;

	for (y = 0; y < lev_fieldy && BorderElement == EL_EMPTY; y++)
	{
		for (x = 0; x < lev_fieldx; x++)
		{
			if (!IS_INDESTRUCTIBLE(Feld[A2TO1(x,y)]))
				BorderElement = EL_STEELWALL;

			if (y != 0 && y != lev_fieldy - 1 && x != lev_fieldx - 1)
				x = lev_fieldx - 2;
		}
	}
}

char getAnimationFrame(char num_frames, long delay, char mode, char start_frame,
																long sync_frame)
{
	long frame = 0;

	if ( delay >= DELAY_MILLION )
		delay = 1000000;

	sync_frame += start_frame * delay;

	if (mode & ANIM_LOOP)			// looping animation
	{
		frame = (sync_frame % (delay * num_frames)) / delay;
	}
	else if (mode & ANIM_LINEAR)		// linear (non-looping) animation
	{
		frame = sync_frame / delay;
		if (frame > num_frames - 1)
			frame = num_frames - 1;
	}
	else if (mode & ANIM_PINGPONG)	// oscillate (border frames once)
	{
		long max_anim_frames = (num_frames > 1 ? 2 * num_frames - 2 : 1);

		frame = (sync_frame % (delay * max_anim_frames)) / delay;
		frame = (frame < num_frames ? frame : max_anim_frames - frame);
	}
	else if (mode & ANIM_PINGPONG2)	// oscillate (border frames twice)
	{
		int max_anim_frames = 2 * num_frames;

		frame = (sync_frame % (delay * max_anim_frames)) / delay;
		frame = (frame < num_frames ? frame : max_anim_frames - frame - 1);
	}
	else if (mode & ANIM_RANDOM)		// play frames in random order
	{
		// note: expect different frames for the same delay cycle!

		if (gfx_anim_random_frame < 0)
			frame = SimpleRND(num_frames);
		else
			frame = gfx_anim_random_frame % num_frames;
	}

	if (mode & ANIM_REVERSE)		// use reverse animation direction
		frame = num_frames - frame - 1;

	return frame;
}

char getGraphicAnimationFrame(short int graphic, long sync_frame)
{
	int anim_idx = ANIM_INDEX(graphic);

	if(anim_idx==1)
		return 0;//only 1 frame

	// animation synchronized with global frame counter, not move position
	if (anim_infoF->anim_global_sync[anim_idx] || sync_frame < 0)
		sync_frame = FrameCounter;

	return getAnimationFrame(anim_infoF->anim_frames[anim_idx],
							 anim_infoF->anim_delay_[anim_idx],
							 anim_infoF->anim_mode[anim_idx],
							 anim_infoF->anim_start_frame[anim_idx],
							 sync_frame);
}

/*inline*/ void DrawGraphicAnimation(int x, int y, int graphic)
{
	if (!IN_SCR_FIELD(x, y))
		return;

/*	DrawGraphicAnimationExt(drawto_field, FX + x * TILEX, FY + y * TILEY,
									graphic, GfxFrame[lx][ly], NO_MASKING);*/
	{
		short int lxy = A2TO1(LEVELX(x),LEVELY(y));
		char frame = getGraphicAnimationFrame(graphic, FrameCounter - GfxSFrame[lxy]);
		if(graphic==-1) bugd("DrGrAn -1 at x,y",x*256+y);
		PalmEasyDraw(x, y, graphic, frame);
	}

	MarkTileDirty(x, y);
}

void DrawLevelElementAnimation(int x, int y, int element)
{
	int graphic = FindGfxValue(element,GfxAction[A2TO1(x,y)],MovDir[A2TO1(x,y)]);
	//Gfx[A2TO1(x,y)]; 
	//was el_act_dir2img(element, GfxAction[x][y], GfxDir[x][y]);
if(graphic==-1) bugd("DrLevElAn -1 at x,y",x*256+y);
	DrawGraphicAnimation(SCREENX(x), SCREENY(y), graphic);
}

void DrawLevelGraphicAnimationIfNeeded(int x, int y, int graphic)
{
	int sx = SCREENX(x), sy = SCREENY(y);

	if (!IN_LEV_FIELD(x, y) || !IN_SCR_FIELD(sx, sy))
		return;

	if (!IS_NEW_FRAME(FrameCounter - GfxSFrame[A2TO1(x,y)], graphic))
		//was GfxFrame[x][y]
		return;
if(graphic==-1) bugd("DrLevGrAnIfNeed -1 at x,y",x*256+y);
	DrawGraphicAnimation(sx, sy, graphic);

	if (GFX_CRUMBLED(Feld[A2TO1(x,y)]))
		DrawLevelFieldCrumbledSand(x, y);
}

void DrawLevelElementAnimationIfNeeded(int x, int y, int element)
{
	int sx = SCREENX(x), sy = SCREENY(y);
	int graphic;

	if (!IN_LEV_FIELD(x, y) || !IN_SCR_FIELD(sx, sy))
		return;

	graphic = FindGfxValue(element,GfxAction[A2TO1(x,y)],MovDir[A2TO1(x,y)]); 
	//Gfx[A2TO1(x,y)]; //called always with Feld[xy]!!!
	//was el_act_dir2img(element, GfxAction[x][y], GfxDir[x][y]);

	if (!IS_NEW_FRAME(FrameCounter - GfxSFrame[A2TO1(x,y)], graphic))
		//was GfxFrame[x][y]
		return;
if(graphic==-1) bugd("DrLevElAnIfNeed -1 at x,y",x*256+y);
	DrawGraphicAnimation(sx, sy, graphic);

	if (GFX_CRUMBLED(element))
		DrawLevelFieldCrumbledSand(x, y);
}

static int getPlayerGraphic(struct PlayerInfo *player, int move_dir)
{
	if (player->use_murphy_graphic)
	{
		// this works only because currently only one player can be "murphy" ...
		static int last_horizontal_dir = MV_LEFT;
		int graphic = FindGfxValue(EL_SP_MURPHY, player->GfxAction, move_dir);
		//was el_act_dir2img(EL_SP_MURPHY, player->GfxAction, move_dir);

		if (move_dir == MV_LEFT || move_dir == MV_RIGHT)
			last_horizontal_dir = move_dir;

		if (graphic == IMG_SP_MURPHY)	// undefined => use special graphic 
		{
			int direction = (player->is_snapping ? move_dir : last_horizontal_dir);

			graphic = FindGfxValue(EL_SP_MURPHY, player->GfxAction, direction);
			//was el_act_dir2img(EL_SP_MURPHY, player->GfxAction, direction);
		}

		return graphic;
	}
	else
		return FindGfxValue(player->element_nr, player->GfxAction, move_dir);
		//was el_act_dir2img(player->element_nr, player->GfxAction, move_dir);
}

void DrawAllPlayers()
{
	if (stored_player_.active)
		DrawPlayer(&stored_player_);
}

void DrawPlayerField(int x, int y)
{
	if (!IS_PLAYER(A2TO1(x, y)))
		return;

	DrawPlayer(PLAYERINFO(x, y));
}

void DrawPlayer(struct PlayerInfo *player)
{
	int jx = player->jx;
	int jy = player->jy;
	int move_dir = player->MovDir;
	int dx = (move_dir == MV_LEFT ? -1 : move_dir == MV_RIGHT ? +1 : 0);
	int dy = (move_dir == MV_UP   ? -1 : move_dir == MV_DOWN  ? +1 : 0);
	int last_jx = (player->is_moving ? jx - dx : jx);
	int last_jy = (player->is_moving ? jy - dy : jy);
	int next_jx = jx + dx;
	int next_jy = jy + dy;
	boolean player_is_moving = (player->MovPos ? TRUE : FALSE);
	int sx = SCREENX(jx), sy = SCREENY(jy);
	int sxx = 0, syy = 0;
	short int jxy=A2TO1(jx,jy);	
	short int last_jxy=A2TO1(last_jx,last_jy);
	int element = Feld[jxy], last_element = Feld[last_jxy];
	int graphic;
	int action = ACTION_DEFAULT;
//	int last_player_graphic = getPlayerGraphic(player, move_dir);
	int last_player_frame = player->Frame;
	int frame = 0;	
	
	if (!player->active || !IN_SCR_FIELD(SCREENX(last_jx), SCREENY(last_jy)))
		return;

	if (element == EL_EXPLOSION)
		return;

	action = (player->is_pushing    ? ACTION_PUSHING         :
			  player->is_digging    ? ACTION_DIGGING         :
			  player->is_collecting ? ACTION_COLLECTING      :
			  player->is_moving     ? ACTION_MOVING          :
			  player->is_snapping   ? ACTION_SNAPPING        :
			  player->is_dropping   ? ACTION_DROPPING        :
			  player->is_waiting    ? player->action_waiting : ACTION_DEFAULT);

	InitPlayerGfxAnimation(player, action, move_dir);

  // -----------------------------------------------------------------------
  // draw things in the field the player is leaving, if needed              
  // -----------------------------------------------------------------------

	if (player->is_moving)
	{
		if (Back[last_jxy] && IS_DRAWABLE(last_element))
		{
			DrawLevelElement(last_jx, last_jy, Back[last_jxy]);

			if (last_element == EL_DYNAMITE_ACTIVE ||
							last_element == EL_SP_DISK_RED_ACTIVE)
				DrawDynamite(last_jx, last_jy);
			else
				DrawLevelFieldThruMask(last_jx, last_jy);
		}
		else if (last_element == EL_DYNAMITE_ACTIVE ||
							last_element == EL_SP_DISK_RED_ACTIVE)
			DrawDynamite(last_jx, last_jy);
		else
			DrawLevelField(last_jx, last_jy);

		if (player->is_pushing && IN_SCR_FIELD(SCREENX(next_jx), SCREENY(next_jy)))
			DrawLevelElement(next_jx, next_jy, EL_EMPTY);
	}

	if (!IN_SCR_FIELD(sx, sy))
		return;

/*	if (setup.direct_draw)
		SetDrawtoField(DRAW_BUFFERED);
*/
	// ----------------------------------------------------------------------- 
	// draw things behind the player, if needed                                
	// ----------------------------------------------------------------------- 

	if (Back[jxy])
		DrawLevelElement(jx, jy, Back[jxy]);
	else if (IS_ACTIVE_BOMB(element))
		DrawLevelElement(jx, jy, EL_EMPTY);
	else
	{
		if (player_is_moving && GfxElement[jxy] != EL_UNDEFINED)
		{
/*			if (GFX_CRUMBLED(GfxElement[jxy]))
				DrawLevelFieldCrumbledSandDigging(jx, jy, move_dir, player->StepFrame);
			else*/
			{
				int old_element = GfxElement[jxy];
				int old_graphic = FindGfxValue(old_element, action, move_dir);
				//was el_act_dir2img(old_element, action, move_dir);
				int frame = getGraphicAnimationFrame(old_graphic, player->StepFrame);

				DrawGraphic(sx, sy, old_graphic, frame);
			}
		}
		else
		{
			GfxElement[jxy] = EL_UNDEFINED;

			DrawLevelField(jx, jy);
		}
	}

	// ----------------------------------------------------------------------- 
	// draw player himself                                                     
	// ----------------------------------------------------------------------- 

	graphic = getPlayerGraphic(player, move_dir);

	// in the case of changed player action or direction, prevent the current
	//   animation frame from being restarted for identical animations
	if (player->Frame == 0 /*&& equalGraphics(graphic, last_player_graphic)*/)
		player->Frame = last_player_frame;

	frame = getGraphicAnimationFrame(graphic, player->Frame);

	if (player->MovPos/*was GfxPos*/)
	{
		if (move_dir == MV_LEFT || move_dir == MV_RIGHT)
			sxx = player->MovPos/*GfxPos*/;
		else
			syy = player->MovPos/*GfxPos*/;
	}

	if (!setup.soft_scrolling && ScreenMovPos)
		sxx = syy = 0;

	DrawGraphicShiftedThruMask(sx, sy, sxx, syy, graphic, frame, NO_CUTTING);

	if (SHIELD_ON(player))
	{
		int graphic = (player->shield_deadly_time_left ? IMG_SHIELD_DEADLY_ACTIVE :
														IMG_SHIELD_NORMAL_ACTIVE);
		int frame = getGraphicAnimationFrame(graphic, -1);

		DrawGraphicShiftedThruMask(sx, sy, sxx, syy, graphic, frame, NO_CUTTING);
	}

	// ----------------------------------------------------------------------- 
	// draw things the player is pushing, if needed                            
	// ----------------------------------------------------------------------- 

	if (player->is_pushing && player->is_moving)
	{
		int px = SCREENX(next_jx), py = SCREENY(next_jy);
		short int next_jxy=A2TO1(next_jx,next_jy); 

		if (Back[next_jxy])
			DrawLevelElement(next_jx, next_jy, Back[next_jxy]);

		if ((sxx || syy) && element == EL_SOKOBAN_OBJECT)
			DrawGraphicShiftedThruMask(px, py, sxx, syy, IMG_SOKOBAN_OBJECT, 0,
																	NO_CUTTING);
		else
		{
			int element = MovingOrBlocked2Element(next_jx, next_jy);
			int graphic = FindGfxValue(element, ACTION_PUSHING, move_dir);
			//was el_act_dir2img(element, ACTION_PUSHING, move_dir);
			int frame = getGraphicAnimationFrame(graphic, player->StepFrame);

			DrawGraphicShifted(px, py, sxx, syy, graphic, frame,
										NO_CUTTING, NO_MASKING);
		}
	}

	// ----------------------------------------------------------------------- 
	// draw things in front of player (active dynamite or dynabombs)           
	// ----------------------------------------------------------------------- 

	if (IS_ACTIVE_BOMB(element))
	{
		graphic = el2img(element);
		frame = getGraphicAnimationFrame(graphic, FrameCounter - GfxSFrame[jxy]);
											//was GfxFrame[jx][jy]

		if (game.emulation == EMU_SUPAPLEX)
			DrawGraphic(sx, sy, IMG_SP_DISK_RED, frame);
		else
			DrawGraphicThruMask(sx, sy, graphic, frame);
	}

	if (player_is_moving && last_element == EL_EXPLOSION)
	{
		int graphic = GetExplodingGfx(GfxElement[last_jxy]); 
		//was el_act2img(GfxElement[last_jx][last_jy], ACTION_EXPLODING);
		int delay = (game.emulation == EMU_SUPAPLEX ? 3 : 2);
		int phase = getExplodePhase(last_jxy) - 1;
		int frame = getGraphicAnimationFrame(graphic, phase - delay);

		if (phase >= delay)
			DrawGraphicThruMask(SCREENX(last_jx), SCREENY(last_jy), graphic, frame);
	}

  // ----------------------------------------------------------------------- 
  // draw elements the player is just walking/passing through/under          
  // ----------------------------------------------------------------------- 

	if (player_is_moving)
	{
		// handle the field the player is leaving ...
		if (IS_ACCESSIBLE_INSIDE(last_element))
			DrawLevelField(last_jx, last_jy);
		else if (IS_ACCESSIBLE_UNDER(last_element))
			DrawLevelFieldThruMask(last_jx, last_jy);
	}

	// do not redraw accessible elements if the player is just pushing them
	if (!player_is_moving || !player->is_pushing)
	{
		// ... and the field the player is entering
		if (IS_ACCESSIBLE_INSIDE(element))
			DrawLevelField(jx, jy);
		else if (IS_ACCESSIBLE_UNDER(element))
			DrawLevelFieldThruMask(jx, jy);
	}
/*
  if (setup.direct_draw)
  {
    int dest_x = SX + SCREENX(MIN(jx, last_jx)) * TILEX;
    int dest_y = SY + SCREENY(MIN(jy, last_jy)) * TILEY;
    int x_size = TILEX * (1 + ABS(jx - last_jx));
    int y_size = TILEY * (1 + ABS(jy - last_jy));

    BlitBitmap(drawto_field, window,
	       dest_x, dest_y, x_size, y_size, dest_x, dest_y);
    SetDrawtoField(DRAW_DIRECT);
  }
*/
	MarkTileDirty(sx,sy);
}

void DrawGraphic(int x, int y, int graphic, int frame)
{
//	DrawGraphicExt(drawto_field, FX + x * TILEX, FY + y * TILEY, graphic, frame);
	PalmEasyDraw(x,y,graphic,frame);
	MarkTileDirty(x, y);
}

void DrawGraphicThruMask(int x, int y, int graphic, int frame)
{/*
	DrawGraphicThruMaskExt(drawto_field, FX + x * TILEX, FY + y *TILEY, graphic,
																		 frame);*/
	PalmEasyDrawThruMask(x,y,graphic,frame);
	MarkTileDirty(x, y);
}

void DrawGraphicShifted(int x,int y, int dx,int dy, int graphic, int frame,
			int cut_mode, int mask_mode)
{
/*	Bitmap *src_bitmap;
	GC drawing_gc;
	int src_x, src_y;*/
	int width = TILEX, height = TILEY;
	int cx = 0, cy = 0;
	int dest_x, dest_y;

	if (graphic < 0)
	{
		DrawGraphic(x, y, graphic, frame);
		return;
	}

	if (dx || dy)			// shifted graphic
	{
		if (x < BX1)		// object enters playfield from the left
		{
			x = BX1;
			width = dx;
			cx = TILEX - dx;
			dx = 0;
		}
		else if (x > BX2)		// object enters playfield from the right
		{
			x = BX2;
			width = -dx;
			dx = TILEX + dx;
		}
		else if (x==BX1 && dx < 0)	// object leaves playfield to the left
		{
			width += dx;
			cx = -dx;
			dx = 0;
		}
		else if (x==BX2 && dx > 0)	// object leaves playfield to the right
			width -= dx;
		else if (dx)		// general horizontal movement
			MarkTileDirty(x + SIGN(dx), y);

		if (y < BY1)		// object enters playfield from the top
		{
			if (cut_mode==CUT_BELOW)	// object completely above top border
				return;

			y = BY1;
			height = dy;
			cy = TILEY - dy;
			dy = 0;
		}
		else if (y > BY2)		// object enters playfield from the bottom
		{
			y = BY2;
			height = -dy;
			dy = TILEY + dy;
		}
		else if (y==BY1 && dy < 0)	// object leaves playfield to the top
		{
			height += dy;
			cy = -dy;
			dy = 0;
		}
		else if (dy > 0 && cut_mode == CUT_ABOVE)
		{
			if (y == BY2)		// object completely above bottom border
				return;

			height = dy;
			cy = TILEY - dy;
			dy = TILEY;
			MarkTileDirty(x, y + 1);
		}				// object leaves playfield to the bottom
		else if (dy > 0 && (y == BY2 || cut_mode == CUT_BELOW))
			height -= dy;
		else if (dy)		// general vertical movement
			MarkTileDirty(x, y + SIGN(dy));
	}
/*
  getGraphicSource(graphic, frame, &src_bitmap, &src_x, &src_y);

  drawing_gc = src_bitmap->stored_clip_gc;

	src_x += cx;
	src_y += cy;
*/
	dest_x = FX + x * TILEX + dx;
	dest_y = FY + y * TILEY + dy;

	if (mask_mode == USE_MASKING)
	{
/*    SetClipOrigin(src_bitmap, drawing_gc, dest_x - src_x, dest_y - src_y);
    BlitBitmapMasked(src_bitmap, drawto_field, src_x, src_y, width, height,
		     dest_x, dest_y);*/
		PalmDrawShiftedMasked(x, y, width, height, cx, cy, dx, dy, graphic, frame);
	}
	else
/*    BlitBitmap(src_bitmap, drawto_field, src_x, src_y, width, height,
	       dest_x, dest_y)*/
		PalmDrawShifted(x, y, width, height, cx, cy, dx, dy, graphic, frame);

	MarkTileDirty(x,y);
}

void DrawScreenElementExt(int x, int y, int dx, int dy, int element,
										int cut_mode, int mask_mode)
{
	int lx = LEVELX(x), ly = LEVELY(y);
	int graphic;
	int frame;
//bugd("DrawScreenElementExt",x+256*y);
	if (IN_LEV_FIELD(lx, ly))
	{
		short int lxy=A2TO1(lx,ly);
		SetRandomAnimationValue(lxy);

/*		if(element==Feld[lxy])
			graphic = Gfx[lxy];
		else
*/			graphic = FindGfxValue(element, GfxAction[lxy], MovDir[lxy]);
		//was el_act_dir2img(element, GfxAction[lx][ly], GfxDir[lx][ly]);
		frame = getGraphicAnimationFrame(graphic, FrameCounter - GfxSFrame[lxy]);
										//was GfxFrame[lx][ly]
	}
	else	// border element
	{
		graphic = el2img(element);
		frame = getGraphicAnimationFrame(graphic, -1);
	}

	if (element == EL_EXPANDABLE_WALL)
	{
		boolean left_stopped = FALSE, right_stopped = FALSE;
		short int lxy=A2TO1(lx,ly);

		if (!IN_LEV_FIELD(lx - 1, ly) || IS_WALL(Feld[lxy-A2TO1(1,0)]))
			left_stopped = TRUE;
		if (!IN_LEV_FIELD(lx + 1, ly) || IS_WALL(Feld[lxy+A2TO1(1,0)]))
			right_stopped = TRUE;

		if (left_stopped && right_stopped)
			graphic = IMG_WALL;
		else if (left_stopped)
		{
			graphic = IMG_EXPANDABLE_WALL_GROWING_RIGHT;
			frame = anim_infoF->anim_frames[ANIM_INDEX(graphic)] - 1;
			//graphic_info[graphic].anim_frames - 1
		}
		else if (right_stopped)
		{
			graphic = IMG_EXPANDABLE_WALL_GROWING_LEFT;
			frame = anim_infoF->anim_frames[ANIM_INDEX(graphic)] - 1;
			//graphic_info[graphic].anim_frames - 1
		}
	}

	if (dx || dy)
		DrawGraphicShifted(x, y, dx, dy, graphic, frame, cut_mode, mask_mode);
	else if (mask_mode == USE_MASKING)
		DrawGraphicThruMask(x, y, graphic, frame);
	else
		DrawGraphic(x, y, graphic, frame);

}

#define TILE_GFX_ELEMENT(xy)						    \
	(GfxElement[xy] != EL_UNDEFINED && Feld[xy] != EL_EXPLOSION ?   \
	 GfxElement[xy] : Feld[xy])

static void DrawLevelFieldCrumbledSandExt(int x, int y, int graphic, int frame)
{
//	Bitmap *src_bitmap;
//	int src_x, src_y;
	int sx = SCREENX(x), sy = SCREENY(y);
	int element;
	int width, height, cx, cy, i;
	int crumbled_border_size = TILEX / 8; //was graphic_info[graphic].border_size;
	short int xy=A2TO1(x,y);

	const int xy_x[4] = {0,-1,+1,0};
	const int xy_y[4] = {-1,0,0,+1};

	if (!IN_LEV_FIELD(x, y))
		return;

	element = TILE_GFX_ELEMENT(xy);

	// crumble field itself
	if (GFX_CRUMBLED(element) && !IS_MOVING(xy))
	{
		if (!IN_SCR_FIELD(sx, sy))
			return;

//		getGraphicSource(graphic, frame, &src_bitmap, &src_x, &src_y);

		for (i = 0; i < 4; i++)
		{
			int xx = x + xy_x[i];
			int yy = y + xy_y[i];
			short int xxyy=A2TO1(xx,yy);

			element = (IN_LEV_FIELD(xx, yy) ? TILE_GFX_ELEMENT(xxyy) 
																: BorderElement);

			// check if neighbour field is of same type
			if (GFX_CRUMBLED(element) && !IS_MOVING(xxyy))
				continue;

			if (i == 1 || i == 2)
			{
				width = crumbled_border_size;
				height = TILEY;
				cx = (i == 2 ? TILEX - crumbled_border_size : 0);
				cy = 0;
			}
			else
			{
				width = TILEX;
				height = crumbled_border_size;
				cx = 0;
				cy = (i == 3 ? TILEY - crumbled_border_size : 0);
			}

			PalmDrawShifted(sx, sy, width, height, cx, cy, cx, cy, graphic, frame);
/*			BlitBitmap(src_bitmap, drawto_field, src_x + cx, src_y + cy,
					width, height, FX + sx * TILEX + cx, FY + sy * TILEY + cy);
*/		}

		MarkTileDirty(sx, sy);
	}
	else		// crumble neighbour fields
	{

		for (i = 0; i < 4; i++)
		{
			int xx = x + xy_x[i];
			int yy = y + xy_y[i];
			int sxx = sx + xy_x[i];
			int syy = sy + xy_y[i];
			short int xxyy=A2TO1(xx,yy);

			if (!IN_LEV_FIELD(xx, yy) ||
						!IN_SCR_FIELD(sxx, syy) ||
						IS_MOVING(xxyy))
				continue;

			element = TILE_GFX_ELEMENT(xxyy);

			if (!GFX_CRUMBLED(element))
				continue;

			graphic = get_act2crm(Feld[xxyy], ACTION_DEFAULT);
			crumbled_border_size = TILEX / 8; //was graphic_info[graphic].border_size;

//			getGraphicSource(graphic, frame, &src_bitmap, &src_x, &src_y);

			if (i == 1 || i == 2)
			{
				width = crumbled_border_size;
				height = TILEY;
				cx = (i == 1 ? TILEX - crumbled_border_size : 0);
				cy = 0;
			}
			else
			{
				width = TILEX;
				height = crumbled_border_size;
				cx = 0;
				cy = (i == 0 ? TILEY - crumbled_border_size : 0);
			}

			if(width==TILEX)
				PalmDrawShifted(sxx, syy, width, height, cx, cy, cx, cy, graphic, frame);
/*			BlitBitmap(src_bitmap, drawto_field, src_x + cx, src_y + cy,
					width, height, FX + sxx * TILEX + cx, FY + syy * TILEY + cy);
*/
			MarkTileDirty(sxx, syy);
		}
	}
}

void DrawLevelFieldCrumbledSand(int x, int y)
{
	int graphic;

	if (!IN_LEV_FIELD(x, y))
		return;

	graphic = get_act2crm(Feld[A2TO1(x,y)], ACTION_DEFAULT);

	DrawLevelFieldCrumbledSandExt(x, y, graphic, 0);
}

void DrawLevelFieldCrumbledSandNeighbours(int x, int y)
{
	int sx = SCREENX(x), sy = SCREENY(y);
	const int xy[4][2] = //for palm only, was static
	{
		{ 0, -1 },
		{ -1, 0 },
		{ +1, 0 },
		{ 0, +1 }
	};
	int i;

	for (i = 0; i < 4; i++)
	{
		int xx = x + xy[i][0];
		int yy = y + xy[i][1];
		int sxx = sx + xy[i][0];
		int syy = sy + xy[i][1];

		if (!IN_LEV_FIELD(xx, yy) ||
						!IN_SCR_FIELD(sxx, syy) ||
						!GFX_CRUMBLED(Feld[A2TO1(xx, yy)]) ||
						IS_MOVING(A2TO1(xx, yy)))
			continue;

		DrawLevelField(xx, yy);
	}
}

static int getBorderElement(int x, int y)
{
	const int border[7][2] = //for palm only const int, was int
	{
		{ EL_STEELWALL_TOPLEFT,		EL_INVISIBLE_STEELWALL_TOPLEFT     },
		{ EL_STEELWALL_TOPRIGHT,		EL_INVISIBLE_STEELWALL_TOPRIGHT    },
		{ EL_STEELWALL_BOTTOMLEFT,		EL_INVISIBLE_STEELWALL_BOTTOMLEFT  },
		{ EL_STEELWALL_BOTTOMRIGHT,		EL_INVISIBLE_STEELWALL_BOTTOMRIGHT },
		{ EL_STEELWALL_VERTICAL,		EL_INVISIBLE_STEELWALL_VERTICAL    },
		{ EL_STEELWALL_HORIZONTAL,		EL_INVISIBLE_STEELWALL_HORIZONTAL  },
		{ EL_STEELWALL,			EL_INVISIBLE_STEELWALL		   }
	};
	int steel_type = (BorderElement == EL_STEELWALL ? 0 : 1);
	int steel_position = (x == -1		&& y == -1		? 0 :
						x == lev_fieldx	&& y == -1		? 1 :
						x == -1		&& y == lev_fieldy	? 2 :
						x == lev_fieldx	&& y == lev_fieldy	? 3 :
						x == -1		|| x == lev_fieldx	? 4 :
						y == -1		|| y == lev_fieldy	? 5 : 6);

	return border[steel_position][steel_type];
}

void DrawScreenElement(int x, int y, int element)
{
	DrawScreenElementExt(x, y, 0, 0, element, NO_CUTTING, NO_MASKING);
	DrawLevelFieldCrumbledSand(LEVELX(x), LEVELY(y));
}

void DrawLevelElement(int x, int y, int element)
{
	if (IN_LEV_FIELD(x, y) && IN_SCR_FIELD(SCREENX(x), SCREENY(y)))
		DrawScreenElement(SCREENX(x), SCREENY(y), element);
}

void DrawScreenField(int x, int y)
{
	int lx = LEVELX(x), ly = LEVELY(y);
	short int lxy=A2TO1(lx,ly);
	int element, content;

	if (!IN_LEV_FIELD(lx, ly))
	{
		if (lx < -1 || lx > lev_fieldx || ly < -1 || ly > lev_fieldy)
			element = EL_EMPTY;
		else
			element = getBorderElement(lx, ly);

		DrawScreenElement(x, y, element);
		return;
	}

	element = Feld[lxy];
	content = Store[lxy];

	if (IS_MOVING(lxy))
	{
		int horiz_move = (MovDir[lxy] == MV_LEFT || MovDir[lxy] == MV_RIGHT);
		boolean cut_mode = NO_CUTTING;

		if (element == EL_QUICKSAND_EMPTYING ||
							element == EL_MAGIC_WALL_EMPTYING ||
							element == EL_BD_MAGIC_WALL_EMPTYING ||
							element == EL_AMOEBA_DROPPING)
			cut_mode = CUT_ABOVE;
		else if (element == EL_QUICKSAND_FILLING ||
							element == EL_MAGIC_WALL_FILLING ||
							element == EL_BD_MAGIC_WALL_FILLING)
			cut_mode = CUT_BELOW;

		if (cut_mode == CUT_ABOVE)
		{
			DrawScreenElementShifted(x, y, 0, 0, element, NO_CUTTING);
		}
		else
			DrawScreenElement(x, y, EL_EMPTY);

		if (horiz_move)
			DrawScreenElementShifted(x, y, MovPos[lxy], 0, element, NO_CUTTING);
		else if (cut_mode == NO_CUTTING)
			DrawScreenElementShifted(x, y, 0, MovPos[lxy], element, cut_mode);
		else
			DrawScreenElementShifted(x, y, 0, MovPos[lxy], content, cut_mode);

		if (content == EL_ACID)
		{
			int dir = MovDir[lxy];
			int newlx = lx + (dir == MV_LEFT ? -1 : dir == MV_RIGHT ? +1 : 0);
			int newly = ly + (dir == MV_UP   ? -1 : dir == MV_DOWN  ? +1 : 0);
//bugd("content EL_ACID",x);
			DrawLevelElementThruMask(newlx, newly, EL_ACID);
		}
	}
	else if (IS_BLOCKED(lxy))
	{
		int sx, sy;
		int horiz_move;
		boolean cut_mode = NO_CUTTING;
		int element_old, content_old;
		short int oldxy;

		Blocked2Moving(lxy, &oldxy);
		sx = SCREENX(A1TOX(oldxy));
		sy = SCREENY(A1TOY(oldxy));

		horiz_move = (MovDir[oldxy] == MV_LEFT ||
							MovDir[oldxy] == MV_RIGHT);
		element_old = Feld[oldxy];
		content_old = Store[oldxy];

		if (element_old == EL_QUICKSAND_EMPTYING ||
					element_old == EL_MAGIC_WALL_EMPTYING ||
					element_old == EL_BD_MAGIC_WALL_EMPTYING ||
					element_old == EL_AMOEBA_DROPPING)
			cut_mode = CUT_ABOVE;

		DrawScreenElement(x, y, EL_EMPTY);

		if (horiz_move)
			DrawScreenElementShifted(sx, sy, MovPos[oldxy], 0, element_old,
																	NO_CUTTING);
		else if (cut_mode == NO_CUTTING)
			DrawScreenElementShifted(sx, sy, 0, MovPos[oldxy], element_old,
																	  cut_mode);
		else
			DrawScreenElementShifted(sx, sy, 0, MovPos[oldxy], content_old,
																	  cut_mode);
	}
	else if (IS_DRAWABLE(element))
		DrawScreenElement(x, y, element);
	else
		DrawScreenElement(x, y, EL_EMPTY);
}

void DrawLevelField(int x, int y)
{
	short int xy=A2TO1(x,y);
	if (IN_SCR_FIELD(SCREENX(x), SCREENY(y)))
		DrawScreenField(SCREENX(x), SCREENY(y));
	else if (IS_MOVING(xy))
	{
		short int newxy;
		int scr_newx, scr_newy;

		Moving2Blocked(xy, &newxy);
		scr_newx=SCREENX(A1TOX(newxy));
		scr_newy=SCREENY(A1TOY(newxy));

		if (IN_SCR_FIELD(scr_newx, scr_newy))
			DrawScreenField(scr_newx, scr_newy);
	}
	else if (IS_BLOCKED(xy))
	{
		short int oldxy;
		int scr_oldx, scr_oldy;

		Blocked2Moving(xy, &oldxy);
		scr_oldx=SCREENX(A1TOX(oldxy));
		scr_oldy=SCREENY(A1TOY(oldxy));

		if (IN_SCR_FIELD(scr_oldx, scr_oldy))
			DrawScreenField(scr_oldx, scr_oldy);
	}
}

void ShowEnvelope(int envelope_nr)
{/*
	int element = EL_ENVELOPE_1 + envelope_nr;
	int graphic = IMG_BACKGROUND_ENVELOPE_1 + envelope_nr;
	boolean ffwd_delay = (tape.playing && tape.fast_forward);
	boolean no_delay = (tape.warp_forward);
	int normal_delay_value = ONE_SECOND_DELAY / (ffwd_delay ? 2 : 1);
	int wait_delay_value = (no_delay ? 0 : normal_delay_value);
	int anim_mode = graphic_info[graphic].anim_mode;
	int main_anim_mode = (anim_mode == ANIM_NONE ? ANIM_VERTICAL|ANIM_HORIZONTAL:
						  anim_mode == ANIM_DEFAULT ? ANIM_VERTICAL : anim_mode);

	game.envelope_active = TRUE;	// needed for RedrawPlayfield() events

	if (anim_mode == ANIM_DEFAULT)
		AnimateEnvelope(envelope_nr, ANIM_DEFAULT, ACTION_OPENING);

	AnimateEnvelope(envelope_nr, main_anim_mode, ACTION_OPENING);

	if (tape.playing)
		Delay(wait_delay_value);
	else
		WaitForEventToContinue();

	if (anim_mode != ANIM_NONE)
		AnimateEnvelope(envelope_nr, main_anim_mode, ACTION_CLOSING);

	if (anim_mode == ANIM_DEFAULT)
		AnimateEnvelope(envelope_nr, ANIM_DEFAULT, ACTION_CLOSING);
*/
	game.envelope_active = FALSE;

	SetDrawtoField(DRAW_BUFFERED);

	redraw_mask |= REDRAW_FIELD;
	BackToFront();
}

void DrawLevel()
{
	int x,y;

	SetDrawBackgroundMask(REDRAW_NONE);
	ClearWindow();

	for (x = BX1; x <= BX2; x++)
		for (y = BY1; y <= BY2; y++)
			DrawScreenField(x, y);

	redraw_mask |= REDRAW_FIELD;
}

unsigned int OpenDoor(unsigned int door_state)
{
	unsigned int new_door_state;

	if (door_state & DOOR_COPY_BACK)
	{
/*		BlitBitmap(bitmap_db_door, bitmap_db_door,
					DOOR_GFX_PAGEX2, DOOR_GFX_PAGEY1, DXSIZE, DYSIZE + VYSIZE,
					DOOR_GFX_PAGEX1, DOOR_GFX_PAGEY1);
*/		door_state &= ~DOOR_COPY_BACK;
	}

	new_door_state = MoveDoor(door_state);

	return(new_door_state);
}

unsigned int CloseDoor(unsigned int door_state)
{
	unsigned int new_door_state;

/*	BlitBitmap(backbuffer, bitmap_db_door,
				DX, DY, DXSIZE, DYSIZE, DOOR_GFX_PAGEX1, DOOR_GFX_PAGEY1);
	BlitBitmap(backbuffer, bitmap_db_door,
				VX, VY, VXSIZE, VYSIZE, DOOR_GFX_PAGEX1, DOOR_GFX_PAGEY2);
*/
	new_door_state = MoveDoor(door_state);

	return(new_door_state);
}

unsigned int MoveDoor(unsigned int door_state)
{
	static int door1 = DOOR_OPEN_1;
	static int door2 = DOOR_CLOSE_2;
	unsigned long door_delay = 0;
	unsigned long door_delay_value;
	int stepsize = 1;

	if (door_state == DOOR_GET_STATE)
		return(door1 | door2);

	if (door_state & DOOR_SET_STATE)
	{
		if (door_state & DOOR_ACTION_1)
			door1 = door_state & DOOR_ACTION_1;
		if (door_state & DOOR_ACTION_2)
			door2 = door_state & DOOR_ACTION_2;

		return(door1 | door2);
	}

	if (door1 == DOOR_OPEN_1 && door_state & DOOR_OPEN_1)
		door_state &= ~DOOR_OPEN_1;
	else if (door1 == DOOR_CLOSE_1 && door_state & DOOR_CLOSE_1)
		door_state &= ~DOOR_CLOSE_1;
	if (door2 == DOOR_OPEN_2 && door_state & DOOR_OPEN_2)
		door_state &= ~DOOR_OPEN_2;
	else if (door2 == DOOR_CLOSE_2 && door_state & DOOR_CLOSE_2)
		door_state &= ~DOOR_CLOSE_2;

	door_delay_value = (door_state & DOOR_ACTION_1 ? door_1.step_delay :
													 door_2.step_delay);

/*	if (setup.quick_doors)
	{
		stepsize = 20;		// must be choosen to always draw last frame
		door_delay_value = 0;
	}

	if (global.autoplay_leveldir)
	{
		door_state |= DOOR_NO_DELAY;
		door_state &= ~DOOR_CLOSE_ALL;
	}

	if (door_state & DOOR_ACTION)
	{
		boolean door_1_done = !(door_state & DOOR_ACTION_1);
		boolean door_2_done = !(door_state & DOOR_ACTION_2);
		int start = ((door_state & DOOR_NO_DELAY) ? DXSIZE : 0);
		int end = (door_state & DOOR_ACTION_1 &&
						door_1.anim_mode == ANIM_VERTICAL ? DYSIZE : DXSIZE);
		int x;

		for (x = start; x <= end && !(door_1_done && door_2_done); x += stepsize)
		{
			Bitmap *bitmap = graphic_info[IMG_GLOBAL_DOOR].bitmap;
			GC gc = bitmap->stored_clip_gc;

			if (door_state & DOOR_ACTION_1)
			{
				int a = MIN(x * door_1.step_offset, end);
				int i = (door_state & DOOR_OPEN_1 ? end - a : a);

				if (x <= a)
	{
	  BlitBitmap(bitmap_db_door, drawto,
		     DOOR_GFX_PAGEX1, DOOR_GFX_PAGEY1 + i / 2,
		     DXSIZE,DYSIZE - i / 2, DX, DY);

	  ClearRectangle(drawto, DX, DY + DYSIZE - i / 2, DXSIZE, i / 2);
	}

	if (door_1.anim_mode == ANIM_HORIZONTAL && x <= DXSIZE)
	{
	  int src1_x = DXSIZE,		src1_y = DOOR_GFX_PAGEY1;
	  int dst1_x = DX + DXSIZE - i,	dst1_y = DY;
	  int src2_x = DXSIZE - i,	src2_y = DOOR_GFX_PAGEY1;
	  int dst2_x = DX,		dst2_y = DY;
	  int width = i, height = DYSIZE;

	  SetClipOrigin(bitmap, gc, dst1_x - src1_x, dst1_y - src1_y);
	  BlitBitmapMasked(bitmap, drawto, src1_x, src1_y, width, height,
			   dst1_x, dst1_y);

	  SetClipOrigin(bitmap, gc, dst2_x - src2_x, dst2_y - src2_y);
	  BlitBitmapMasked(bitmap, drawto, src2_x, src2_y, width, height,
			   dst2_x, dst2_y);
	}
	else if (door_1.anim_mode == ANIM_VERTICAL && x <= DYSIZE)
	{
	  int src1_x = DXSIZE,		src1_y = DOOR_GFX_PAGEY1;
	  int dst1_x = DX,		dst1_y = DY + DYSIZE - i;
	  int src2_x = 0,		src2_y = DOOR_GFX_PAGEY1 + DYSIZE - i;
	  int dst2_x = DX,		dst2_y = DY;
	  int width = DXSIZE, height = i;

	  SetClipOrigin(bitmap, gc, dst1_x - src1_x, dst1_y - src1_y);
	  BlitBitmapMasked(bitmap, drawto, src1_x, src1_y, width, height,
			   dst1_x, dst1_y);

	  SetClipOrigin(bitmap, gc, dst2_x - src2_x, dst2_y - src2_y);
	  BlitBitmapMasked(bitmap, drawto, src2_x, src2_y, width, height,
			   dst2_x, dst2_y);
	}
	else if (x <= DXSIZE)	// ANIM_DEFAULT
	{
	  int j = (door_1.anim_mode == ANIM_DEFAULT ? (DXSIZE - i) / 3 : 0);

	  SetClipOrigin(bitmap, gc, DX - i, (DY + j) - DOOR_GFX_PAGEY1);
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE, DOOR_GFX_PAGEY1, i, 77,
			   DX + DXSIZE - i, DY + j);
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE, DOOR_GFX_PAGEY1 + 140, i, 63,
			   DX + DXSIZE - i, DY + 140 + j);
	  SetClipOrigin(bitmap, gc, DX - DXSIZE + i,
			DY - (DOOR_GFX_PAGEY1 + j));
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE - i, DOOR_GFX_PAGEY1 + j, i, 77 - j,
			   DX, DY);
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE-i, DOOR_GFX_PAGEY1 + 140, i, 63,
			   DX, DY + 140 - j);

	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE - i, DOOR_GFX_PAGEY1 + 77, i, 63,
			   DX, DY + 77 - j);
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE - i, DOOR_GFX_PAGEY1 + 203, i, 77,
			   DX, DY + 203 - j);
	  SetClipOrigin(bitmap, gc, DX - i, (DY + j) - DOOR_GFX_PAGEY1);
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE, DOOR_GFX_PAGEY1 + 77, i, 63,
			   DX + DXSIZE - i, DY + 77 + j);
	  BlitBitmapMasked(bitmap, drawto,
			   DXSIZE, DOOR_GFX_PAGEY1 + 203, i, 77 - j,
			   DX + DXSIZE - i, DY + 203 + j);
	}

	redraw_mask |= REDRAW_DOOR_1;
	door_1_done = (a == end);
      }

      if (door_state & DOOR_ACTION_2)
      {
	int a = MIN(x * door_2.step_offset, VXSIZE);
	int i = (door_state & DOOR_OPEN_2 ? VXSIZE - a : a);

	if (x <= VYSIZE)
	{
	  BlitBitmap(bitmap_db_door, drawto,
		     DOOR_GFX_PAGEX1, DOOR_GFX_PAGEY2 + i / 2,
		     VXSIZE, VYSIZE - i / 2, VX, VY);

	  ClearRectangle(drawto, VX, VY + VYSIZE - i / 2, VXSIZE, i / 2);
	}

	if (door_2.anim_mode == ANIM_HORIZONTAL && x <= VXSIZE)
	{
	  int src1_x = VXSIZE,		src1_y = DOOR_GFX_PAGEY2;
	  int dst1_x = VX + VXSIZE - i,	dst1_y = VY;
	  int src2_x = VXSIZE - i,	src2_y = DOOR_GFX_PAGEY2;
	  int dst2_x = VX,		dst2_y = VY;
	  int width = i, height = VYSIZE;

	  SetClipOrigin(bitmap, gc, dst1_x - src1_x, dst1_y - src1_y);
	  BlitBitmapMasked(bitmap, drawto, src1_x, src1_y, width, height,
			   dst1_x, dst1_y);

	  SetClipOrigin(bitmap, gc, dst2_x - src2_x, dst2_y - src2_y);
	  BlitBitmapMasked(bitmap, drawto, src2_x, src2_y, width, height,
			   dst2_x, dst2_y);
	}
	else if (door_2.anim_mode == ANIM_VERTICAL && x <= VYSIZE)
	{
	  int src1_x = VXSIZE,		src1_y = DOOR_GFX_PAGEY2;
	  int dst1_x = VX,		dst1_y = VY + VYSIZE - i;
	  int src2_x = 0,		src2_y = DOOR_GFX_PAGEY2 + VYSIZE - i;
	  int dst2_x = VX,		dst2_y = VY;
	  int width = VXSIZE, height = i;

	  SetClipOrigin(bitmap, gc, dst1_x - src1_x, dst1_y - src1_y);
	  BlitBitmapMasked(bitmap, drawto, src1_x, src1_y, width, height,
			   dst1_x, dst1_y);

	  SetClipOrigin(bitmap, gc, dst2_x - src2_x, dst2_y - src2_y);
	  BlitBitmapMasked(bitmap, drawto, src2_x, src2_y, width, height,
			   dst2_x, dst2_y);
	}
	else if (x <= VXSIZE)	// ANIM_DEFAULT
	{
	  int j = (door_2.anim_mode == ANIM_DEFAULT ? (VXSIZE - i) / 3 : 0);

	  SetClipOrigin(bitmap, gc, VX - i, (VY + j) - DOOR_GFX_PAGEY2);
	  BlitBitmapMasked(bitmap, drawto,
			   VXSIZE, DOOR_GFX_PAGEY2, i, VYSIZE / 2,
			   VX + VXSIZE - i, VY + j);
	  SetClipOrigin(bitmap, gc,
			VX - VXSIZE + i, VY - (DOOR_GFX_PAGEY2 + j));
	  BlitBitmapMasked(bitmap, drawto,
			   VXSIZE - i, DOOR_GFX_PAGEY2 + j, i, VYSIZE / 2 - j,
			   VX, VY);

	  BlitBitmapMasked(bitmap, drawto,
			   VXSIZE - i, DOOR_GFX_PAGEY2 + VYSIZE / 2,
			   i, VYSIZE / 2, VX, VY + VYSIZE / 2 - j);
	  SetClipOrigin(bitmap, gc, VX - i, (VY + j) - DOOR_GFX_PAGEY2);
	  BlitBitmapMasked(bitmap, drawto,
			   VXSIZE, DOOR_GFX_PAGEY2 + VYSIZE / 2,
			   i, VYSIZE / 2 - j,
			   VX + VXSIZE - i, VY + VYSIZE / 2 + j);
	}

	redraw_mask |= REDRAW_DOOR_2;
	door_2_done = (a == VXSIZE);
      }

      BackToFront();

      if (game_status == GAME_MODE_MAIN)
	DoAnimation();

      if (!(door_state & DOOR_NO_DELAY))
	WaitUntilDelayReached(&door_delay, door_delay_value);
    }
  }
*/
	if (door_state & DOOR_ACTION_1)
		door1 = door_state & DOOR_ACTION_1;
	if (door_state & DOOR_ACTION_2)
		door2 = door_state & DOOR_ACTION_2;

	return (door1 | door2);
}

int el_act_dir2img(int element, int action, int direction)
{
/*	element = GFX_ELEMENT(element);
	direction = MV_DIR_BIT(direction);	// default: MV_NO_MOVING => MV_DOWN

	return element_info[element].direction_graphic[action][direction];*/
	return 0;//palm only now!!!
}

/*
int el_act2crm(int element, int action)
{
	element = GFX_ELEMENT(element);

	return element_info[element].crumbled[action];
}
*/

boolean ActionGraphicExist(short int element, char action)
{
	int i=element_infoF->other_graphic_index[element];
	int sz=i+element_infoF->other_graphic_size[element];

	if( sz==i || action==ACTION_DEFAULT )
		return FALSE;

	for(;i<sz;i++)
		if(element_graphic_infoF->action[i]==action)
			return TRUE;

	return FALSE;
}

short int GetExplodingGfx(short int element)
{
	if(element==EL_SP_ELECTRON)
		return IMG_SP_ELECTRON_EXPLODING;
	if(IS_SP_ELEMENT(element))
		return IMG_SP_DEFAULT_EXPLODING;
	return IMG_DEFAULT_EXPLODING;
}

short int FindGfxValue(short int element, char action, char direction)
{
	int found_num = -1;
	int i=element_infoF->other_graphic_index[element];
	int sz=i+element_infoF->other_graphic_size[element];

	if( sz==i || (action==ACTION_DEFAULT && direction==0) )
		return element_infoF->def_graphic[element];//ALL DEFAULT, so no other graphic

	for(;i<sz;i++)
	{
		int dir_mask =0xFF; 
		int dir_bit = element_graphic_infoF->direction[i];
		int act_df = element_graphic_infoF->action[i];
		
		if(dir_bit>=0)
			dir_mask = 1 << dir_bit;
		
		if(act_df ==-1 && (direction & dir_mask))
			found_num = i;
			
		if(dir_bit==-1 && act_df==action)
			found_num = i;

		if((direction & dir_mask) && act_df==action)
			return element_graphic_infoF->graphic[i];
	}

	if(found_num>0)
		return element_graphic_infoF->graphic[found_num];
	else
		return element_infoF->def_graphic[element];
								//no other graphic for such direction and action
}

short int GetPlayerGfx(struct PlayerInfo *player)
{
	short int graphic = -1;
	short int element = player->element_nr;

	if (player->use_murphy_graphic)
		element = EL_SP_MURPHY;

	graphic = FindGfxValue(element, player->GfxAction,	player->MovDir);

	return graphic;
}