/* values for element/graphics mapping configuration (normal) */
const struct
{
	short int element;//was int
	char action;//was int
	char direction;//was int
//	boolean crumbled;
	short int graphic;//was int
}
element_to_graphic[] =
{
  {
    EL_BD_WALL,		-1, -1,// FALSE,
    IMG_BD_WALL
  },
  {
    EL_BD_ROCK,		-1, -1,// FALSE,
    IMG_BD_ROCK
  },
  {
    EL_BD_ROCK,				ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_BD_ROCK_MOVING_LEFT
  },
  {
    EL_BD_ROCK,				ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_BD_ROCK_MOVING_RIGHT
  },
  {
    EL_BD_ROCK,				ACTION_PUSHING, MV_BIT_LEFT, //FALSE,
    IMG_BD_ROCK_PUSHING_LEFT
  },
  {
    EL_BD_ROCK,				ACTION_PUSHING, MV_BIT_RIGHT, //FALSE,
    IMG_BD_ROCK_PUSHING_RIGHT
  },
  {
    EL_BD_DIAMOND,		-1, -1, //FALSE,
    IMG_BD_DIAMOND
  },
  {
    EL_BD_DIAMOND,			ACTION_MOVING, -1, //FALSE,
    IMG_BD_DIAMOND_MOVING
  },
  {
    EL_BD_DIAMOND,			ACTION_FALLING, -1, //FALSE,
    IMG_BD_DIAMOND_FALLING
  },
  {
    EL_BD_MAGIC_WALL,	-1, -1, //FALSE,
    IMG_BD_MAGIC_WALL
  },
/*  {
    EL_BD_MAGIC_WALL,			ACTION_ACTIVE, -1, FALSE,
    IMG_BD_MAGIC_WALL_ACTIVE
  },
  {
    EL_BD_MAGIC_WALL,			ACTION_FILLING, -1, FALSE,
    IMG_BD_MAGIC_WALL_FILLING
  },
  {
    EL_BD_MAGIC_WALL,			ACTION_EMPTYING, -1, FALSE,
    IMG_BD_MAGIC_WALL_EMPTYING
  },*/
/*  {
    EL_SP_DEFAULT,			ACTION_EXPLODING, -1, FALSE,
    IMG_SP_DEFAULT_EXPLODING
  },*/
  {
    EL_SP_BASE,			-1, -1, //FALSE,
    IMG_SP_BASE
  },
  {
    EL_SP_BASE,			ACTION_DIGGING, -1, //FALSE,
    IMG_SP_BASE
  },
  {
    EL_SP_ZONK,			-1, -1, //FALSE,
    IMG_SP_ZONK
  },
  {
    EL_SP_ZONK,				ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_SP_ZONK_MOVING_LEFT
  },
  {
    EL_SP_ZONK,				ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_ZONK_MOVING_RIGHT
  },
  {
    EL_SP_ZONK,				ACTION_PUSHING, MV_BIT_LEFT, //FALSE,
    IMG_SP_ZONK_PUSHING_LEFT
  },
  {
    EL_SP_ZONK,				ACTION_PUSHING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_ZONK_PUSHING_RIGHT
  },
  {
    EL_SP_MURPHY,		-1, -1, //FALSE,
    IMG_SP_MURPHY
  },
  {
    EL_SP_MURPHY,			ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_SP_MURPHY_MOVING_LEFT
  },
  {
    EL_SP_MURPHY,			ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_MURPHY_MOVING_RIGHT
  },
  {
    EL_SP_MURPHY,			ACTION_DIGGING, MV_BIT_LEFT, //FALSE,
    IMG_SP_MURPHY_DIGGING_LEFT
  },
  {
    EL_SP_MURPHY,			ACTION_DIGGING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_MURPHY_DIGGING_RIGHT
  },
  {
    EL_SP_MURPHY,			ACTION_COLLECTING, MV_BIT_LEFT, //FALSE,
    IMG_SP_MURPHY_COLLECTING_LEFT
  },
  {
    EL_SP_MURPHY,			ACTION_COLLECTING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_MURPHY_COLLECTING_RIGHT
  },
  {
    EL_SP_MURPHY,			ACTION_PUSHING, MV_BIT_LEFT, //FALSE,
    IMG_SP_MURPHY_PUSHING_LEFT
  },
  {
    EL_SP_MURPHY,			ACTION_PUSHING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_MURPHY_PUSHING_RIGHT
  },
  {
    EL_SP_MURPHY,			ACTION_SNAPPING, MV_BIT_LEFT, //FALSE,
    IMG_SP_MURPHY_SNAPPING_LEFT
  },
  {
    EL_SP_MURPHY,			ACTION_SNAPPING, MV_BIT_RIGHT, //FALSE,
    IMG_SP_MURPHY_SNAPPING_RIGHT
  },
  {
    EL_SP_MURPHY,			ACTION_SNAPPING, MV_BIT_UP, //FALSE,
    IMG_SP_MURPHY_SNAPPING_UP
  },
  {
    EL_SP_MURPHY,			ACTION_SNAPPING, MV_BIT_DOWN, //FALSE,
    IMG_SP_MURPHY_SNAPPING_DOWN
  },
  {
    EL_SP_INFOTRON,		-1, -1, //FALSE,
    IMG_SP_INFOTRON
  },
  {
    EL_SP_INFOTRON,		ACTION_COLLECTING, -1, //FALSE,
    IMG_SP_INFOTRON
  },
/*  {
    EL_SP_DISK_RED,			ACTION_COLLECTING, -1, FALSE,
    IMG_SP_DISK_RED_COLLECTING
  },*/
  {
    EL_SP_DISK_RED_ACTIVE,			-1, -1, //FALSE,
    IMG_SP_DISK_RED_ACTIVE
  },
/*  {
    EL_SP_DISK_RED,			ACTION_ACTIVE, -1, FALSE,
    IMG_SP_DISK_RED_ACTIVE
  },*/
  {
    EL_SP_SNIKSNAK,			-1, -1, //FALSE,
    IMG_SP_SNIKSNAK
  },
  {
    EL_SP_SNIKSNAK,			-1, MV_BIT_LEFT, //FALSE,
    IMG_SP_SNIKSNAK_LEFT
  },
  {
    EL_SP_SNIKSNAK,			-1, MV_BIT_RIGHT, //FALSE,
    IMG_SP_SNIKSNAK_RIGHT
  },
  {
    EL_SP_SNIKSNAK,			-1, MV_BIT_UP, //FALSE,
    IMG_SP_SNIKSNAK_UP
  },
  {
    EL_SP_SNIKSNAK,			-1, MV_BIT_DOWN, //FALSE,
    IMG_SP_SNIKSNAK_DOWN
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_LEFT, MV_BIT_UP, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_UP
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_LEFT, MV_BIT_DOWN, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_DOWN
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_RIGHT, MV_BIT_UP, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_RIGHT_UP
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_RIGHT, MV_BIT_DOWN, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_RIGHT_DOWN
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_UP, MV_BIT_LEFT, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_UP_LEFT
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_UP, MV_BIT_RIGHT, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_UP_RIGHT
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_DOWN, MV_BIT_LEFT, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_DOWN_LEFT
  },
  {
    EL_SP_SNIKSNAK,			ACTION_TURNING_FROM_DOWN, MV_BIT_RIGHT, //FALSE,
    IMG_SP_SNIKSNAK_TURNING_FROM_DOWN_RIGHT
  },
  {
    EL_SP_ELECTRON,		-1, -1, //FALSE,
    IMG_SP_ELECTRON
  },
/*  {
    EL_SP_ELECTRON,			ACTION_EXPLODING, -1, FALSE,
    IMG_SP_ELECTRON_EXPLODING
  },*/
  {
    EL_SP_TERMINAL,		-1, -1, //FALSE,
    IMG_SP_TERMINAL
  },
/*  {
    EL_SP_TERMINAL,			ACTION_ACTIVE, -1, FALSE,
    IMG_SP_TERMINAL_ACTIVE
  },*/
  {
    EL_SP_BUGGY_BASE,		-1, -1, //FALSE,
    IMG_SP_BUGGY_BASE
  },
  {
    EL_SP_BUGGY_BASE_ACTIVATING,	-1, -1, //FALSE,
    IMG_SP_BUGGY_BASE_ACTIVATING
  },
/*  {
    EL_SP_BUGGY_BASE,			ACTION_ACTIVATING, -1, FALSE,
    IMG_SP_BUGGY_BASE_ACTIVATING
  },*/
  {
    EL_SP_BUGGY_BASE_ACTIVE,		-1, -1, //FALSE,
    IMG_SP_BUGGY_BASE_ACTIVE
  },
/*  {
    EL_SP_BUGGY_BASE,			ACTION_ACTIVE, -1, FALSE,
    IMG_SP_BUGGY_BASE_ACTIVE
  },*/
  {
    EL_SAND,		-1, -1, //FALSE,
    IMG_SAND
  },
/*  {
    EL_SAND,				-1, -1, TRUE,
    IMG_SAND_CRUMBLED
  },*/
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_LEFT, //FALSE,
    IMG_SAND_DIGGING_LEFT
  },
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_RIGHT, //FALSE,
    IMG_SAND_DIGGING_RIGHT
  },
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_UP, //FALSE,
    IMG_SAND_DIGGING_UP
  },
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_DOWN, //FALSE,
    IMG_SAND_DIGGING_DOWN
  },
/*  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_LEFT, TRUE,
    IMG_SAND_DIGGING_LEFT_CRUMBLED
  },
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_RIGHT, TRUE,
    IMG_SAND_DIGGING_RIGHT_CRUMBLED
  },
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_UP, TRUE,
    IMG_SAND_DIGGING_UP_CRUMBLED
  },
  {
    EL_SAND,				ACTION_DIGGING, MV_BIT_DOWN, TRUE,
    IMG_SAND_DIGGING_DOWN_CRUMBLED
  },*/
  {
    EL_ROCK,		-1, -1, //FALSE,
    IMG_ROCK
  },
  {
    EL_ROCK,				ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_ROCK_MOVING_LEFT
  },
  {
    EL_ROCK,				ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_ROCK_MOVING_RIGHT
  },
  {
    EL_ROCK,				ACTION_PUSHING, MV_BIT_LEFT, //FALSE,
    IMG_ROCK_PUSHING_LEFT
  },
  {
    EL_ROCK,				ACTION_PUSHING, MV_BIT_RIGHT, //FALSE,
    IMG_ROCK_PUSHING_RIGHT
  },
  {
    EL_EMERALD,			-1, -1, //FALSE,
    IMG_EMERALD
  },
  {
    EL_EMERALD,				ACTION_MOVING, -1, //FALSE,
    IMG_EMERALD_MOVING
  },
  {
    EL_EMERALD,				ACTION_FALLING, -1, //FALSE,
    IMG_EMERALD_FALLING
  },
  {
    EL_EMERALD,				ACTION_COLLECTING, -1, //FALSE,
    IMG_EMERALD_COLLECTING
  },
  {
    EL_DIAMOND,			-1, -1, //FALSE,
    IMG_DIAMOND
  },
  {
    EL_DIAMOND,				ACTION_MOVING, -1, //FALSE,
    IMG_DIAMOND_MOVING
  },
  {
    EL_DIAMOND,				ACTION_FALLING, -1, //FALSE,
    IMG_DIAMOND_FALLING
  },
  {
    EL_DIAMOND,				ACTION_COLLECTING, -1, //FALSE,
    IMG_DIAMOND_COLLECTING
  },
  {
    EL_BOMB,		-1, -1, //FALSE,
    IMG_BOMB
  },
  {
    EL_NUT,			-1, -1, //FALSE,
    IMG_NUT
  },
/*  {
    EL_NUT,				ACTION_BREAKING, -1, //FALSE,
    IMG_NUT_BREAKING
  },*/
  {
    EL_NUT_BREAKING,		-1, -1, //FALSE,
    IMG_NUT_BREAKING
  },
  {
    EL_DYNAMITE,		-1, -1, //FALSE,
    IMG_DYNAMITE
  },
  {
    EL_DYNAMITE_ACTIVE,			-1, -1, //FALSE,
    IMG_DYNAMITE_ACTIVE
  },
/*  {
    EL_DYNAMITE,			ACTION_ACTIVE, -1, FALSE,
    IMG_DYNAMITE_ACTIVE
  },*/
  {
    EL_BUG,			-1, -1, //FALSE,
    IMG_BUG
  },
  {
    EL_BUG,				-1, MV_BIT_RIGHT, //FALSE,
    IMG_BUG_RIGHT
  },
  {
    EL_BUG,				-1, MV_BIT_UP, //FALSE,
    IMG_BUG_UP
  },
  {
    EL_BUG,				-1, MV_BIT_LEFT, //FALSE,
    IMG_BUG_LEFT
  },
  {
    EL_BUG,				-1, MV_BIT_DOWN, //FALSE,
    IMG_BUG_DOWN
  },
  {
    EL_BUG,				ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_BUG_MOVING_RIGHT
  },
  {
    EL_BUG,				ACTION_MOVING, MV_BIT_UP, //FALSE,
    IMG_BUG_MOVING_UP
  },
  {
    EL_BUG,				ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_BUG_MOVING_LEFT
  },
  {
    EL_BUG,				ACTION_MOVING, MV_BIT_DOWN, //FALSE,
    IMG_BUG_MOVING_DOWN
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_RIGHT, MV_BIT_UP, //FALSE,
    IMG_BUG_TURNING_FROM_RIGHT_UP
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_UP, MV_BIT_LEFT, //FALSE,
    IMG_BUG_TURNING_FROM_UP_LEFT
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_LEFT, MV_BIT_DOWN, //FALSE,
    IMG_BUG_TURNING_FROM_LEFT_DOWN
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_DOWN, MV_BIT_RIGHT, //FALSE,
    IMG_BUG_TURNING_FROM_DOWN_RIGHT
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_RIGHT, MV_BIT_DOWN, //FALSE,
    IMG_BUG_TURNING_FROM_RIGHT_DOWN
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_UP, MV_BIT_RIGHT, //FALSE,
    IMG_BUG_TURNING_FROM_UP_RIGHT
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_LEFT, MV_BIT_UP, //FALSE,
    IMG_BUG_TURNING_FROM_LEFT_UP
  },
  {
    EL_BUG,				ACTION_TURNING_FROM_DOWN, MV_BIT_LEFT, //FALSE,
    IMG_BUG_TURNING_FROM_DOWN_LEFT
  },
  {
    EL_SPACESHIP,		-1, -1, //FALSE,
    IMG_SPACESHIP
  },
  {
    EL_SPACESHIP,			-1, MV_BIT_RIGHT, //FALSE,
    IMG_SPACESHIP_RIGHT
  },
  {
    EL_SPACESHIP,			-1, MV_BIT_UP, //FALSE,
    IMG_SPACESHIP_UP
  },
  {
    EL_SPACESHIP,			-1, MV_BIT_LEFT, //FALSE,
    IMG_SPACESHIP_LEFT
  },
  {
    EL_SPACESHIP,			-1, MV_BIT_DOWN, //FALSE,
    IMG_SPACESHIP_DOWN
  },
  {
    EL_SPACESHIP,			ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_SPACESHIP_MOVING_RIGHT
  },
  {
    EL_SPACESHIP,			ACTION_MOVING, MV_BIT_UP, //FALSE,
    IMG_SPACESHIP_MOVING_UP
  },
  {
    EL_SPACESHIP,			ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_SPACESHIP_MOVING_LEFT
  },
  {
    EL_SPACESHIP,			ACTION_MOVING, MV_BIT_DOWN, //FALSE,
    IMG_SPACESHIP_MOVING_DOWN
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_RIGHT, MV_BIT_UP, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_RIGHT_UP
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_UP, MV_BIT_LEFT, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_UP_LEFT
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_LEFT, MV_BIT_DOWN, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_LEFT_DOWN
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_DOWN, MV_BIT_RIGHT, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_DOWN_RIGHT
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_RIGHT, MV_BIT_DOWN, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_RIGHT_DOWN
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_UP, MV_BIT_RIGHT, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_UP_RIGHT
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_LEFT, MV_BIT_UP, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_LEFT_UP
  },
  {
    EL_SPACESHIP,			ACTION_TURNING_FROM_DOWN, MV_BIT_LEFT, //FALSE,
    IMG_SPACESHIP_TURNING_FROM_DOWN_LEFT
  },
  {
    EL_YAMYAM,		-1, -1, //FALSE,
    IMG_YAMYAM
  },
  {
    EL_YAMYAM,				ACTION_MOVING, -1, //FALSE,
    IMG_YAMYAM_MOVING
  },
  {
    EL_ROBOT,		-1, -1, //FALSE,
    IMG_ROBOT
  },
  {
    EL_ROBOT,				ACTION_MOVING, -1, //FALSE,
    IMG_ROBOT_MOVING
  },
  {
    EL_ROBOT_WHEEL,		-1, -1, //FALSE,
    IMG_ROBOT_WHEEL
  },
  {
    EL_ROBOT_WHEEL_ACTIVE,		-1, -1, //FALSE,
    IMG_ROBOT_WHEEL_ACTIVE
  },
/*  {
    EL_ROBOT_WHEEL,			ACTION_ACTIVE, -1, FALSE,
    IMG_ROBOT_WHEEL_ACTIVE
  },*/
  {
    EL_MAGIC_WALL,		-1, -1, //FALSE,
    IMG_MAGIC_WALL
  },
  {
    EL_MAGIC_WALL_ACTIVE,	-1, -1, //FALSE,
    IMG_MAGIC_WALL_ACTIVE
  },
/*  {
    EL_MAGIC_WALL,			ACTION_ACTIVE, -1, FALSE,
    IMG_MAGIC_WALL_ACTIVE
  },*/
  {
    EL_MAGIC_WALL_FILLING,		-1, -1, //FALSE,
    IMG_MAGIC_WALL_FILLING
  },
/*  {
    EL_MAGIC_WALL,			ACTION_FILLING, -1, FALSE,
    IMG_MAGIC_WALL_FILLING
  },*/
  {
    EL_MAGIC_WALL_FULL,		-1, -1, //FALSE,
    IMG_MAGIC_WALL_FULL
  },
  {
    EL_MAGIC_WALL_EMPTYING,		-1, -1, //FALSE,
    IMG_MAGIC_WALL_EMPTYING
  },
/*  {
    EL_MAGIC_WALL,			ACTION_EMPTYING, -1, FALSE,
    IMG_MAGIC_WALL_EMPTYING
  },*/
  {
    EL_MAGIC_WALL_DEAD,		-1, -1, //FALSE,
    IMG_MAGIC_WALL_DEAD
  },
  {
    EL_AMOEBA_GROWING,		-1, -1, //FALSE,
    IMG_AMOEBA_GROWING
  },
/*  {
    EL_AMOEBA,				ACTION_GROWING, -1, FALSE,
    IMG_AMOEBA_GROWING
  },*/
  {
    EL_AMOEBA_SHRINKING,	-1, -1, //FALSE,
    IMG_AMOEBA_SHRINKING
  },
/*  {
    EL_AMOEBA,				ACTION_SHRINKING, -1, FALSE,
    IMG_AMOEBA_SHRINKING
  },*/
  {
    EL_AMOEBA_WET,		-1, -1, //FALSE,
    IMG_AMOEBA_WET
  },
  {
    EL_AMOEBA_DROPPING,		-1, -1, //FALSE,
    IMG_AMOEBA_DROPPING
  },
/*  {
    EL_AMOEBA,				ACTION_DROPPING, -1, FALSE,
    IMG_AMOEBA_DROPPING
  },*/
  {
    EL_BALLOON,			-1, -1, //FALSE,
    IMG_BALLOON
  },
  {
    EL_BALLOON,				ACTION_MOVING, -1, //FALSE,
    IMG_BALLOON_MOVING
  },
  {
    EL_BALLOON,				ACTION_PUSHING, -1, //FALSE,
    IMG_BALLOON_PUSHING
  },
  {
    EL_BALLOON_SWITCH_LEFT,		-1, -1, //FALSE,
    IMG_BALLOON_SWITCH_LEFT
  },
  {
    EL_BALLOON_SWITCH_RIGHT,	-1, -1, //FALSE,
    IMG_BALLOON_SWITCH_RIGHT
  },
  {
    EL_BALLOON_SWITCH_UP,	-1, -1, //FALSE,
    IMG_BALLOON_SWITCH_UP
  },
  {
    EL_BALLOON_SWITCH_DOWN,		-1, -1, //FALSE,
    IMG_BALLOON_SWITCH_DOWN
  },
  {
    EL_BALLOON_SWITCH_ANY,	-1, -1, //FALSE,
    IMG_BALLOON_SWITCH_ANY
  },
  {
    EL_INVISIBLE_STEELWALL_ACTIVE,	-1, -1, //FALSE,
    IMG_INVISIBLE_STEELWALL_ACTIVE
  },
/*  {
    EL_INVISIBLE_STEELWALL,		ACTION_ACTIVE, -1, FALSE,
    IMG_INVISIBLE_STEELWALL_ACTIVE
  },*/
  {
    EL_INVISIBLE_WALL_ACTIVE,		-1, -1, //FALSE,
    IMG_INVISIBLE_WALL_ACTIVE
  },
/*  {
    EL_INVISIBLE_WALL,			ACTION_ACTIVE, -1, FALSE,
    IMG_INVISIBLE_WALL_ACTIVE
  },*/
  {
    EL_INVISIBLE_SAND_ACTIVE,		-1, -1, //FALSE,
    IMG_INVISIBLE_SAND_ACTIVE
  },
/*  {
    EL_INVISIBLE_SAND,			ACTION_ACTIVE, -1, FALSE,
    IMG_INVISIBLE_SAND_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_1_MIDDLE,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_1_MIDDLE_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_MIDDLE_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_1_MIDDLE,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_1_MIDDLE_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_1_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_LEFT
  },
  {
    EL_CONVEYOR_BELT_1_LEFT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_LEFT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_1_LEFT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_1_LEFT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_1_RIGHT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_RIGHT
  },
  {
    EL_CONVEYOR_BELT_1_RIGHT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_RIGHT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_1_RIGHT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_1_RIGHT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_1_SWITCH_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_SWITCH_LEFT
  },
  {
    EL_CONVEYOR_BELT_1_SWITCH_MIDDLE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_SWITCH_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_1_SWITCH_RIGHT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_1_SWITCH_RIGHT
  },
  {
    EL_CONVEYOR_BELT_2_MIDDLE,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_2_MIDDLE_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_MIDDLE_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_2_MIDDLE,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_2_MIDDLE_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_2_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_LEFT
  },
  {
    EL_CONVEYOR_BELT_2_LEFT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_LEFT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_2_LEFT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_2_LEFT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_2_RIGHT,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_RIGHT
  },
  {
    EL_CONVEYOR_BELT_2_RIGHT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_RIGHT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_2_RIGHT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_2_RIGHT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_2_SWITCH_LEFT,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_SWITCH_LEFT
  },
  {
    EL_CONVEYOR_BELT_2_SWITCH_MIDDLE,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_SWITCH_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_2_SWITCH_RIGHT,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_2_SWITCH_RIGHT
  },
  {
    EL_CONVEYOR_BELT_3_MIDDLE,			-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_3_MIDDLE_ACTIVE,		-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_MIDDLE_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_3_MIDDLE,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_3_MIDDLE_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_3_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_LEFT
  },
  {
    EL_CONVEYOR_BELT_3_LEFT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_LEFT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_3_LEFT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_3_LEFT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_3_RIGHT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_RIGHT
  },
  {
    EL_CONVEYOR_BELT_3_RIGHT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_RIGHT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_3_RIGHT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_3_RIGHT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_3_SWITCH_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_SWITCH_LEFT
  },
  {
    EL_CONVEYOR_BELT_3_SWITCH_MIDDLE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_SWITCH_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_3_SWITCH_RIGHT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_3_SWITCH_RIGHT
  },
  {
    EL_CONVEYOR_BELT_4_MIDDLE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_4_MIDDLE_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_MIDDLE_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_4_MIDDLE,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_4_MIDDLE_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_4_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_LEFT
  },
  {
    EL_CONVEYOR_BELT_4_LEFT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_LEFT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_4_LEFT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_4_LEFT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_4_RIGHT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_RIGHT
  },
  {
    EL_CONVEYOR_BELT_4_RIGHT_ACTIVE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_RIGHT_ACTIVE
  },
/*  {
    EL_CONVEYOR_BELT_4_RIGHT,		ACTION_ACTIVE, -1, FALSE,
    IMG_CONVEYOR_BELT_4_RIGHT_ACTIVE
  },*/
  {
    EL_CONVEYOR_BELT_4_SWITCH_LEFT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_SWITCH_LEFT
  },
  {
    EL_CONVEYOR_BELT_4_SWITCH_MIDDLE,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_SWITCH_MIDDLE
  },
  {
    EL_CONVEYOR_BELT_4_SWITCH_RIGHT,	-1, -1, //FALSE,
    IMG_CONVEYOR_BELT_4_SWITCH_RIGHT
  },
  {
    EL_SWITCHGATE_SWITCH_UP,	-1, -1, //FALSE,
    IMG_SWITCHGATE_SWITCH_UP
  },
  {
    EL_SWITCHGATE_SWITCH_DOWN,	-1, -1, //FALSE,
    IMG_SWITCHGATE_SWITCH_DOWN
  },
  {
    EL_LIGHT_SWITCH,	-1, -1, //FALSE,
    IMG_LIGHT_SWITCH
  },
  {
    EL_LIGHT_SWITCH_ACTIVE,		-1, -1, //FALSE,
    IMG_LIGHT_SWITCH_ACTIVE
  },
/*  {
    EL_LIGHT_SWITCH,			ACTION_ACTIVE, -1, FALSE,
    IMG_LIGHT_SWITCH_ACTIVE
  },*/
  {
    EL_TIMEGATE_SWITCH,		-1, -1, //FALSE,
    IMG_TIMEGATE_SWITCH
  },
  {
    EL_TIMEGATE_SWITCH_ACTIVE,		-1, -1, //FALSE,
    IMG_TIMEGATE_SWITCH_ACTIVE
  },
/*  {
    EL_TIMEGATE_SWITCH,			ACTION_ACTIVE, -1, FALSE,
    IMG_TIMEGATE_SWITCH_ACTIVE
  },*/
  {
    EL_ENVELOPE_1,		-1, -1, //FALSE,
    IMG_ENVELOPE_1
  },
/*  {
    EL_ENVELOPE_1,			ACTION_COLLECTING, -1, FALSE,
    IMG_ENVELOPE_1_COLLECTING
  },*/
  {
    EL_ENVELOPE_2,		-1, -1, //FALSE,
    IMG_ENVELOPE_2
  },
/*  {
    EL_ENVELOPE_2,			ACTION_COLLECTING, -1, FALSE,
    IMG_ENVELOPE_2_COLLECTING
  },*/
  {
    EL_ENVELOPE_3,		-1, -1, //FALSE,
    IMG_ENVELOPE_3
  },
/*  {
    EL_ENVELOPE_3,			ACTION_COLLECTING, -1, FALSE,
    IMG_ENVELOPE_3_COLLECTING
  },*/
  {
    EL_ENVELOPE_4,		-1, -1, //FALSE,
    IMG_ENVELOPE_4
  },
/*  {
    EL_ENVELOPE_4,			ACTION_COLLECTING, -1, FALSE,
    IMG_ENVELOPE_4_COLLECTING
  },*/
  {
    EL_SHIELD_NORMAL,		-1, -1, //FALSE,
    IMG_SHIELD_NORMAL
  },
  {
    EL_SHIELD_NORMAL_ACTIVE,		-1, -1, //FALSE,
    IMG_SHIELD_NORMAL_ACTIVE
  },
/*  {
    EL_SHIELD_NORMAL,			ACTION_ACTIVE, -1, FALSE,
    IMG_SHIELD_NORMAL_ACTIVE
  },*/
  {
    EL_SHIELD_DEADLY,		-1, -1, //FALSE,
    IMG_SHIELD_DEADLY
  },
  {
    EL_SHIELD_DEADLY_ACTIVE,	-1, -1, //FALSE,
    IMG_SHIELD_DEADLY_ACTIVE
  },
/*  {
    EL_SHIELD_DEADLY,			ACTION_ACTIVE, -1, FALSE,
    IMG_SHIELD_DEADLY_ACTIVE
  },*/
  {
    EL_PEARL,		-1, -1, //FALSE,
    IMG_PEARL
  },
/*  {
    EL_PEARL,				ACTION_BREAKING, -1, //FALSE,
    IMG_PEARL_BREAKING
  },*/
  {
    EL_PEARL_BREAKING,	-1, -1, //FALSE,
    IMG_PEARL_BREAKING
  },
  {
    EL_TRAP,		-1, -1, //FALSE,
    IMG_TRAP
  },
  {
    EL_TRAP_ACTIVE,		-1, -1, //FALSE,
    IMG_TRAP_ACTIVE
  },
/*  {
    EL_TRAP,				ACTION_ACTIVE, -1, FALSE,
    IMG_TRAP_ACTIVE
  },*/
  {
    EL_PACMAN,		-1, -1, //FALSE,
    IMG_PACMAN
  },
  {
    EL_PACMAN,				-1, MV_BIT_RIGHT, //FALSE,
    IMG_PACMAN_RIGHT
  },
  {
    EL_PACMAN,				-1, MV_BIT_UP, //FALSE,
    IMG_PACMAN_UP
  },
  {
    EL_PACMAN,				-1, MV_BIT_LEFT, //FALSE,
    IMG_PACMAN_LEFT
  },
  {
    EL_PACMAN,				-1, MV_BIT_DOWN, //FALSE,
    IMG_PACMAN_DOWN
  },
  {
    EL_PACMAN,				ACTION_TURNING_FROM_RIGHT, -1, //FALSE,
    IMG_PACMAN_TURNING_FROM_RIGHT
  },
  {
    EL_PACMAN,				ACTION_TURNING_FROM_UP, -1, //FALSE,
    IMG_PACMAN_TURNING_FROM_UP
  },
  {
    EL_PACMAN,				ACTION_TURNING_FROM_LEFT, -1, //FALSE,
    IMG_PACMAN_TURNING_FROM_LEFT
  },
  {
    EL_PACMAN,				ACTION_TURNING_FROM_DOWN, -1, //FALSE,
    IMG_PACMAN_TURNING_FROM_DOWN
  },
  {
    EL_LAMP,		-1, -1, //FALSE,
    IMG_LAMP
  },
  {
    EL_LAMP_ACTIVE,		-1, -1, //FALSE,
    IMG_LAMP_ACTIVE
  },
/*  {
    EL_LAMP,				ACTION_ACTIVE, -1, FALSE,
    IMG_LAMP_ACTIVE
  },*/
  {
    EL_EMERALD_YELLOW,	-1, -1, //FALSE,
    IMG_EMERALD_YELLOW
  },
  {
    EL_EMERALD_YELLOW,			ACTION_MOVING, -1, //FALSE,
    IMG_EMERALD_YELLOW_MOVING
  },
  {
    EL_EMERALD_YELLOW,			ACTION_FALLING, -1, //FALSE,
    IMG_EMERALD_YELLOW_FALLING
  },
  {
    EL_EMERALD_RED,		-1, -1, //FALSE,
    IMG_EMERALD_RED
  },
/*  {
    EL_EMERALD_RED,			ACTION_MOVING, -1, FALSE,
    IMG_EMERALD_RED_MOVING
  },
  {
    EL_EMERALD_RED,			ACTION_FALLING, -1, FALSE,
    IMG_EMERALD_RED_FALLING
  },*/
  {
    EL_EMERALD_PURPLE,		-1, -1, //FALSE,
    IMG_EMERALD_PURPLE
  },
/*  {
    EL_EMERALD_PURPLE,			ACTION_MOVING, -1, FALSE,
    IMG_EMERALD_PURPLE_MOVING
  },
  {
    EL_EMERALD_PURPLE,			ACTION_FALLING, -1, FALSE,
    IMG_EMERALD_PURPLE_FALLING
  },*/
  {
    EL_EXPANDABLE_WALL,		-1, -1, //FALSE,
    IMG_EXPANDABLE_WALL
  },
/*  {
    EL_EXPANDABLE_WALL,			ACTION_GROWING, MV_BIT_LEFT, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_LEFT
  },
  {
    EL_EXPANDABLE_WALL,			ACTION_GROWING, MV_BIT_RIGHT, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_RIGHT
  },
  {
    EL_EXPANDABLE_WALL,			ACTION_GROWING, MV_BIT_UP, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_UP
  },
  {
    EL_EXPANDABLE_WALL,			ACTION_GROWING, MV_BIT_DOWN, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_DOWN
  },*/
  {
    EL_EXPANDABLE_WALL_HORIZONTAL,	-1, -1, //FALSE,
    IMG_EXPANDABLE_WALL_HORIZONTAL
  },
  {
    EL_EXPANDABLE_WALL_VERTICAL,	-1, -1, //FALSE,
    IMG_EXPANDABLE_WALL_VERTICAL
  },
  {
    EL_EXPANDABLE_WALL_ANY,		-1, -1, //FALSE,
    IMG_EXPANDABLE_WALL_ANY
  },
  {
    EL_EXPANDABLE_WALL_GROWING,		-1, MV_BIT_LEFT, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_LEFT
  },
  {
    EL_EXPANDABLE_WALL_GROWING,		-1, MV_BIT_RIGHT, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_RIGHT
  },
  {
    EL_EXPANDABLE_WALL_GROWING,		-1, MV_BIT_UP, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_UP
  },
  {
    EL_EXPANDABLE_WALL_GROWING,		-1, MV_BIT_DOWN, //FALSE,
    IMG_EXPANDABLE_WALL_GROWING_DOWN
  },
  {
    EL_DARK_YAMYAM,		-1, -1, //FALSE,
    IMG_DARK_YAMYAM
  },
  {
    EL_DYNABOMB,	-1, -1, //FALSE,
    IMG_DYNABOMB
  },
  {
    EL_DYNABOMB_ACTIVE,		-1, -1, //FALSE,
    IMG_DYNABOMB_ACTIVE
  },
/*  {
    EL_DYNABOMB,			ACTION_ACTIVE, -1, FALSE,
    IMG_DYNABOMB_ACTIVE
  },*/
  {
    EL_DYNABOMB_PLAYER_1,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_1
  },
  {
    EL_DYNABOMB_PLAYER_1_ACTIVE,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_1_ACTIVE
  },
/*  {
    EL_DYNABOMB_PLAYER_1,		ACTION_ACTIVE, -1, FALSE,
    IMG_DYNABOMB_PLAYER_1_ACTIVE
  },*/
  {
    EL_DYNABOMB_PLAYER_2,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_2
  },
  {
    EL_DYNABOMB_PLAYER_2_ACTIVE,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_2_ACTIVE
  },
/*  {
    EL_DYNABOMB_PLAYER_2,		ACTION_ACTIVE, -1, FALSE,
    IMG_DYNABOMB_PLAYER_2_ACTIVE
  },*/
  {
    EL_DYNABOMB_PLAYER_3,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_3
  },
  {
    EL_DYNABOMB_PLAYER_3_ACTIVE,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_3_ACTIVE
  },
/*  {
    EL_DYNABOMB_PLAYER_3,		ACTION_ACTIVE, -1, FALSE,
    IMG_DYNABOMB_PLAYER_3_ACTIVE
  },*/
  {
    EL_DYNABOMB_PLAYER_4,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_4
  },
  {
    EL_DYNABOMB_PLAYER_4_ACTIVE,	-1, -1, //FALSE,
    IMG_DYNABOMB_PLAYER_4_ACTIVE
  },
/*  {
    EL_DYNABOMB_PLAYER_4,		ACTION_ACTIVE, -1, FALSE,
    IMG_DYNABOMB_PLAYER_4_ACTIVE
  },*/
  {
    EL_DYNABOMB_INCREASE_NUMBER,	-1, -1, //FALSE,
    IMG_DYNABOMB_INCREASE_NUMBER
  },
  {
    EL_DYNABOMB_INCREASE_SIZE,	-1, -1, //FALSE,
    IMG_DYNABOMB_INCREASE_SIZE
  },
  {
    EL_DYNABOMB_INCREASE_POWER,		-1, -1, //FALSE,
    IMG_DYNABOMB_INCREASE_POWER
  },
  {
    EL_PIG,		-1, -1, //FALSE,
    IMG_PIG
  },
  {
    EL_PIG,				-1, MV_BIT_DOWN, //FALSE,
    IMG_PIG_DOWN
  },
  {
    EL_PIG,				-1, MV_BIT_UP, //FALSE,
    IMG_PIG_UP
  },
  {
    EL_PIG,				-1, MV_BIT_LEFT, //FALSE,
    IMG_PIG_LEFT
  },
  {
    EL_PIG,				-1, MV_BIT_RIGHT, //FALSE,
    IMG_PIG_RIGHT
  },
/*  {
    EL_PIG,				ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_PIG_MOVING_DOWN
  },
  {
    EL_PIG,				ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_PIG_MOVING_UP
  },
  {
    EL_PIG,				ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_PIG_MOVING_LEFT
  },
  {
    EL_PIG,				ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_PIG_MOVING_RIGHT
  },
  {
    EL_PIG,				ACTION_DIGGING, MV_BIT_DOWN, FALSE,
    IMG_PIG_DIGGING_DOWN
  },
  {
    EL_PIG,				ACTION_DIGGING, MV_BIT_UP, FALSE,
    IMG_PIG_DIGGING_UP
  },
  {
    EL_PIG,				ACTION_DIGGING, MV_BIT_LEFT, FALSE,
    IMG_PIG_DIGGING_LEFT
  },
  {
    EL_PIG,				ACTION_DIGGING, MV_BIT_RIGHT, FALSE,
    IMG_PIG_DIGGING_RIGHT
  },*/
  {
    EL_DRAGON,		-1, -1, //FALSE,
    IMG_DRAGON
  },
  {
    EL_DRAGON,				-1, MV_BIT_DOWN, //FALSE,
    IMG_DRAGON_DOWN
  },
  {
    EL_DRAGON,				-1, MV_BIT_UP, //FALSE,
    IMG_DRAGON_UP
  },
  {
    EL_DRAGON,				-1, MV_BIT_LEFT, //FALSE,
    IMG_DRAGON_LEFT
  },
  {
    EL_DRAGON,				-1, MV_BIT_RIGHT, //FALSE,
    IMG_DRAGON_RIGHT
  },
/*  {
    EL_DRAGON,				ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_DRAGON_MOVING_DOWN
  },
  {
    EL_DRAGON,				ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_DRAGON_MOVING_UP
  },
  {
    EL_DRAGON,				ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_DRAGON_MOVING_LEFT
  },
  {
    EL_DRAGON,				ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_DRAGON_MOVING_RIGHT
  },
  {
    EL_DRAGON,				ACTION_ATTACKING, MV_BIT_DOWN, FALSE,
    IMG_DRAGON_ATTACKING_DOWN
  },
  {
    EL_DRAGON,				ACTION_ATTACKING, MV_BIT_UP, FALSE,
    IMG_DRAGON_ATTACKING_UP
  },
  {
    EL_DRAGON,				ACTION_ATTACKING, MV_BIT_LEFT, FALSE,
    IMG_DRAGON_ATTACKING_LEFT
  },
  {
    EL_DRAGON,				ACTION_ATTACKING, MV_BIT_RIGHT, FALSE,
    IMG_DRAGON_ATTACKING_RIGHT
  },*/
  {
    EL_MOLE,		-1, -1, //FALSE,
    IMG_MOLE
  },
  {
    EL_MOLE,				-1, MV_BIT_DOWN, //FALSE,
    IMG_MOLE_DOWN
  },
  {
    EL_MOLE,				-1, MV_BIT_UP, //FALSE,
    IMG_MOLE_UP
  },
  {
    EL_MOLE,				-1, MV_BIT_LEFT, //FALSE,
    IMG_MOLE_LEFT
  },
  {
    EL_MOLE,				-1, MV_BIT_RIGHT, //FALSE,
    IMG_MOLE_RIGHT
  },
/*  {
    EL_MOLE,				ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_MOLE_MOVING_DOWN
  },
  {
    EL_MOLE,				ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_MOLE_MOVING_UP
  },
  {
    EL_MOLE,				ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_MOLE_MOVING_LEFT
  },
  {
    EL_MOLE,				ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_MOLE_MOVING_RIGHT
  },
  {
    EL_MOLE,				ACTION_DIGGING, MV_BIT_DOWN, FALSE,
    IMG_MOLE_DIGGING_DOWN
  },
  {
    EL_MOLE,				ACTION_DIGGING, MV_BIT_UP, FALSE,
    IMG_MOLE_DIGGING_UP
  },
  {
    EL_MOLE,				ACTION_DIGGING, MV_BIT_LEFT, FALSE,
    IMG_MOLE_DIGGING_LEFT
  },
  {
    EL_MOLE,				ACTION_DIGGING, MV_BIT_RIGHT, FALSE,
    IMG_MOLE_DIGGING_RIGHT
  },*/
  {
    EL_PENGUIN,		-1, -1, //FALSE,
    IMG_PENGUIN
  },
  {
    EL_PENGUIN,				-1, MV_BIT_DOWN, //FALSE,
    IMG_PENGUIN_DOWN
  },
  {
    EL_PENGUIN,				-1, MV_BIT_UP, //FALSE,
    IMG_PENGUIN_UP
  },
  {
    EL_PENGUIN,				-1, MV_BIT_LEFT, //FALSE,
    IMG_PENGUIN_LEFT
  },
  {
    EL_PENGUIN,				-1, MV_BIT_RIGHT, //FALSE,
    IMG_PENGUIN_RIGHT
  },
/*  {
    EL_PENGUIN,				ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_PENGUIN_MOVING_DOWN
  },
  {
    EL_PENGUIN,				ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_PENGUIN_MOVING_UP
  },
  {
    EL_PENGUIN,				ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_PENGUIN_MOVING_LEFT
  },
  {
    EL_PENGUIN,				ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_PENGUIN_MOVING_RIGHT
  },*/
  {
    EL_PLAYER_1,		-1, -1, //FALSE,
    IMG_PLAYER_1
  },
  {
    EL_PLAYER_1,			-1, MV_BIT_DOWN, //FALSE,
    IMG_PLAYER_1_DOWN
  },
  {
    EL_PLAYER_1,			-1, MV_BIT_UP, //FALSE,
    IMG_PLAYER_1_UP
  },
  {
    EL_PLAYER_1,			-1, MV_BIT_LEFT, //FALSE,
    IMG_PLAYER_1_LEFT
  },
  {
    EL_PLAYER_1,			-1, MV_BIT_RIGHT, //FALSE,
    IMG_PLAYER_1_RIGHT
  },
  {
    EL_PLAYER_1,			ACTION_MOVING, MV_BIT_DOWN, //FALSE,
    IMG_PLAYER_1_MOVING_DOWN
  },
  {
    EL_PLAYER_1,			ACTION_MOVING, MV_BIT_UP, //FALSE,
    IMG_PLAYER_1_MOVING_UP
  },
  {
    EL_PLAYER_1,			ACTION_MOVING, MV_BIT_LEFT, //FALSE,
    IMG_PLAYER_1_MOVING_LEFT
  },
  {
    EL_PLAYER_1,			ACTION_MOVING, MV_BIT_RIGHT, //FALSE,
    IMG_PLAYER_1_MOVING_RIGHT
  },
  {
    EL_PLAYER_1,			ACTION_DIGGING, MV_BIT_DOWN, //FALSE,
    IMG_PLAYER_1_DIGGING_DOWN
  },
  {
    EL_PLAYER_1,			ACTION_DIGGING, MV_BIT_UP, //FALSE,
    IMG_PLAYER_1_DIGGING_UP
  },
  {
    EL_PLAYER_1,			ACTION_DIGGING, MV_BIT_LEFT, //FALSE,
    IMG_PLAYER_1_DIGGING_LEFT
  },
  {
    EL_PLAYER_1,			ACTION_DIGGING, MV_BIT_RIGHT, //FALSE,
    IMG_PLAYER_1_DIGGING_RIGHT
  },
  {
    EL_PLAYER_1,			ACTION_COLLECTING, MV_BIT_DOWN, //FALSE,
    IMG_PLAYER_1_COLLECTING_DOWN
  },
  {
    EL_PLAYER_1,			ACTION_COLLECTING, MV_BIT_UP, //FALSE,
    IMG_PLAYER_1_COLLECTING_UP
  },
  {
    EL_PLAYER_1,			ACTION_COLLECTING, MV_BIT_LEFT, //FALSE,
    IMG_PLAYER_1_COLLECTING_LEFT
  },
  {
    EL_PLAYER_1,			ACTION_COLLECTING, MV_BIT_RIGHT, //FALSE,
    IMG_PLAYER_1_COLLECTING_RIGHT
  },
  {
    EL_PLAYER_1,			ACTION_PUSHING, MV_BIT_DOWN, //FALSE,
    IMG_PLAYER_1_PUSHING_DOWN
  },
  {
    EL_PLAYER_1,			ACTION_PUSHING, MV_BIT_UP, //FALSE,
    IMG_PLAYER_1_PUSHING_UP
  },
  {
    EL_PLAYER_1,			ACTION_PUSHING, MV_BIT_LEFT, //FALSE,
    IMG_PLAYER_1_PUSHING_LEFT
  },
  {
    EL_PLAYER_1,			ACTION_PUSHING, MV_BIT_RIGHT, //FALSE,
    IMG_PLAYER_1_PUSHING_RIGHT
  },
  {
    EL_PLAYER_1,			ACTION_SNAPPING, MV_BIT_DOWN, //FALSE,
    IMG_PLAYER_1_SNAPPING_DOWN
  },
  {
    EL_PLAYER_1,			ACTION_SNAPPING, MV_BIT_UP, //FALSE,
    IMG_PLAYER_1_SNAPPING_UP
  },
  {
    EL_PLAYER_1,			ACTION_SNAPPING, MV_BIT_LEFT, //FALSE,
    IMG_PLAYER_1_SNAPPING_LEFT
  },
  {
    EL_PLAYER_1,			ACTION_SNAPPING, MV_BIT_RIGHT, //FALSE,
    IMG_PLAYER_1_SNAPPING_RIGHT
  },
/*  {
    EL_PLAYER_2,			-1, -1, FALSE,
    IMG_PLAYER_2
  },
  {
    EL_PLAYER_2,			-1, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_2_DOWN
  },
  {
    EL_PLAYER_2,			-1, MV_BIT_UP, FALSE,
    IMG_PLAYER_2_UP
  },
  {
    EL_PLAYER_2,			-1, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_2_LEFT
  },
  {
    EL_PLAYER_2,			-1, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_2_RIGHT
  },
  {
    EL_PLAYER_2,			ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_2_MOVING_DOWN
  },
  {
    EL_PLAYER_2,			ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_PLAYER_2_MOVING_UP
  },
  {
    EL_PLAYER_2,			ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_2_MOVING_LEFT
  },
  {
    EL_PLAYER_2,			ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_2_MOVING_RIGHT
  },
  {
    EL_PLAYER_2,			ACTION_DIGGING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_2_DIGGING_DOWN
  },
  {
    EL_PLAYER_2,			ACTION_DIGGING, MV_BIT_UP, FALSE,
    IMG_PLAYER_2_DIGGING_UP
  },
  {
    EL_PLAYER_2,			ACTION_DIGGING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_2_DIGGING_LEFT
  },
  {
    EL_PLAYER_2,			ACTION_DIGGING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_2_DIGGING_RIGHT
  },
  {
    EL_PLAYER_2,			ACTION_COLLECTING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_2_COLLECTING_DOWN
  },
  {
    EL_PLAYER_2,			ACTION_COLLECTING, MV_BIT_UP, FALSE,
    IMG_PLAYER_2_COLLECTING_UP
  },
  {
    EL_PLAYER_2,			ACTION_COLLECTING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_2_COLLECTING_LEFT
  },
  {
    EL_PLAYER_2,			ACTION_COLLECTING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_2_COLLECTING_RIGHT
  },
  {
    EL_PLAYER_2,			ACTION_PUSHING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_2_PUSHING_DOWN
  },
  {
    EL_PLAYER_2,			ACTION_PUSHING, MV_BIT_UP, FALSE,
    IMG_PLAYER_2_PUSHING_UP
  },
  {
    EL_PLAYER_2,			ACTION_PUSHING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_2_PUSHING_LEFT
  },
  {
    EL_PLAYER_2,			ACTION_PUSHING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_2_PUSHING_RIGHT
  },
  {
    EL_PLAYER_2,			ACTION_SNAPPING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_2_SNAPPING_DOWN
  },
  {
    EL_PLAYER_2,			ACTION_SNAPPING, MV_BIT_UP, FALSE,
    IMG_PLAYER_2_SNAPPING_UP
  },
  {
    EL_PLAYER_2,			ACTION_SNAPPING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_2_SNAPPING_LEFT
  },
  {
    EL_PLAYER_2,			ACTION_SNAPPING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_2_SNAPPING_RIGHT
  },
  {
    EL_PLAYER_3,			-1, -1, FALSE,
    IMG_PLAYER_3
  },
  {
    EL_PLAYER_3,			-1, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_3_DOWN
  },
  {
    EL_PLAYER_3,			-1, MV_BIT_UP, FALSE,
    IMG_PLAYER_3_UP
  },
  {
    EL_PLAYER_3,			-1, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_3_LEFT
  },
  {
    EL_PLAYER_3,			-1, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_3_RIGHT
  },
  {
    EL_PLAYER_3,			ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_3_MOVING_DOWN
  },
  {
    EL_PLAYER_3,			ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_PLAYER_3_MOVING_UP
  },
  {
    EL_PLAYER_3,			ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_3_MOVING_LEFT
  },
  {
    EL_PLAYER_3,			ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_3_MOVING_RIGHT
  },
  {
    EL_PLAYER_3,			ACTION_DIGGING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_3_DIGGING_DOWN
  },
  {
    EL_PLAYER_3,			ACTION_DIGGING, MV_BIT_UP, FALSE,
    IMG_PLAYER_3_DIGGING_UP
  },
  {
    EL_PLAYER_3,			ACTION_DIGGING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_3_DIGGING_LEFT
  },
  {
    EL_PLAYER_3,			ACTION_DIGGING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_3_DIGGING_RIGHT
  },
  {
    EL_PLAYER_3,			ACTION_COLLECTING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_3_COLLECTING_DOWN
  },
  {
    EL_PLAYER_3,			ACTION_COLLECTING, MV_BIT_UP, FALSE,
    IMG_PLAYER_3_COLLECTING_UP
  },
  {
    EL_PLAYER_3,			ACTION_COLLECTING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_3_COLLECTING_LEFT
  },
  {
    EL_PLAYER_3,			ACTION_COLLECTING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_3_COLLECTING_RIGHT
  },
  {
    EL_PLAYER_3,			ACTION_PUSHING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_3_PUSHING_DOWN
  },
  {
    EL_PLAYER_3,			ACTION_PUSHING, MV_BIT_UP, FALSE,
    IMG_PLAYER_3_PUSHING_UP
  },
  {
    EL_PLAYER_3,			ACTION_PUSHING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_3_PUSHING_LEFT
  },
  {
    EL_PLAYER_3,			ACTION_PUSHING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_3_PUSHING_RIGHT
  },
  {
    EL_PLAYER_3,			ACTION_SNAPPING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_3_SNAPPING_DOWN
  },
  {
    EL_PLAYER_3,			ACTION_SNAPPING, MV_BIT_UP, FALSE,
    IMG_PLAYER_3_SNAPPING_UP
  },
  {
    EL_PLAYER_3,			ACTION_SNAPPING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_3_SNAPPING_LEFT
  },
  {
    EL_PLAYER_3,			ACTION_SNAPPING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_3_SNAPPING_RIGHT
  },
  {
    EL_PLAYER_4,			-1, -1, FALSE,
    IMG_PLAYER_4
  },
  {
    EL_PLAYER_4,			-1, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_4_DOWN
  },
  {
    EL_PLAYER_4,			-1, MV_BIT_UP, FALSE,
    IMG_PLAYER_4_UP
  },
  {
    EL_PLAYER_4,			-1, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_4_LEFT
  },
  {
    EL_PLAYER_4,			-1, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_4_RIGHT
  },
  {
    EL_PLAYER_4,			ACTION_MOVING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_4_MOVING_DOWN
  },
  {
    EL_PLAYER_4,			ACTION_MOVING, MV_BIT_UP, FALSE,
    IMG_PLAYER_4_MOVING_UP
  },
  {
    EL_PLAYER_4,			ACTION_MOVING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_4_MOVING_LEFT
  },
  {
    EL_PLAYER_4,			ACTION_MOVING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_4_MOVING_RIGHT
  },
  {
    EL_PLAYER_4,			ACTION_DIGGING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_4_DIGGING_DOWN
  },
  {
    EL_PLAYER_4,			ACTION_DIGGING, MV_BIT_UP, FALSE,
    IMG_PLAYER_4_DIGGING_UP
  },
  {
    EL_PLAYER_4,			ACTION_DIGGING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_4_DIGGING_LEFT
  },
  {
    EL_PLAYER_4,			ACTION_DIGGING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_4_DIGGING_RIGHT
  },
  {
    EL_PLAYER_4,			ACTION_COLLECTING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_4_COLLECTING_DOWN
  },
  {
    EL_PLAYER_4,			ACTION_COLLECTING, MV_BIT_UP, FALSE,
    IMG_PLAYER_4_COLLECTING_UP
  },
  {
    EL_PLAYER_4,			ACTION_COLLECTING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_4_COLLECTING_LEFT
  },
  {
    EL_PLAYER_4,			ACTION_COLLECTING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_4_COLLECTING_RIGHT
  },
  {
    EL_PLAYER_4,			ACTION_PUSHING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_4_PUSHING_DOWN
  },
  {
    EL_PLAYER_4,			ACTION_PUSHING, MV_BIT_UP, FALSE,
    IMG_PLAYER_4_PUSHING_UP
  },
  {
    EL_PLAYER_4,			ACTION_PUSHING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_4_PUSHING_LEFT
  },
  {
    EL_PLAYER_4,			ACTION_PUSHING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_4_PUSHING_RIGHT
  },
  {
    EL_PLAYER_4,			ACTION_SNAPPING, MV_BIT_DOWN, FALSE,
    IMG_PLAYER_4_SNAPPING_DOWN
  },
  {
    EL_PLAYER_4,			ACTION_SNAPPING, MV_BIT_UP, FALSE,
    IMG_PLAYER_4_SNAPPING_UP
  },
  {
    EL_PLAYER_4,			ACTION_SNAPPING, MV_BIT_LEFT, FALSE,
    IMG_PLAYER_4_SNAPPING_LEFT
  },
  {
    EL_PLAYER_4,			ACTION_SNAPPING, MV_BIT_RIGHT, FALSE,
    IMG_PLAYER_4_SNAPPING_RIGHT
  },
  {
    EL_DEFAULT,				ACTION_EXPLODING, -1, FALSE,
    IMG_DEFAULT_EXPLODING
  },*/
/*
  {
    EL_CUSTOM_1,			-1, -1, FALSE,
    IMG_CUSTOM_1
  },
  {
    EL_CUSTOM_2,			-1, -1, FALSE,
    IMG_CUSTOM_2
  },
  {
    EL_CUSTOM_3,			-1, -1, FALSE,
    IMG_CUSTOM_3
  },
  {
    EL_CUSTOM_4,			-1, -1, FALSE,
    IMG_CUSTOM_4
  },
  {
    EL_CUSTOM_5,			-1, -1, FALSE,
    IMG_CUSTOM_5
  },
  {
    EL_CUSTOM_6,			-1, -1, FALSE,
    IMG_CUSTOM_6
  },
  {
    EL_CUSTOM_7,			-1, -1, FALSE,
    IMG_CUSTOM_7
  },
  {
    EL_CUSTOM_8,			-1, -1, FALSE,
    IMG_CUSTOM_8
  },
  {
    EL_CUSTOM_9,			-1, -1, FALSE,
    IMG_CUSTOM_9
  },
  {
    EL_CUSTOM_10,			-1, -1, FALSE,
    IMG_CUSTOM_10
  },
  {
    EL_CUSTOM_11,			-1, -1, FALSE,
    IMG_CUSTOM_11
  },
  {
    EL_CUSTOM_12,			-1, -1, FALSE,
    IMG_CUSTOM_12
  },
  {
    EL_CUSTOM_13,			-1, -1, FALSE,
    IMG_CUSTOM_13
  },
  {
    EL_CUSTOM_14,			-1, -1, FALSE,
    IMG_CUSTOM_14
  },
  {
    EL_CUSTOM_15,			-1, -1, FALSE,
    IMG_CUSTOM_15
  },
  {
    EL_CUSTOM_16,			-1, -1, FALSE,
    IMG_CUSTOM_16
  },
  {
    EL_CUSTOM_17,			-1, -1, FALSE,
    IMG_CUSTOM_17
  },
  {
    EL_CUSTOM_18,			-1, -1, FALSE,
    IMG_CUSTOM_18
  },
  {
    EL_CUSTOM_19,			-1, -1, FALSE,
    IMG_CUSTOM_19
  },
  {
    EL_CUSTOM_20,			-1, -1, FALSE,
    IMG_CUSTOM_20
  },
  {
    EL_CUSTOM_21,			-1, -1, FALSE,
    IMG_CUSTOM_21
  },
  {
    EL_CUSTOM_22,			-1, -1, FALSE,
    IMG_CUSTOM_22
  },
  {
    EL_CUSTOM_23,			-1, -1, FALSE,
    IMG_CUSTOM_23
  },
  {
    EL_CUSTOM_24,			-1, -1, FALSE,
    IMG_CUSTOM_24
  },
  {
    EL_CUSTOM_25,			-1, -1, FALSE,
    IMG_CUSTOM_25
  },
  {
    EL_CUSTOM_26,			-1, -1, FALSE,
    IMG_CUSTOM_26
  },
  {
    EL_CUSTOM_27,			-1, -1, FALSE,
    IMG_CUSTOM_27
  },
  {
    EL_CUSTOM_28,			-1, -1, FALSE,
    IMG_CUSTOM_28
  },
  {
    EL_CUSTOM_29,			-1, -1, FALSE,
    IMG_CUSTOM_29
  },
  {
    EL_CUSTOM_30,			-1, -1, FALSE,
    IMG_CUSTOM_30
  },
  {
    EL_CUSTOM_31,			-1, -1, FALSE,
    IMG_CUSTOM_31
  },
  {
    EL_CUSTOM_32,			-1, -1, FALSE,
    IMG_CUSTOM_32
  },
  {
    EL_CUSTOM_33,			-1, -1, FALSE,
    IMG_CUSTOM_33
  },
  {
    EL_CUSTOM_34,			-1, -1, FALSE,
    IMG_CUSTOM_34
  },
  {
    EL_CUSTOM_35,			-1, -1, FALSE,
    IMG_CUSTOM_35
  },
  {
    EL_CUSTOM_36,			-1, -1, FALSE,
    IMG_CUSTOM_36
  },
  {
    EL_CUSTOM_37,			-1, -1, FALSE,
    IMG_CUSTOM_37
  },
  {
    EL_CUSTOM_38,			-1, -1, FALSE,
    IMG_CUSTOM_38
  },
  {
    EL_CUSTOM_39,			-1, -1, FALSE,
    IMG_CUSTOM_39
  },
  {
    EL_CUSTOM_40,			-1, -1, FALSE,
    IMG_CUSTOM_40
  },
  {
    EL_CUSTOM_41,			-1, -1, FALSE,
    IMG_CUSTOM_41
  },
  {
    EL_CUSTOM_42,			-1, -1, FALSE,
    IMG_CUSTOM_42
  },
  {
    EL_CUSTOM_43,			-1, -1, FALSE,
    IMG_CUSTOM_43
  },
  {
    EL_CUSTOM_44,			-1, -1, FALSE,
    IMG_CUSTOM_44
  },
  {
    EL_CUSTOM_45,			-1, -1, FALSE,
    IMG_CUSTOM_45
  },
  {
    EL_CUSTOM_46,			-1, -1, FALSE,
    IMG_CUSTOM_46
  },
  {
    EL_CUSTOM_47,			-1, -1, FALSE,
    IMG_CUSTOM_47
  },
  {
    EL_CUSTOM_48,			-1, -1, FALSE,
    IMG_CUSTOM_48
  },
  {
    EL_CUSTOM_49,			-1, -1, FALSE,
    IMG_CUSTOM_49
  },
  {
    EL_CUSTOM_50,			-1, -1, FALSE,
    IMG_CUSTOM_50
  },
  {
    EL_CUSTOM_51,			-1, -1, FALSE,
    IMG_CUSTOM_51
  },
  {
    EL_CUSTOM_52,			-1, -1, FALSE,
    IMG_CUSTOM_52
  },
  {
    EL_CUSTOM_53,			-1, -1, FALSE,
    IMG_CUSTOM_53
  },
  {
    EL_CUSTOM_54,			-1, -1, FALSE,
    IMG_CUSTOM_54
  },
  {
    EL_CUSTOM_55,			-1, -1, FALSE,
    IMG_CUSTOM_55
  },
  {
    EL_CUSTOM_56,			-1, -1, FALSE,
    IMG_CUSTOM_56
  },
  {
    EL_CUSTOM_57,			-1, -1, FALSE,
    IMG_CUSTOM_57
  },
  {
    EL_CUSTOM_58,			-1, -1, FALSE,
    IMG_CUSTOM_58
  },
  {
    EL_CUSTOM_59,			-1, -1, FALSE,
    IMG_CUSTOM_59
  },
  {
    EL_CUSTOM_60,			-1, -1, FALSE,
    IMG_CUSTOM_60
  },
  {
    EL_CUSTOM_61,			-1, -1, FALSE,
    IMG_CUSTOM_61
  },
  {
    EL_CUSTOM_62,			-1, -1, FALSE,
    IMG_CUSTOM_62
  },
  {
    EL_CUSTOM_63,			-1, -1, FALSE,
    IMG_CUSTOM_63
  },
  {
    EL_CUSTOM_64,			-1, -1, FALSE,
    IMG_CUSTOM_64
  },
  {
    EL_CUSTOM_65,			-1, -1, FALSE,
    IMG_CUSTOM_65
  },
  {
    EL_CUSTOM_66,			-1, -1, FALSE,
    IMG_CUSTOM_66
  },
  {
    EL_CUSTOM_67,			-1, -1, FALSE,
    IMG_CUSTOM_67
  },
  {
    EL_CUSTOM_68,			-1, -1, FALSE,
    IMG_CUSTOM_68
  },
  {
    EL_CUSTOM_69,			-1, -1, FALSE,
    IMG_CUSTOM_69
  },
  {
    EL_CUSTOM_70,			-1, -1, FALSE,
    IMG_CUSTOM_70
  },
  {
    EL_CUSTOM_71,			-1, -1, FALSE,
    IMG_CUSTOM_71
  },
  {
    EL_CUSTOM_72,			-1, -1, FALSE,
    IMG_CUSTOM_72
  },
  {
    EL_CUSTOM_73,			-1, -1, FALSE,
    IMG_CUSTOM_73
  },
  {
    EL_CUSTOM_74,			-1, -1, FALSE,
    IMG_CUSTOM_74
  },
  {
    EL_CUSTOM_75,			-1, -1, FALSE,
    IMG_CUSTOM_75
  },
  {
    EL_CUSTOM_76,			-1, -1, FALSE,
    IMG_CUSTOM_76
  },
  {
    EL_CUSTOM_77,			-1, -1, FALSE,
    IMG_CUSTOM_77
  },
  {
    EL_CUSTOM_78,			-1, -1, FALSE,
    IMG_CUSTOM_78
  },
  {
    EL_CUSTOM_79,			-1, -1, FALSE,
    IMG_CUSTOM_79
  },
  {
    EL_CUSTOM_80,			-1, -1, FALSE,
    IMG_CUSTOM_80
  },
  {
    EL_CUSTOM_81,			-1, -1, FALSE,
    IMG_CUSTOM_81
  },
  {
    EL_CUSTOM_82,			-1, -1, FALSE,
    IMG_CUSTOM_82
  },
  {
    EL_CUSTOM_83,			-1, -1, FALSE,
    IMG_CUSTOM_83
  },
  {
    EL_CUSTOM_84,			-1, -1, FALSE,
    IMG_CUSTOM_84
  },
  {
    EL_CUSTOM_85,			-1, -1, FALSE,
    IMG_CUSTOM_85
  },
  {
    EL_CUSTOM_86,			-1, -1, FALSE,
    IMG_CUSTOM_86
  },
  {
    EL_CUSTOM_87,			-1, -1, FALSE,
    IMG_CUSTOM_87
  },
  {
    EL_CUSTOM_88,			-1, -1, FALSE,
    IMG_CUSTOM_88
  },
  {
    EL_CUSTOM_89,			-1, -1, FALSE,
    IMG_CUSTOM_89
  },
  {
    EL_CUSTOM_90,			-1, -1, FALSE,
    IMG_CUSTOM_90
  },
  {
    EL_CUSTOM_91,			-1, -1, FALSE,
    IMG_CUSTOM_91
  },
  {
    EL_CUSTOM_92,			-1, -1, FALSE,
    IMG_CUSTOM_92
  },
  {
    EL_CUSTOM_93,			-1, -1, FALSE,
    IMG_CUSTOM_93
  },
  {
    EL_CUSTOM_94,			-1, -1, FALSE,
    IMG_CUSTOM_94
  },
  {
    EL_CUSTOM_95,			-1, -1, FALSE,
    IMG_CUSTOM_95
  },
  {
    EL_CUSTOM_96,			-1, -1, FALSE,
    IMG_CUSTOM_96
  },
  {
    EL_CUSTOM_97,			-1, -1, FALSE,
    IMG_CUSTOM_97
  },
  {
    EL_CUSTOM_98,			-1, -1, FALSE,
    IMG_CUSTOM_98
  },
  {
    EL_CUSTOM_99,			-1, -1, FALSE,
    IMG_CUSTOM_99
  },
  {
    EL_CUSTOM_100,			-1, -1, FALSE,
    IMG_CUSTOM_100
  },
  {
    EL_CUSTOM_101,			-1, -1, FALSE,
    IMG_CUSTOM_101
  },
  {
    EL_CUSTOM_102,			-1, -1, FALSE,
    IMG_CUSTOM_102
  },
  {
    EL_CUSTOM_103,			-1, -1, FALSE,
    IMG_CUSTOM_103
  },
  {
    EL_CUSTOM_104,			-1, -1, FALSE,
    IMG_CUSTOM_104
  },
  {
    EL_CUSTOM_105,			-1, -1, FALSE,
    IMG_CUSTOM_105
  },
  {
    EL_CUSTOM_106,			-1, -1, FALSE,
    IMG_CUSTOM_106
  },
  {
    EL_CUSTOM_107,			-1, -1, FALSE,
    IMG_CUSTOM_107
  },
  {
    EL_CUSTOM_108,			-1, -1, FALSE,
    IMG_CUSTOM_108
  },
  {
    EL_CUSTOM_109,			-1, -1, FALSE,
    IMG_CUSTOM_109
  },
  {
    EL_CUSTOM_110,			-1, -1, FALSE,
    IMG_CUSTOM_110
  },
  {
    EL_CUSTOM_111,			-1, -1, FALSE,
    IMG_CUSTOM_111
  },
  {
    EL_CUSTOM_112,			-1, -1, FALSE,
    IMG_CUSTOM_112
  },
  {
    EL_CUSTOM_113,			-1, -1, FALSE,
    IMG_CUSTOM_113
  },
  {
    EL_CUSTOM_114,			-1, -1, FALSE,
    IMG_CUSTOM_114
  },
  {
    EL_CUSTOM_115,			-1, -1, FALSE,
    IMG_CUSTOM_115
  },
  {
    EL_CUSTOM_116,			-1, -1, FALSE,
    IMG_CUSTOM_116
  },
  {
    EL_CUSTOM_117,			-1, -1, FALSE,
    IMG_CUSTOM_117
  },
  {
    EL_CUSTOM_118,			-1, -1, FALSE,
    IMG_CUSTOM_118
  },
  {
    EL_CUSTOM_119,			-1, -1, FALSE,
    IMG_CUSTOM_119
  },
  {
    EL_CUSTOM_120,			-1, -1, FALSE,
    IMG_CUSTOM_120
  },
  {
    EL_CUSTOM_121,			-1, -1, FALSE,
    IMG_CUSTOM_121
  },
  {
    EL_CUSTOM_122,			-1, -1, FALSE,
    IMG_CUSTOM_122
  },
  {
    EL_CUSTOM_123,			-1, -1, FALSE,
    IMG_CUSTOM_123
  },
  {
    EL_CUSTOM_124,			-1, -1, FALSE,
    IMG_CUSTOM_124
  },
  {
    EL_CUSTOM_125,			-1, -1, FALSE,
    IMG_CUSTOM_125
  },
  {
    EL_CUSTOM_126,			-1, -1, FALSE,
    IMG_CUSTOM_126
  },
  {
    EL_CUSTOM_127,			-1, -1, FALSE,
    IMG_CUSTOM_127
  },
  {
    EL_CUSTOM_128,			-1, -1, FALSE,
    IMG_CUSTOM_128
  },
  {
    EL_CUSTOM_129,			-1, -1, FALSE,
    IMG_CUSTOM_129
  },
  {
    EL_CUSTOM_130,			-1, -1, FALSE,
    IMG_CUSTOM_130
  },
  {
    EL_CUSTOM_131,			-1, -1, FALSE,
    IMG_CUSTOM_131
  },
  {
    EL_CUSTOM_132,			-1, -1, FALSE,
    IMG_CUSTOM_132
  },
  {
    EL_CUSTOM_133,			-1, -1, FALSE,
    IMG_CUSTOM_133
  },
  {
    EL_CUSTOM_134,			-1, -1, FALSE,
    IMG_CUSTOM_134
  },
  {
    EL_CUSTOM_135,			-1, -1, FALSE,
    IMG_CUSTOM_135
  },
  {
    EL_CUSTOM_136,			-1, -1, FALSE,
    IMG_CUSTOM_136
  },
  {
    EL_CUSTOM_137,			-1, -1, FALSE,
    IMG_CUSTOM_137
  },
  {
    EL_CUSTOM_138,			-1, -1, FALSE,
    IMG_CUSTOM_138
  },
  {
    EL_CUSTOM_139,			-1, -1, FALSE,
    IMG_CUSTOM_139
  },
  {
    EL_CUSTOM_140,			-1, -1, FALSE,
    IMG_CUSTOM_140
  },
  {
    EL_CUSTOM_141,			-1, -1, FALSE,
    IMG_CUSTOM_141
  },
  {
    EL_CUSTOM_142,			-1, -1, FALSE,
    IMG_CUSTOM_142
  },
  {
    EL_CUSTOM_143,			-1, -1, FALSE,
    IMG_CUSTOM_143
  },
  {
    EL_CUSTOM_144,			-1, -1, FALSE,
    IMG_CUSTOM_144
  },
  {
    EL_CUSTOM_145,			-1, -1, FALSE,
    IMG_CUSTOM_145
  },
  {
    EL_CUSTOM_146,			-1, -1, FALSE,
    IMG_CUSTOM_146
  },
  {
    EL_CUSTOM_147,			-1, -1, FALSE,
    IMG_CUSTOM_147
  },
  {
    EL_CUSTOM_148,			-1, -1, FALSE,
    IMG_CUSTOM_148
  },
  {
    EL_CUSTOM_149,			-1, -1, FALSE,
    IMG_CUSTOM_149
  },
  {
    EL_CUSTOM_150,			-1, -1, FALSE,
    IMG_CUSTOM_150
  },
  {
    EL_CUSTOM_151,			-1, -1, FALSE,
    IMG_CUSTOM_151
  },
  {
    EL_CUSTOM_152,			-1, -1, FALSE,
    IMG_CUSTOM_152
  },
  {
    EL_CUSTOM_153,			-1, -1, FALSE,
    IMG_CUSTOM_153
  },
  {
    EL_CUSTOM_154,			-1, -1, FALSE,
    IMG_CUSTOM_154
  },
  {
    EL_CUSTOM_155,			-1, -1, FALSE,
    IMG_CUSTOM_155
  },
  {
    EL_CUSTOM_156,			-1, -1, FALSE,
    IMG_CUSTOM_156
  },
  {
    EL_CUSTOM_157,			-1, -1, FALSE,
    IMG_CUSTOM_157
  },
  {
    EL_CUSTOM_158,			-1, -1, FALSE,
    IMG_CUSTOM_158
  },
  {
    EL_CUSTOM_159,			-1, -1, FALSE,
    IMG_CUSTOM_159
  },
  {
    EL_CUSTOM_160,			-1, -1, FALSE,
    IMG_CUSTOM_160
  },
  {
    EL_CUSTOM_161,			-1, -1, FALSE,
    IMG_CUSTOM_161
  },
  {
    EL_CUSTOM_162,			-1, -1, FALSE,
    IMG_CUSTOM_162
  },
  {
    EL_CUSTOM_163,			-1, -1, FALSE,
    IMG_CUSTOM_163
  },
  {
    EL_CUSTOM_164,			-1, -1, FALSE,
    IMG_CUSTOM_164
  },
  {
    EL_CUSTOM_165,			-1, -1, FALSE,
    IMG_CUSTOM_165
  },
  {
    EL_CUSTOM_166,			-1, -1, FALSE,
    IMG_CUSTOM_166
  },
  {
    EL_CUSTOM_167,			-1, -1, FALSE,
    IMG_CUSTOM_167
  },
  {
    EL_CUSTOM_168,			-1, -1, FALSE,
    IMG_CUSTOM_168
  },
  {
    EL_CUSTOM_169,			-1, -1, FALSE,
    IMG_CUSTOM_169
  },
  {
    EL_CUSTOM_170,			-1, -1, FALSE,
    IMG_CUSTOM_170
  },
  {
    EL_CUSTOM_171,			-1, -1, FALSE,
    IMG_CUSTOM_171
  },
  {
    EL_CUSTOM_172,			-1, -1, FALSE,
    IMG_CUSTOM_172
  },
  {
    EL_CUSTOM_173,			-1, -1, FALSE,
    IMG_CUSTOM_173
  },
  {
    EL_CUSTOM_174,			-1, -1, FALSE,
    IMG_CUSTOM_174
  },
  {
    EL_CUSTOM_175,			-1, -1, FALSE,
    IMG_CUSTOM_175
  },
  {
    EL_CUSTOM_176,			-1, -1, FALSE,
    IMG_CUSTOM_176
  },
  {
    EL_CUSTOM_177,			-1, -1, FALSE,
    IMG_CUSTOM_177
  },
  {
    EL_CUSTOM_178,			-1, -1, FALSE,
    IMG_CUSTOM_178
  },
  {
    EL_CUSTOM_179,			-1, -1, FALSE,
    IMG_CUSTOM_179
  },
  {
    EL_CUSTOM_180,			-1, -1, FALSE,
    IMG_CUSTOM_180
  },
  {
    EL_CUSTOM_181,			-1, -1, FALSE,
    IMG_CUSTOM_181
  },
  {
    EL_CUSTOM_182,			-1, -1, FALSE,
    IMG_CUSTOM_182
  },
  {
    EL_CUSTOM_183,			-1, -1, FALSE,
    IMG_CUSTOM_183
  },
  {
    EL_CUSTOM_184,			-1, -1, FALSE,
    IMG_CUSTOM_184
  },
  {
    EL_CUSTOM_185,			-1, -1, FALSE,
    IMG_CUSTOM_185
  },
  {
    EL_CUSTOM_186,			-1, -1, FALSE,
    IMG_CUSTOM_186
  },
  {
    EL_CUSTOM_187,			-1, -1, FALSE,
    IMG_CUSTOM_187
  },
  {
    EL_CUSTOM_188,			-1, -1, FALSE,
    IMG_CUSTOM_188
  },
  {
    EL_CUSTOM_189,			-1, -1, FALSE,
    IMG_CUSTOM_189
  },
  {
    EL_CUSTOM_190,			-1, -1, FALSE,
    IMG_CUSTOM_190
  },
  {
    EL_CUSTOM_191,			-1, -1, FALSE,
    IMG_CUSTOM_191
  },
  {
    EL_CUSTOM_192,			-1, -1, FALSE,
    IMG_CUSTOM_192
  },
  {
    EL_CUSTOM_193,			-1, -1, FALSE,
    IMG_CUSTOM_193
  },
  {
    EL_CUSTOM_194,			-1, -1, FALSE,
    IMG_CUSTOM_194
  },
  {
    EL_CUSTOM_195,			-1, -1, FALSE,
    IMG_CUSTOM_195
  },
  {
    EL_CUSTOM_196,			-1, -1, FALSE,
    IMG_CUSTOM_196
  },
  {
    EL_CUSTOM_197,			-1, -1, FALSE,
    IMG_CUSTOM_197
  },
  {
    EL_CUSTOM_198,			-1, -1, FALSE,
    IMG_CUSTOM_198
  },
  {
    EL_CUSTOM_199,			-1, -1, FALSE,
    IMG_CUSTOM_199
  },
  {
    EL_CUSTOM_200,			-1, -1, FALSE,
    IMG_CUSTOM_200
  },
  {
    EL_CUSTOM_201,			-1, -1, FALSE,
    IMG_CUSTOM_201
  },
  {
    EL_CUSTOM_202,			-1, -1, FALSE,
    IMG_CUSTOM_202
  },
  {
    EL_CUSTOM_203,			-1, -1, FALSE,
    IMG_CUSTOM_203
  },
  {
    EL_CUSTOM_204,			-1, -1, FALSE,
    IMG_CUSTOM_204
  },
  {
    EL_CUSTOM_205,			-1, -1, FALSE,
    IMG_CUSTOM_205
  },
  {
    EL_CUSTOM_206,			-1, -1, FALSE,
    IMG_CUSTOM_206
  },
  {
    EL_CUSTOM_207,			-1, -1, FALSE,
    IMG_CUSTOM_207
  },
  {
    EL_CUSTOM_208,			-1, -1, FALSE,
    IMG_CUSTOM_208
  },
  {
    EL_CUSTOM_209,			-1, -1, FALSE,
    IMG_CUSTOM_209
  },
  {
    EL_CUSTOM_210,			-1, -1, FALSE,
    IMG_CUSTOM_210
  },
  {
    EL_CUSTOM_211,			-1, -1, FALSE,
    IMG_CUSTOM_211
  },
  {
    EL_CUSTOM_212,			-1, -1, FALSE,
    IMG_CUSTOM_212
  },
  {
    EL_CUSTOM_213,			-1, -1, FALSE,
    IMG_CUSTOM_213
  },
  {
    EL_CUSTOM_214,			-1, -1, FALSE,
    IMG_CUSTOM_214
  },
  {
    EL_CUSTOM_215,			-1, -1, FALSE,
    IMG_CUSTOM_215
  },
  {
    EL_CUSTOM_216,			-1, -1, FALSE,
    IMG_CUSTOM_216
  },
  {
    EL_CUSTOM_217,			-1, -1, FALSE,
    IMG_CUSTOM_217
  },
  {
    EL_CUSTOM_218,			-1, -1, FALSE,
    IMG_CUSTOM_218
  },
  {
    EL_CUSTOM_219,			-1, -1, FALSE,
    IMG_CUSTOM_219
  },
  {
    EL_CUSTOM_220,			-1, -1, FALSE,
    IMG_CUSTOM_220
  },
  {
    EL_CUSTOM_221,			-1, -1, FALSE,
    IMG_CUSTOM_221
  },
  {
    EL_CUSTOM_222,			-1, -1, FALSE,
    IMG_CUSTOM_222
  },
  {
    EL_CUSTOM_223,			-1, -1, FALSE,
    IMG_CUSTOM_223
  },
  {
    EL_CUSTOM_224,			-1, -1, FALSE,
    IMG_CUSTOM_224
  },
  {
    EL_CUSTOM_225,			-1, -1, FALSE,
    IMG_CUSTOM_225
  },
  {
    EL_CUSTOM_226,			-1, -1, FALSE,
    IMG_CUSTOM_226
  },
  {
    EL_CUSTOM_227,			-1, -1, FALSE,
    IMG_CUSTOM_227
  },
  {
    EL_CUSTOM_228,			-1, -1, FALSE,
    IMG_CUSTOM_228
  },
  {
    EL_CUSTOM_229,			-1, -1, FALSE,
    IMG_CUSTOM_229
  },
  {
    EL_CUSTOM_230,			-1, -1, FALSE,
    IMG_CUSTOM_230
  },
  {
    EL_CUSTOM_231,			-1, -1, FALSE,
    IMG_CUSTOM_231
  },
  {
    EL_CUSTOM_232,			-1, -1, FALSE,
    IMG_CUSTOM_232
  },
  {
    EL_CUSTOM_233,			-1, -1, FALSE,
    IMG_CUSTOM_233
  },
  {
    EL_CUSTOM_234,			-1, -1, FALSE,
    IMG_CUSTOM_234
  },
  {
    EL_CUSTOM_235,			-1, -1, FALSE,
    IMG_CUSTOM_235
  },
  {
    EL_CUSTOM_236,			-1, -1, FALSE,
    IMG_CUSTOM_236
  },
  {
    EL_CUSTOM_237,			-1, -1, FALSE,
    IMG_CUSTOM_237
  },
  {
    EL_CUSTOM_238,			-1, -1, FALSE,
    IMG_CUSTOM_238
  },
  {
    EL_CUSTOM_239,			-1, -1, FALSE,
    IMG_CUSTOM_239
  },
  {
    EL_CUSTOM_240,			-1, -1, FALSE,
    IMG_CUSTOM_240
  },
  {
    EL_CUSTOM_241,			-1, -1, FALSE,
    IMG_CUSTOM_241
  },
  {
    EL_CUSTOM_242,			-1, -1, FALSE,
    IMG_CUSTOM_242
  },
  {
    EL_CUSTOM_243,			-1, -1, FALSE,
    IMG_CUSTOM_243
  },
  {
    EL_CUSTOM_244,			-1, -1, FALSE,
    IMG_CUSTOM_244
  },
  {
    EL_CUSTOM_245,			-1, -1, FALSE,
    IMG_CUSTOM_245
  },
  {
    EL_CUSTOM_246,			-1, -1, FALSE,
    IMG_CUSTOM_246
  },
  {
    EL_CUSTOM_247,			-1, -1, FALSE,
    IMG_CUSTOM_247
  },
  {
    EL_CUSTOM_248,			-1, -1, FALSE,
    IMG_CUSTOM_248
  },
  {
    EL_CUSTOM_249,			-1, -1, FALSE,
    IMG_CUSTOM_249
  },
  {
    EL_CUSTOM_250,			-1, -1, FALSE,
    IMG_CUSTOM_250
  },
  {
    EL_CUSTOM_251,			-1, -1, FALSE,
    IMG_CUSTOM_251
  },
  {
    EL_CUSTOM_252,			-1, -1, FALSE,
    IMG_CUSTOM_252
  },
  {
    EL_CUSTOM_253,			-1, -1, FALSE,
    IMG_CUSTOM_253
  },
  {
    EL_CUSTOM_254,			-1, -1, FALSE,
    IMG_CUSTOM_254
  },
  {
    EL_CUSTOM_255,			-1, -1, FALSE,
    IMG_CUSTOM_255
  },
  {
    EL_CUSTOM_256,			-1, -1, FALSE,
    IMG_CUSTOM_256
  }, 
  {
    EL_GROUP_1,				-1, -1, FALSE,
    IMG_GROUP_1
  },
  {
    EL_GROUP_2,				-1, -1, FALSE,
    IMG_GROUP_2
  },
  {
    EL_GROUP_3,				-1, -1, FALSE,
    IMG_GROUP_3
  },
  {
    EL_GROUP_4,				-1, -1, FALSE,
    IMG_GROUP_4
  },
  {
    EL_GROUP_5,				-1, -1, FALSE,
    IMG_GROUP_5
  },
  {
    EL_GROUP_6,				-1, -1, FALSE,
    IMG_GROUP_6
  },
  {
    EL_GROUP_7,				-1, -1, FALSE,
    IMG_GROUP_7
  },
  {
    EL_GROUP_8,				-1, -1, FALSE,
    IMG_GROUP_8
  },
  {
    EL_GROUP_9,				-1, -1, FALSE,
    IMG_GROUP_9
  },
  {
    EL_GROUP_10,			-1, -1, FALSE,
    IMG_GROUP_10
  },
  {
    EL_GROUP_11,			-1, -1, FALSE,
    IMG_GROUP_11
  },
  {
    EL_GROUP_12,			-1, -1, FALSE,
    IMG_GROUP_12
  },
  {
    EL_GROUP_13,			-1, -1, FALSE,
    IMG_GROUP_13
  },
  {
    EL_GROUP_14,			-1, -1, FALSE,
    IMG_GROUP_14
  },
  {
    EL_GROUP_15,			-1, -1, FALSE,
    IMG_GROUP_15
  },
  {
    EL_GROUP_16,			-1, -1, FALSE,
    IMG_GROUP_16
  },
  {
    EL_GROUP_17,			-1, -1, FALSE,
    IMG_GROUP_17
  },
  {
    EL_GROUP_18,			-1, -1, FALSE,
    IMG_GROUP_18
  },
  {
    EL_GROUP_19,			-1, -1, FALSE,
    IMG_GROUP_19
  },
  {
    EL_GROUP_20,			-1, -1, FALSE,
    IMG_GROUP_20
  },
  {
    EL_GROUP_21,			-1, -1, FALSE,
    IMG_GROUP_21
  },
  {
    EL_GROUP_22,			-1, -1, FALSE,
    IMG_GROUP_22
  },
  {
    EL_GROUP_23,			-1, -1, FALSE,
    IMG_GROUP_23
  },
  {
    EL_GROUP_24,			-1, -1, FALSE,
    IMG_GROUP_24
  },
  {
    EL_GROUP_25,			-1, -1, FALSE,
    IMG_GROUP_25
  },
  {
    EL_GROUP_26,			-1, -1, FALSE,
    IMG_GROUP_26
  },
  {
    EL_GROUP_27,			-1, -1, FALSE,
    IMG_GROUP_27
  },
  {
    EL_GROUP_28,			-1, -1, FALSE,
    IMG_GROUP_28
  },
  {
    EL_GROUP_29,			-1, -1, FALSE,
    IMG_GROUP_29
  },
  {
    EL_GROUP_30,			-1, -1, FALSE,
    IMG_GROUP_30
  },
  {
    EL_GROUP_31,			-1, -1, FALSE,
    IMG_GROUP_31
  },
  {
    EL_GROUP_32,			-1, -1, FALSE,
    IMG_GROUP_32
  },
*/
	{
		-1,					-1, -1,// FALSE,
		-1
	}
};

const struct
{
	short int element;
	short int graphic;
}
element_1_graphic[] =
{
  {
    EL_BD_MAGIC_WALL_ACTIVE,
    IMG_BD_MAGIC_WALL_ACTIVE
  },
  {
    EL_BD_MAGIC_WALL_FILLING,
    IMG_BD_MAGIC_WALL_FILLING
  },
  {
    EL_BD_MAGIC_WALL_FULL,
    IMG_BD_MAGIC_WALL_FULL
  },
  {
    EL_BD_MAGIC_WALL_EMPTYING,
    IMG_BD_MAGIC_WALL_EMPTYING
  },
  {
    EL_BD_MAGIC_WALL_DEAD,
    IMG_BD_MAGIC_WALL_DEAD
  },
  {
    EL_BD_AMOEBA,
    IMG_BD_AMOEBA
  },
  {
    EL_BD_BUTTERFLY,
    IMG_BD_BUTTERFLY
  },
  {
    EL_BD_FIREFLY,
    IMG_BD_FIREFLY
  },
  {
    EL_SP_MURPHY_CLONE,
    IMG_SP_MURPHY_CLONE
  },
  {
    EL_SP_TERMINAL_ACTIVE,
    IMG_SP_TERMINAL_ACTIVE
  },
  {
    EL_SP_CHIP_SINGLE,
    IMG_SP_CHIP_SINGLE
  },
  {
    EL_SP_CHIP_LEFT,
    IMG_SP_CHIP_LEFT
  },
  {
    EL_SP_CHIP_RIGHT,
    IMG_SP_CHIP_RIGHT
  },
  {
    EL_SP_CHIP_TOP,
    IMG_SP_CHIP_TOP
  },
  {
    EL_SP_CHIP_BOTTOM,
    IMG_SP_CHIP_BOTTOM
  },
  {
    EL_SP_HARDWARE_GRAY,
    IMG_SP_HARDWARE_GRAY
  },
  {
    EL_SP_HARDWARE_GREEN,
    IMG_SP_HARDWARE_GREEN
  },
  {
    EL_SP_HARDWARE_BLUE,
    IMG_SP_HARDWARE_BLUE
  },
  {
    EL_SP_HARDWARE_RED,
    IMG_SP_HARDWARE_RED
  },
  {
    EL_SP_HARDWARE_YELLOW,
    IMG_SP_HARDWARE_YELLOW
  },
  {
    EL_SP_EXIT_CLOSED,
    IMG_SP_EXIT_CLOSED
  },
  {
    EL_SP_EXIT_OPENING,
    IMG_SP_EXIT_OPENING
  },
  {
    EL_SP_EXIT_OPEN,
    IMG_SP_EXIT_OPEN
  },
  {
    EL_SP_EXIT_CLOSING,
    IMG_SP_EXIT_CLOSING
  },
  {
    EL_SP_DISK_ORANGE,
    IMG_SP_DISK_ORANGE
  },
  {
    EL_SP_DISK_YELLOW,
    IMG_SP_DISK_YELLOW
  },
  {
    EL_SP_DISK_RED,
    IMG_SP_DISK_RED
  },
  {
    EL_SP_PORT_RIGHT,
    IMG_SP_PORT_RIGHT
  },
  {
    EL_SP_PORT_DOWN,
    IMG_SP_PORT_DOWN
  },
  {
    EL_SP_PORT_LEFT,
    IMG_SP_PORT_LEFT
  },
  {
    EL_SP_PORT_UP,
    IMG_SP_PORT_UP
  },
  {
    EL_SP_PORT_HORIZONTAL,
    IMG_SP_PORT_HORIZONTAL
  },
  {
    EL_SP_PORT_VERTICAL,
    IMG_SP_PORT_VERTICAL
  },
  {
    EL_SP_PORT_ANY,
    IMG_SP_PORT_ANY
  },
  {
    EL_SP_GRAVITY_PORT_RIGHT,
    IMG_SP_GRAVITY_PORT_RIGHT
  },
  {
    EL_SP_GRAVITY_PORT_DOWN,
    IMG_SP_GRAVITY_PORT_DOWN
  },
  {
    EL_SP_GRAVITY_PORT_LEFT,
    IMG_SP_GRAVITY_PORT_LEFT
  },
  {
    EL_SP_GRAVITY_PORT_UP,
    IMG_SP_GRAVITY_PORT_UP
  },
  {
    EL_SP_GRAVITY_ON_PORT_RIGHT,
    IMG_SP_GRAVITY_ON_PORT_RIGHT
  },
  {
    EL_SP_GRAVITY_ON_PORT_DOWN,
    IMG_SP_GRAVITY_ON_PORT_DOWN
  },
  {
    EL_SP_GRAVITY_ON_PORT_LEFT,
    IMG_SP_GRAVITY_ON_PORT_LEFT
  },
  {
    EL_SP_GRAVITY_ON_PORT_UP,
    IMG_SP_GRAVITY_ON_PORT_UP
  },
  {
    EL_SP_GRAVITY_OFF_PORT_RIGHT,
    IMG_SP_GRAVITY_OFF_PORT_RIGHT
  },
  {
    EL_SP_GRAVITY_OFF_PORT_DOWN,
    IMG_SP_GRAVITY_OFF_PORT_DOWN
  },
  {
    EL_SP_GRAVITY_OFF_PORT_LEFT,
    IMG_SP_GRAVITY_OFF_PORT_LEFT
  },
  {
    EL_SP_GRAVITY_OFF_PORT_UP,
    IMG_SP_GRAVITY_OFF_PORT_UP
  },
  {
    EL_SP_HARDWARE_BASE_1,
    IMG_SP_HARDWARE_BASE_1
  },
  {
    EL_SP_HARDWARE_BASE_2,
    IMG_SP_HARDWARE_BASE_2
  },
  {
    EL_SP_HARDWARE_BASE_3,
    IMG_SP_HARDWARE_BASE_3
  },
  {
    EL_SP_HARDWARE_BASE_4,
    IMG_SP_HARDWARE_BASE_4
  },
  {
    EL_SP_HARDWARE_BASE_5,
    IMG_SP_HARDWARE_BASE_5
  },
  {
    EL_SP_HARDWARE_BASE_6,
    IMG_SP_HARDWARE_BASE_6
  },
  {
    EL_SOKOBAN_OBJECT,
    IMG_SOKOBAN_OBJECT
  },
  {
    EL_SOKOBAN_FIELD_EMPTY,
    IMG_SOKOBAN_FIELD_EMPTY
  },
  {
    EL_SOKOBAN_FIELD_FULL,
    IMG_SOKOBAN_FIELD_FULL
  },
  {
    EL_SOKOBAN_FIELD_PLAYER,
    IMG_SOKOBAN_FIELD_PLAYER
  },
  {
    EL_EMPTY_SPACE,
    IMG_EMPTY_SPACE
  },
  {
    EL_WALL,
    IMG_WALL
  },
  {
    EL_WALL_SLIPPERY,
    IMG_WALL_SLIPPERY
  },
  {
    EL_STEELWALL,
    IMG_STEELWALL
  },
  {
    EL_WALL_EMERALD,
    IMG_WALL_EMERALD
  },
  {
    EL_WALL_DIAMOND,
    IMG_WALL_DIAMOND
  },
  {
    EL_BUG_RIGHT,
    IMG_BUG_RIGHT
  },
  {
    EL_BUG_UP,
    IMG_BUG_UP
  },
  {
    EL_BUG_LEFT,
    IMG_BUG_LEFT
  },
  {
    EL_BUG_DOWN,
    IMG_BUG_DOWN
  },
  {
    EL_SPACESHIP_RIGHT,
    IMG_SPACESHIP_RIGHT
  },
  {
    EL_SPACESHIP_UP,
    IMG_SPACESHIP_UP
  },
  {
    EL_SPACESHIP_LEFT,
    IMG_SPACESHIP_LEFT
  },
  {
    EL_SPACESHIP_DOWN,
    IMG_SPACESHIP_DOWN
  },
  {
    EL_QUICKSAND_EMPTY,
    IMG_QUICKSAND_EMPTY
  },
  {
    EL_QUICKSAND_FILLING,
    IMG_QUICKSAND_FILLING
  },
  {
    EL_QUICKSAND_FULL,
    IMG_QUICKSAND_FULL
  },
  {
    EL_QUICKSAND_EMPTYING,
    IMG_QUICKSAND_EMPTYING
  },
  {
    EL_ACID_POOL_TOPLEFT,
    IMG_ACID_POOL_TOPLEFT
  },
  {
    EL_ACID_POOL_TOPRIGHT,
    IMG_ACID_POOL_TOPRIGHT
  },
  {
    EL_ACID_POOL_BOTTOMLEFT,
    IMG_ACID_POOL_BOTTOMLEFT
  },
  {
    EL_ACID_POOL_BOTTOM,
    IMG_ACID_POOL_BOTTOM
  },
  {
    EL_ACID_POOL_BOTTOMRIGHT,
    IMG_ACID_POOL_BOTTOMRIGHT
  },
  {
    EL_ACID,
    IMG_ACID
  },
  {
    EL_ACID_SPLASH_LEFT,
    IMG_ACID_SPLASH_LEFT
  },
  {
    EL_ACID_SPLASH_RIGHT,
    IMG_ACID_SPLASH_RIGHT
  },
  {
    EL_AMOEBA_DROP,
    IMG_AMOEBA_DROP
  },
  {
    EL_AMOEBA_DRY,
    IMG_AMOEBA_DRY
  },
  {
    EL_AMOEBA_FULL,
    IMG_AMOEBA_FULL
  },
  {
    EL_AMOEBA_DEAD,
    IMG_AMOEBA_DEAD
  },
  {
    EL_EM_KEY_1,
    IMG_EM_KEY_1
  },
  {
    EL_EM_KEY_2,
    IMG_EM_KEY_2
  },
  {
    EL_EM_KEY_3,
    IMG_EM_KEY_3
  },
  {
    EL_EM_KEY_4,
    IMG_EM_KEY_4
  },
  {
    EL_EM_GATE_1,
    IMG_EM_GATE_1
  },
  {
    EL_EM_GATE_2,
    IMG_EM_GATE_2
  },
  {
    EL_EM_GATE_3,
    IMG_EM_GATE_3
  },
  {
    EL_EM_GATE_4,
    IMG_EM_GATE_4
  },
  {
    EL_EM_GATE_1_GRAY,
    IMG_EM_GATE_1_GRAY
  },
  {
    EL_EM_GATE_2_GRAY,
    IMG_EM_GATE_2_GRAY
  },
  {
    EL_EM_GATE_3_GRAY,
    IMG_EM_GATE_3_GRAY
  },
  {
    EL_EM_GATE_4_GRAY,
    IMG_EM_GATE_4_GRAY
  },
  {
    EL_EXIT_CLOSED,
    IMG_EXIT_CLOSED
  },
  {
    EL_EXIT_OPENING,
    IMG_EXIT_OPENING
  },
  {
    EL_EXIT_OPEN,
    IMG_EXIT_OPEN
  },
  {
    EL_EXIT_CLOSING,
    IMG_EXIT_CLOSING
  },
  {
    EL_SPRING,
    IMG_SPRING
  },
  {
    EL_EMC_STEELWALL_1,
    IMG_EMC_STEELWALL_1
  },
  {
    EL_EMC_STEELWALL_2,
    IMG_EMC_STEELWALL_2
  },
  {
    EL_EMC_STEELWALL_3,
    IMG_EMC_STEELWALL_3
  },
  {
    EL_EMC_STEELWALL_4,
    IMG_EMC_STEELWALL_4
  },
  {
    EL_EMC_WALL_1,
    IMG_EMC_WALL_1
  },
  {
    EL_EMC_WALL_2,
    IMG_EMC_WALL_2
  },
  {
    EL_EMC_WALL_3,
    IMG_EMC_WALL_3
  },
  {
    EL_EMC_WALL_4,
    IMG_EMC_WALL_4
  },
  {
    EL_EMC_WALL_5,
    IMG_EMC_WALL_5
  },
  {
    EL_EMC_WALL_6,
    IMG_EMC_WALL_6
  },
  {
    EL_EMC_WALL_7,
    IMG_EMC_WALL_7
  },
  {
    EL_EMC_WALL_8,
    IMG_EMC_WALL_8
  },
  {
    EL_INVISIBLE_STEELWALL,
    IMG_INVISIBLE_STEELWALL
  },
  {
    EL_INVISIBLE_WALL,
    IMG_INVISIBLE_WALL
  },
  {
    EL_INVISIBLE_SAND,
    IMG_INVISIBLE_SAND
  },
  {
    EL_SIGN_EXCLAMATION,
    IMG_SIGN_EXCLAMATION
  },
  {
    EL_SIGN_STOP,
    IMG_SIGN_STOP
  },
  {
    EL_LANDMINE,
    IMG_LANDMINE
  },
  {
    EL_STEELWALL_SLIPPERY,
    IMG_STEELWALL_SLIPPERY
  },
  {
    EL_EXTRA_TIME,
    IMG_EXTRA_TIME
  },
  {
    EL_SWITCHGATE_CLOSED,
    IMG_SWITCHGATE_CLOSED
  },
  {
    EL_SWITCHGATE_OPENING,
    IMG_SWITCHGATE_OPENING
  },
  {
    EL_SWITCHGATE_OPEN,
    IMG_SWITCHGATE_OPEN
  },
  {
    EL_SWITCHGATE_CLOSING,
    IMG_SWITCHGATE_CLOSING
  },
  {
    EL_TIMEGATE_CLOSED,
    IMG_TIMEGATE_CLOSED
  },
  {
    EL_TIMEGATE_OPENING,
    IMG_TIMEGATE_OPENING
  },
  {
    EL_TIMEGATE_OPEN,
    IMG_TIMEGATE_OPEN
  },
  {
    EL_TIMEGATE_CLOSING,
    IMG_TIMEGATE_CLOSING
  },
  {
    EL_CRYSTAL,
    IMG_CRYSTAL
  },
  {
    EL_WALL_PEARL,
    IMG_WALL_PEARL
  },
  {
    EL_WALL_CRYSTAL,
    IMG_WALL_CRYSTAL
  },
  {
    EL_TUBE_RIGHT_DOWN,
    IMG_TUBE_RIGHT_DOWN
  },
  {
    EL_TUBE_HORIZONTAL_DOWN,
    IMG_TUBE_HORIZONTAL_DOWN
  },
  {
    EL_TUBE_LEFT_DOWN,
    IMG_TUBE_LEFT_DOWN
  },
  {
    EL_TUBE_HORIZONTAL,
    IMG_TUBE_HORIZONTAL
  },
  {
    EL_TUBE_VERTICAL_RIGHT,
    IMG_TUBE_VERTICAL_RIGHT
  },
  {
    EL_TUBE_ANY,
    IMG_TUBE_ANY
  },
  {
    EL_TUBE_VERTICAL_LEFT,
    IMG_TUBE_VERTICAL_LEFT
  },
  {
    EL_TUBE_VERTICAL,
    IMG_TUBE_VERTICAL
  },
  {
    EL_TUBE_RIGHT_UP,
    IMG_TUBE_RIGHT_UP
  },
  {
    EL_TUBE_HORIZONTAL_UP,
    IMG_TUBE_HORIZONTAL_UP
  },
  {
    EL_TUBE_LEFT_UP,
    IMG_TUBE_LEFT_UP
  },
  {
    EL_DX_SUPABOMB,
    IMG_DX_SUPABOMB
  },
  {
    EL_KEY_1,
    IMG_KEY_1
  },
  {
    EL_KEY_2,
    IMG_KEY_2
  },
  {
    EL_KEY_3,
    IMG_KEY_3
  },
  {
    EL_KEY_4,
    IMG_KEY_4
  },
  {
    EL_GATE_1,
    IMG_GATE_1
  },
  {
    EL_GATE_2,
    IMG_GATE_2
  },
  {
    EL_GATE_3,
    IMG_GATE_3
  },
  {
    EL_GATE_4,
    IMG_GATE_4
  },
  {
    EL_GATE_1_GRAY,
    IMG_GATE_1_GRAY
  },
  {
    EL_GATE_2_GRAY,
    IMG_GATE_2_GRAY
  },
  {
    EL_GATE_3_GRAY,
    IMG_GATE_3_GRAY
  },
  {
    EL_GATE_4_GRAY,
    IMG_GATE_4_GRAY
  },
  {
    EL_GAME_OF_LIFE,
    IMG_GAME_OF_LIFE
  },
  {
    EL_BIOMAZE,
    IMG_BIOMAZE
  },
  {
    EL_PACMAN_RIGHT,
    IMG_PACMAN_RIGHT
  },
  {
    EL_PACMAN_UP,
    IMG_PACMAN_UP
  },
  {
    EL_PACMAN_LEFT,
    IMG_PACMAN_LEFT
  },
  {
    EL_PACMAN_DOWN,
    IMG_PACMAN_DOWN
  },
  {
    EL_TIME_ORB_FULL,
    IMG_TIME_ORB_FULL
  },
  {
    EL_TIME_ORB_EMPTY,
    IMG_TIME_ORB_EMPTY
  },
  {
    EL_WALL_EMERALD_YELLOW,
    IMG_WALL_EMERALD_YELLOW
  },
  {
    EL_WALL_EMERALD_RED,
    IMG_WALL_EMERALD_RED
  },
  {
    EL_WALL_EMERALD_PURPLE,
    IMG_WALL_EMERALD_PURPLE
  },
  {
    EL_WALL_BD_DIAMOND,
    IMG_WALL_BD_DIAMOND
  },
  {
    EL_BLACK_ORB,
    IMG_BLACK_ORB
  },
  {
    EL_SPEED_PILL,
    IMG_SPEED_PILL
  },
  {
    EL_MOLE_DOWN,
    IMG_MOLE_DOWN
  },
  {
    EL_MOLE_UP,
    IMG_MOLE_UP
  },
  {
    EL_MOLE_LEFT,
    IMG_MOLE_LEFT
  },
  {
    EL_MOLE_RIGHT,
    IMG_MOLE_RIGHT
  },
  {
    EL_SATELLITE,
    IMG_SATELLITE
  },
  {
    EL_STONEBLOCK,
    IMG_STONEBLOCK
  },
  {
    EL_STEELWALL_TOPLEFT,
    IMG_STEELWALL_TOPLEFT
  },
  {
    EL_STEELWALL_TOPRIGHT,
    IMG_STEELWALL_TOPRIGHT
  },
  {
    EL_STEELWALL_BOTTOMLEFT,
    IMG_STEELWALL_BOTTOMLEFT
  },
  {
    EL_STEELWALL_BOTTOMRIGHT,
    IMG_STEELWALL_BOTTOMRIGHT
  },
  {
    EL_STEELWALL_HORIZONTAL,
    IMG_STEELWALL_HORIZONTAL
  },
  {
    EL_STEELWALL_VERTICAL,
    IMG_STEELWALL_VERTICAL
  },
  {
    EL_INVISIBLE_STEELWALL_TOPLEFT,
    IMG_INVISIBLE_STEELWALL_TOPLEFT
  },
  {
    EL_INVISIBLE_STEELWALL_TOPRIGHT,
    IMG_INVISIBLE_STEELWALL_TOPRIGHT
  },
  {
    EL_INVISIBLE_STEELWALL_BOTTOMLEFT,
    IMG_INVISIBLE_STEELWALL_BOTTOMLEFT
  },
  {
    EL_INVISIBLE_STEELWALL_BOTTOMRIGHT,
    IMG_INVISIBLE_STEELWALL_BOTTOMRIGHT
  },
  {
    EL_INVISIBLE_STEELWALL_HORIZONTAL,
    IMG_INVISIBLE_STEELWALL_HORIZONTAL
  },
  {
    EL_INVISIBLE_STEELWALL_VERTICAL,
    IMG_INVISIBLE_STEELWALL_VERTICAL
  },
  {
    EL_ARROW_LEFT,
    IMG_ARROW_LEFT
  },
  {
    EL_ARROW_RIGHT,
    IMG_ARROW_RIGHT
  },
  {
    EL_ARROW_UP,
    IMG_ARROW_UP
  },
  {
    EL_ARROW_DOWN,
    IMG_ARROW_DOWN
  },
  {
    EL_UNKNOWN,
    IMG_UNKNOWN
  },
  {
    EL_TRIGGER_ELEMENT,
    IMG_TRIGGER_ELEMENT
  },
  {
    EL_TRIGGER_PLAYER,
    IMG_TRIGGER_PLAYER
  },
  {
    EL_BD_BUTTERFLY_DOWN,
    IMG_BD_BUTTERFLY
  },
  {
    EL_BD_BUTTERFLY_LEFT,
    IMG_BD_BUTTERFLY
  },
  {
    EL_BD_BUTTERFLY_RIGHT,
    IMG_BD_BUTTERFLY
  },
  {
    EL_BD_BUTTERFLY_UP,
    IMG_BD_BUTTERFLY
  },
  {
    EL_BD_FIREFLY_DOWN,
    IMG_BD_FIREFLY
  },
  {
    EL_BD_FIREFLY_LEFT,
    IMG_BD_FIREFLY
  },
  {
    EL_BD_FIREFLY_RIGHT,
    IMG_BD_FIREFLY
  },
  {
    EL_BD_FIREFLY_UP,
    IMG_BD_FIREFLY
  },
  {
    EL_DOOR_WHITE,
    IMG_CHAR_QUESTION
  },
  {
    EL_DOOR_WHITE_GRAY,
    IMG_CHAR_QUESTION
  },
  {
    EL_DX_UNKNOWN_15,
    IMG_CHAR_QUESTION
  },
  {
    EL_DX_UNKNOWN_42,
    IMG_CHAR_QUESTION
  },
  {
    EL_KEY_WHITE,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_EXIT,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_HEART,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_ONEWAY,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_OTHER,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_PARKING,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_RADIOACTIVITY,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_ROUND,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_TRIANGLE,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_WHEELCHAIR,
    IMG_CHAR_QUESTION
  },
  {
    EL_SIGN_YINYANG,
    IMG_CHAR_QUESTION
  },
  {
    EL_CHAR_SPACE,
    IMG_CHAR_SPACE
  },
  {
    EL_CHAR_EXCLAM,
    IMG_CHAR_EXCLAM
  },
  {
    EL_CHAR_QUOTEDBL,
    IMG_CHAR_QUOTEDBL
  },
  {
    EL_CHAR_NUMBERSIGN,
    IMG_CHAR_NUMBERSIGN
  },
  {
    EL_CHAR_DOLLAR,
    IMG_CHAR_DOLLAR
  },
  {
    EL_CHAR_PROCENT,
    IMG_CHAR_PROCENT
  },
  {
    EL_CHAR_AMPERSAND,
    IMG_CHAR_AMPERSAND
  },
  {
    EL_CHAR_APOSTROPHE,
    IMG_CHAR_APOSTROPHE
  },
  {
    EL_CHAR_PARENLEFT,
    IMG_CHAR_PARENLEFT
  },
  {
    EL_CHAR_PARENRIGHT,
    IMG_CHAR_PARENRIGHT
  },
  {
    EL_CHAR_ASTERISK,
    IMG_CHAR_ASTERISK
  },
  {
    EL_CHAR_PLUS,
    IMG_CHAR_PLUS
  },
  {
    EL_CHAR_COMMA,
    IMG_CHAR_COMMA
  },
  {
    EL_CHAR_MINUS,
    IMG_CHAR_MINUS
  },
  {
    EL_CHAR_PERIOD,
    IMG_CHAR_PERIOD
  },
  {
    EL_CHAR_SLASH,
    IMG_CHAR_SLASH
  },
  {
    EL_CHAR_0,
    IMG_CHAR_0
  },
  {
    EL_CHAR_1,
    IMG_CHAR_1
  },
  {
    EL_CHAR_2,
    IMG_CHAR_2
  },
  {
    EL_CHAR_3,
    IMG_CHAR_3
  },
  {
    EL_CHAR_4,
    IMG_CHAR_4
  },
  {
    EL_CHAR_5,
    IMG_CHAR_5
  },
  {
    EL_CHAR_6,
    IMG_CHAR_6
  },
  {
    EL_CHAR_7,
    IMG_CHAR_7
  },
  {
    EL_CHAR_8,
    IMG_CHAR_8
  },
  {
    EL_CHAR_9,
    IMG_CHAR_9
  },
  {
    EL_CHAR_COLON,
    IMG_CHAR_COLON
  },
  {
    EL_CHAR_SEMICOLON,
    IMG_CHAR_SEMICOLON
  },
  {
    EL_CHAR_LESS,
    IMG_CHAR_LESS
  },
  {
    EL_CHAR_EQUAL,
    IMG_CHAR_EQUAL
  },
  {
    EL_CHAR_GREATER,
    IMG_CHAR_GREATER
  },
  {
    EL_CHAR_QUESTION,
    IMG_CHAR_QUESTION
  },
  {
    EL_CHAR_AT,
    IMG_CHAR_AT
  },
  {
    EL_CHAR_A,
    IMG_CHAR_A
  },
  {
    EL_CHAR_B,
    IMG_CHAR_B
  },
  {
    EL_CHAR_C,
    IMG_CHAR_C
  },
  {
    EL_CHAR_D,
    IMG_CHAR_D
  },
  {
    EL_CHAR_E,
    IMG_CHAR_E
  },
  {
    EL_CHAR_F,
    IMG_CHAR_F
  },
  {
    EL_CHAR_G,
    IMG_CHAR_G
  },
  {
    EL_CHAR_H,
    IMG_CHAR_H
  },
  {
    EL_CHAR_I,
    IMG_CHAR_I
  },
  {
    EL_CHAR_J,
    IMG_CHAR_J
  },
  {
    EL_CHAR_K,
    IMG_CHAR_K
  },
  {
    EL_CHAR_L,
    IMG_CHAR_L
  },
  {
    EL_CHAR_M,
    IMG_CHAR_M
  },
  {
    EL_CHAR_N,
    IMG_CHAR_N
  },
  {
    EL_CHAR_O,
    IMG_CHAR_O
  },
  {
    EL_CHAR_P,
    IMG_CHAR_P
  },
  {
    EL_CHAR_Q,
    IMG_CHAR_Q
  },
  {
    EL_CHAR_R,
    IMG_CHAR_R
  },
  {
    EL_CHAR_S,
    IMG_CHAR_S
  },
  {
    EL_CHAR_T,
    IMG_CHAR_T
  },
  {
    EL_CHAR_U,
    IMG_CHAR_U
  },
  {
    EL_CHAR_V,
    IMG_CHAR_V
  },
  {
    EL_CHAR_W,
    IMG_CHAR_W
  },
  {
    EL_CHAR_X,
    IMG_CHAR_X
  },
  {
    EL_CHAR_Y,
    IMG_CHAR_Y
  },
  {
    EL_CHAR_Z,
    IMG_CHAR_Z
  },
  {
    EL_CHAR_BRACKETLEFT,
    IMG_CHAR_BRACKETLEFT
  },
  {
    EL_CHAR_BACKSLASH,
    IMG_CHAR_BACKSLASH
  },
  {
    EL_CHAR_BRACKETRIGHT,
    IMG_CHAR_BRACKETRIGHT
  },
  {
    EL_CHAR_ASCIICIRCUM,
    IMG_CHAR_ASCIICIRCUM
  },
  {
    EL_CHAR_UNDERSCORE,
    IMG_CHAR_UNDERSCORE
  },
  {
    EL_CHAR_COPYRIGHT,
    IMG_CHAR_COPYRIGHT
  },
  {
    EL_CHAR_AUMLAUT,
    IMG_CHAR_AUMLAUT
  },
  {
    EL_CHAR_OUMLAUT,
    IMG_CHAR_OUMLAUT
  },
  {
    EL_CHAR_UUMLAUT,
    IMG_CHAR_UUMLAUT
  },
  {
    EL_CHAR_DEGREE,
    IMG_CHAR_DEGREE
  },
  {
    EL_CHAR_TRADEMARK,
    IMG_CHAR_TRADEMARK
  },
  {
    EL_CHAR_CURSOR,
    IMG_CHAR_CURSOR
  },
  {
    -1,
    -1
  }
};