#ifndef INIT_H_INCLUDED
#define INIT_H_INCLUDED

#include "main_.h" 
#include "code_sections.h"

void InitMainDoLoop(void) INIT_SECTION;

#define setMoveIntoAcidProperty(l, e, v)	\
	(setBitfieldProperty(&(l)->can_move_into_acid_bits,	\
			     EP_CAN_MOVE_INTO_ACID, e, v))
#define getMoveIntoAcidProperty(l, e)		\
	(getBitfieldProperty(&(l)->can_move_into_acid_bits,	\
			     EP_CAN_MOVE_INTO_ACID, e))
#define setDontCollideWithProperty(l, e, v)	\
	(setBitfieldProperty(&(l)->dont_collide_with_bits,	\
			     EP_DONT_COLLIDE_WITH, e, v))

#define getDontCollideWithProperty(l, e)	\
	(getBitfieldProperty(&(l)->dont_collide_with_bits,	\
			     EP_DONT_COLLIDE_WITH, e))

void setBitfieldProperty(long *, int, int, boolean) INIT_SECTION;
boolean getBitfieldProperty(long *, int, int) INIT_SECTION;

void InitElementPropertiesStatic(void) INIT_SECTION;
void InitElementPropertiesEngine(long) INIT_SECTION;//was int and now long for palm

void OpenAll(void);
void CloseAll(void);
#endif
