#ifndef LIBGAMEMISC_H_INCLUDED
#define LIBGAMEMISC_H_INCLUDED

#include "libgamesystem.h"

/* values for InitCounter() and Counter() */
#define INIT_COUNTER			0
#define READ_COUNTER			1 

/* values for InitRND() */
#define NEW_RANDOMIZE			-1

#define MAX_LINE_LEN			1024

#define InitRND(seed)			init_random_number(0, seed) 
#define InitSimpleRND(seed)		init_random_number(1, seed)
#define RND(max)				get_random_number(0, max)
#define SimpleRND(max)			get_random_number(1, max)

void InitCounter(void);

void DelayX10(unsigned long);
boolean FrameReached(unsigned long *, unsigned long);
 
unsigned long init_random_number(int, long); //was int
unsigned long get_random_number(int, long);//was int

#endif
